/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <dirent.h>
#include <errno.h>
#include <gdk/gdkx.h>
#include <id3.h>
#include <glib.h>
#include "charset.h"
#include "vcedit.h"

#define ID3V2_MAX_STRING_LEN 4096
int isogg(char *);
int ismp3(char *);
int ffill_list(char *di);
int afill_list(char *di);
GtkWidget* create_awindow2 (char *);
int dfill_list(char *di);


void mtitle(char *f,GtkWidget *widget);

char *sel1=NULL;
char *sel2=NULL;
int sel_num1,sel_num2=-1;
char *fsel1=NULL;
char *fsel2=NULL;
int fsel_num1,fsel_num2=0;
int dsel=-1;

GtkWidget *af,*ae,*aclist1,*aclist2,*al,*fl,*fclist1,*fclist2,*fe,*de,*dl,*dclist1=NULL;
char *sdir=NULL;
char *fdir=NULL;
char *adata=NULL;
char *fdata=NULL;
char *ddir=NULL;
char *ddata=NULL;

void
on_afixed2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_aclist1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2];
char *dt;
GtkTargetEntry target[1];
struct dirent *dent;
int num;
GdkPixmap *pm=NULL;
GdkWindow *pwindow;

target[0].target="text/plain";
target[0].flags=GTK_TARGET_SAME_APP;
target[0].info=0;

sel_num1=0;
aclist1=widget;
gtk_clist_set_column_auto_resize ((GtkCList*)widget,0,1);


gtk_drag_source_set(aclist1,GDK_BUTTON1_MASK,target,1,GDK_ACTION_COPY|GDK_ACTION_MOVE);

pwindow = (GdkWindow *)GDK_ROOT_PARENT();

gtk_clist_set_use_drag_icons ((GtkCList*)aclist1,1);
pm=gdk_pixmap_create_from_xpm ((GdkWindow*)pwindow,NULL,NULL,"/usr/share/icons/sonic-rainbow_drag.xpm");
if(pm!=NULL)
gtk_drag_set_default_icon(gdk_colormap_get_system(),pm,NULL,1,1);


dir1_handle=opendir(sdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)return;
}
while(1)
{
dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type==DT_DIR || dent->d_type==DT_LNK)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(sdir)+strlen(dent->d_name)+2);
strcpy(dt,sdir);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
sel_num1++;
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
sel_num1++;
}
}

}

sel1=(char*)malloc(sel_num1);
for(num=0;num<sel_num1;num++)
sel1[num]=0;

closedir(dir1_handle);

gtk_clist_set_auto_sort ((GtkCList*)aclist1,1);
}


void
on_aclist2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
int num;
DIR *dir1_handle,*t_dir=NULL;
char *t[2],*dt;
struct dirent *dent;
GtkTargetEntry target[1];
GdkPixmap *pm=NULL;
GdkWindow *pwindow;

target[0].target="text/plain";
target[0].flags=GTK_TARGET_SAME_APP;
target[0].info=0;

pwindow = (GdkWindow *)GDK_ROOT_PARENT();

aclist2=widget;
sel_num2=0;

gtk_clist_set_column_auto_resize ((GtkCList*)widget,0,1);

gtk_drag_source_set(aclist2,GDK_BUTTON1_MASK,target,1,GDK_ACTION_COPY|GDK_ACTION_MOVE);
gtk_clist_set_use_drag_icons ((GtkCList*)aclist2,1);
pm=gdk_pixmap_create_from_xpm ((GdkWindow*)pwindow,NULL,NULL,"/usr/share/icons/sonic-rainbow_drag.xpm");
if(pm!=NULL)
gtk_drag_set_default_icon(gdk_colormap_get_system(),pm,NULL,1,1);


dir1_handle=opendir(sdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)
return;
}
while(1)
{
dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(sdir)+strlen(dent->d_name)+2);
strcpy(dt,sdir);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir==NULL)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
sel_num2++;
}
else
closedir(t_dir);
t_dir=NULL;
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
sel_num2++;
}
}
}
sel2=(char*)malloc(sel_num2);
for(num=0;num<sel_num2;num++)
sel2[num]=0;
gtk_clist_set_auto_sort ((GtkCList*)aclist2,1);
closedir(dir1_handle);
}


void
on_aentry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)widget,sdir);
ae=widget;
}




void
on_abutton3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
GtkCList *cl=NULL;
GList *glist=NULL;
gint row=0;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num=0;
int first=0;
int one=0;


cl=GTK_CLIST(aclist1);
glist = cl->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;

if(row!=-1)
{
one=1;
en=gtk_entry_get_text((GtkEntry*)ae);
for(num=0;num<sel_num1;num++)
{
  if(sel1[num])
  {
   gtk_clist_get_text((GtkCList*)aclist1,num,0,&p);
   if(first==0)
   {
   d=(char *)malloc(strlen(p)+2+strlen(en)+1);
    strcpy(d,en);
    strcat(d,p);
    strcat(d,"\n");
    first=1;
   }
   else
   {
   d=realloc(d,strlen(p)+2+strlen(d)+1+strlen(en)+1);
   strcat(d,en);
   strcat(d,p);
   strcat(d,"\n");
  }
 }
}
}

row=0;
cl=NULL;
glist=NULL;

cl=GTK_CLIST(aclist2);
glist = cl->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
en=NULL;

if(row!=-1)
{
one=1;
en=gtk_entry_get_text((GtkEntry*)ae);
for(num=0;num<sel_num2;num++)
{
  if(sel2[num])
  {
   gtk_clist_get_text((GtkCList*)aclist2,num,0,&p);
   if(first==0)
   {
    d=(char *)malloc(strlen(p)+2+strlen(en)+2);
    strcpy(d,en);
    strcat(d,p);
    strcat(d,"\n");
    first=1;
   }
   else
   {
   d=realloc(d,strlen(p)+2+strlen(d)+1+strlen(en)+2);
   strcat(d,en);
   strcat(d,p);
   strcat(d,"\n");
   }
  }
}
}

if(one==0)
{
d=(char*)malloc(strlen(gtk_entry_get_text((GtkEntry*)ae))+3);
sprintf(d,"%s\n",gtk_entry_get_text((GtkEntry*)ae));
}

if(sel_num1)free(sel1);
if(sel_num2)free(sel2);
adata=d;
gtk_main_quit();
}



void
on_aclist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *t,*p;
char *cwd,*nwd;
int b;


if(event->button.type==GDK_2BUTTON_PRESS)
{
cwd=(char *)malloc(10001);
nwd=(char *)malloc(10001);
getcwd(cwd,10000);
gtk_clist_get_text((GtkCList *)clist,row,column,&p);
t=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)ae))+ strlen(p)+2);
strcpy(t,gtk_entry_get_text((GtkEntry*)ae));
strcat(t,p);
strcat(t,"/");
chdir(t);
getcwd(nwd,10000);
if(strlen(nwd)>2 && nwd[strlen(nwd)-1]!='/')
strcat(nwd,"/");
b=afill_list(t);
if(b)gtk_entry_set_text((GtkEntry*)ae,nwd);
chdir(cwd);
free(cwd);
free(nwd);
free(t);
}
else
sel1[row]=1;
}


int afill_list(char *di)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2];
char *dt;
int num;
struct dirent *dent=NULL;

if(sel1!=NULL)
free(sel1);
if(sel2!=NULL);
free(sel2);
sel1=NULL;
sel2=NULL;
sel_num1=0;
sel_num2=0;


dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)aclist1);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type==DT_DIR  || dent->d_type == DT_LNK)
{
if(dent->d_type == DT_LNK)
{
dt=(char*)malloc(strlen(di)+strlen(dent->d_name)+2);
strcpy(dt,di);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)aclist1,t);
sel_num1++;
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)aclist1,t);
sel_num1++;
}
}
}
closedir(dir1_handle);

sel1=(char*)malloc(sel_num1+1);
for(num=0;num<sel_num1;num++)
sel1[num]=0;


dir1_handle=NULL;
dent=NULL;

dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)aclist2);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
if(dent->d_type == DT_LNK)
{
dt=(char*)malloc(strlen(di)+strlen(dent->d_name)+2);
strcpy(dt,di);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir==NULL)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)aclist2,t);
sel_num2++;
}
else
closedir(t_dir);
t_dir=NULL;
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)aclist2,t);
sel_num2++;
}
}

}
closedir(dir1_handle);
if(sel_num2)
{
sel2=(char*)malloc(sel_num2+1);
for(num=0;num<sel_num2;num++)
sel2[num]=0;
}

return 1;
}


void
on_abutton4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
adata=NULL;
free(sel1);
free(sel2);
sel1=NULL;
sel2=NULL;
sel_num1=0;
sel_num2=0;
gtk_main_quit();
}



void
on_awindow2_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
al=widget;
adata=NULL;
}


void
on_aclist1_drag_data_get                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
GtkCList *cl=NULL;
GList *glist=NULL;
gint row;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num;
int first=0;


cl=GTK_CLIST(widget);
glist = cl->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
if(row==-1)
gtk_selection_data_set(data,GDK_SELECTION_TYPE_STRING,8,"&&&&\n",strlen("&&&&\n"));
else
{

en=gtk_entry_get_text((GtkEntry*)ae);

for(num=0;num<sel_num1;num++)
{
  if(sel1[num])
  {
   gtk_clist_get_text((GtkCList*)aclist1,num,0,&p);


   if(first==0)
   {
   d=(char *)malloc(strlen(p)+2+strlen(en)+1);
    strcpy(d,en);
    strcat(d,p);
    strcat(d,"\n");
    first=1;
   }
   else
   {
   d=realloc(d,strlen(p)+2+strlen(d)+1+strlen(en)+1);
   strcat(d,en);
   strcat(d,p);
   strcat(d,"\n");
  }
 }
}
gtk_selection_data_set(data,GDK_SELECTION_TYPE_STRING,8,d,strlen(d));
free(d);
}


}



void
on_aclist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
sel1[row]=0;
}



void
on_aclist2_drag_data_get                (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
GtkCList *cl=NULL;
GList *glist=NULL;
gint row;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num;
int first=0;


cl=GTK_CLIST(widget);
glist = cl->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
if(row==-1)
gtk_selection_data_set(data,GDK_SELECTION_TYPE_STRING,8,"&&&&\n",strlen("&&&&\n"));
else
{
en=gtk_entry_get_text((GtkEntry*)ae);
for(num=0;num<sel_num2;num++)
{
  if(sel2[num])
  {
   gtk_clist_get_text((GtkCList*)aclist2,num,0,&p);
   if(first==0)
   {
    d=(char *)malloc(strlen(p)+strlen(en)+4);
    strcpy(d,en);
    strcat(d,p);
    strcat(d,"\n");
    first=1;
   }
   else
   {
   d=realloc(d,strlen(p)+strlen(d)+strlen(en)+4);
   strcat(d,en);
   strcat(d,p);
   strcat(d,"\n");
   }
  }
}
gtk_selection_data_set(data,GDK_SELECTION_TYPE_STRING,8,d,strlen(d));
free(d);
}


}


void
on_aclist2_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
sel2[row]=1;
}


void
on_aclist2_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
sel2[row]=0;
}



GtkWidget* single_file_window (char *sd)
{
  GtkWidget *atwindow2;
  GtkWidget *atfixed2;
  GtkWidget *atentry1;
  GtkWidget *atbutton3;
  GtkWidget *atscrolledwindow2;
  GtkWidget *atclist2;
  GtkWidget *atlabel2;
  GtkWidget *atbutton4;
  GtkWidget *atlabel3;
  GtkWidget *atscrolledwindow1;
  GtkWidget *atclist1;
  GtkWidget *atlabel1;
DIR *dir1_handle=NULL;
char *root_dir="/";


dir1_handle=opendir(sd);
if(dir1_handle==NULL)
{
fdir=root_dir;
}
else
{
closedir(dir1_handle);
fdir=sd;
}


  atwindow2 = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (atwindow2), "atwindow2", atwindow2);
  gtk_window_set_title (GTK_WINDOW (atwindow2), "Sonic-Rainbow Select File");

  atfixed2 = gtk_fixed_new ();
  gtk_widget_ref (atfixed2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atfixed2", atfixed2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atfixed2);
  gtk_container_add (GTK_CONTAINER (atwindow2), atfixed2);
  gtk_widget_set_usize (atfixed2, 408, 353);

  atentry1 = gtk_entry_new ();
  gtk_widget_ref (atentry1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atentry1", atentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atentry1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atentry1, 128, 16);
  gtk_widget_set_uposition (atentry1, 128, 16);
  gtk_widget_set_usize (atentry1, 264, 24);

  atbutton3 = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (atbutton3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton3", atbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton3, 40, 288);
  gtk_widget_set_uposition (atbutton3, 40, 288);
  gtk_widget_set_usize (atbutton3, 130, 26);

  atscrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atscrolledwindow2", atscrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow2);
  gtk_fixed_put (GTK_FIXED (atfixed2), atscrolledwindow2, 232, 56);
  gtk_widget_set_uposition (atscrolledwindow2, 232, 56);
  gtk_widget_set_usize (atscrolledwindow2, 160, 208);

  atclist2 = gtk_clist_new (1);
  gtk_widget_ref (atclist2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atclist2", atclist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atclist2);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow2), atclist2);
  gtk_clist_set_column_width (GTK_CLIST (atclist2), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (atclist2), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (atclist2));

  atlabel2 = gtk_label_new ("Files");
  gtk_widget_ref (atlabel2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel2", atlabel2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel2);
  gtk_clist_set_column_widget (GTK_CLIST (atclist2), 0, atlabel2);
  gtk_label_set_justify (GTK_LABEL (atlabel2), GTK_JUSTIFY_LEFT);

  atbutton4 = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (atbutton4);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton4", atbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton4);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton4, 232, 288);
  gtk_widget_set_uposition (atbutton4, 232, 288);
  gtk_widget_set_usize (atbutton4, 51, 26);

  atlabel3 = gtk_label_new ("Current Directory");
  gtk_widget_ref (atlabel3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel3", atlabel3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atlabel3, 16, 16);
  gtk_widget_set_uposition (atlabel3, 16, 16);
  gtk_widget_set_usize (atlabel3, 112, 24);

  atscrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atscrolledwindow1", atscrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atscrolledwindow1, 16, 56);
  gtk_widget_set_uposition (atscrolledwindow1, 16, 56);
  gtk_widget_set_usize (atscrolledwindow1, 160, 208);

  atclist1 = gtk_clist_new (1);
  gtk_widget_ref (atclist1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atclist1", atclist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atclist1);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow1), atclist1);
  gtk_clist_set_column_width (GTK_CLIST (atclist1), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (atclist1), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (atclist1));

  atlabel1 = gtk_label_new ("Directorys");
  gtk_widget_ref (atlabel1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel1", atlabel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel1);
  gtk_clist_set_column_widget (GTK_CLIST (atclist1), 0, atlabel1);
  gtk_label_set_justify (GTK_LABEL (atlabel1), GTK_JUSTIFY_LEFT);

  gtk_signal_connect (GTK_OBJECT (atwindow2), "realize",
                      GTK_SIGNAL_FUNC (on_fwindow2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atfixed2), "realize",
                      GTK_SIGNAL_FUNC (on_ffixed2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atentry1), "realize",
                      GTK_SIGNAL_FUNC (on_fentry1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton3), "clicked",
                      GTK_SIGNAL_FUNC (on_fbutton3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "realize",
                      GTK_SIGNAL_FUNC (on_fclist2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "select_row",
                      GTK_SIGNAL_FUNC (on_fclist2_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "unselect_row",
                      GTK_SIGNAL_FUNC (on_fclist2_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton4), "clicked",
                      GTK_SIGNAL_FUNC (on_fbutton4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "realize",
                      GTK_SIGNAL_FUNC (on_fclist1_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (atclist1), "select_row",
                      GTK_SIGNAL_FUNC (on_fclist1_select_row),
                      NULL);
fsel_num1=-1;
fsel_num2=-1;


gtk_clist_set_auto_sort ((GtkCList*)atclist1,1);


  return atwindow2;
}



GtkWidget* create_awindow2 (char *sd)
{
  GtkWidget *atwindow2;
  GtkWidget *atfixed2;
  GtkWidget *atentry1;
  GtkWidget *atbutton3;
  GtkWidget *atscrolledwindow2;
  GtkWidget *atclist2;
  GtkWidget *atlabel2;
  GtkWidget *atbutton4;
  GtkWidget *atlabel3;
  GtkWidget *atscrolledwindow1;
  GtkWidget *atclist1;
  GtkWidget *atlabel1;
DIR *dir1_handle=NULL;
char *root_dir="/";



dir1_handle=opendir(sd);
if(dir1_handle==NULL)
{
sdir=root_dir;
}
else
{
closedir(dir1_handle);
sdir=sd;
}
  sdir=sd;


  atwindow2 = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (atwindow2), "atwindow2", atwindow2);
  gtk_window_set_title (GTK_WINDOW (atwindow2), "Sonic-Rainbow Select File");

  atfixed2 = gtk_fixed_new ();
  gtk_widget_ref (atfixed2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atfixed2", atfixed2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atfixed2);
  gtk_container_add (GTK_CONTAINER (atwindow2), atfixed2);
  gtk_widget_set_usize (atfixed2, 408, 353);

  atentry1 = gtk_entry_new ();
  gtk_widget_ref (atentry1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atentry1", atentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atentry1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atentry1, 128, 16);
  gtk_widget_set_uposition (atentry1, 128, 16);
  gtk_widget_set_usize (atentry1, 264, 24);

  atbutton3 = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (atbutton3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton3", atbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton3, 40, 288);
  gtk_widget_set_uposition (atbutton3, 40, 288);
  gtk_widget_set_usize (atbutton3, 130, 26);

  atscrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atscrolledwindow2", atscrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow2);
  gtk_fixed_put (GTK_FIXED (atfixed2), atscrolledwindow2, 232, 56);
  gtk_widget_set_uposition (atscrolledwindow2, 232, 56);
  gtk_widget_set_usize (atscrolledwindow2, 160, 208);

  atclist2 = gtk_clist_new (1);
  gtk_widget_ref (atclist2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atclist2", atclist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atclist2);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow2), atclist2);
  gtk_clist_set_column_width (GTK_CLIST (atclist2), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (atclist2), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (atclist2));

  atlabel2 = gtk_label_new ("Files");
  gtk_widget_ref (atlabel2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel2", atlabel2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel2);
  gtk_clist_set_column_widget (GTK_CLIST (atclist2), 0, atlabel2);
  gtk_label_set_justify (GTK_LABEL (atlabel2), GTK_JUSTIFY_LEFT);

  atbutton4 = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (atbutton4);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton4", atbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton4);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton4, 232, 288);
  gtk_widget_set_uposition (atbutton4, 232, 288);
  gtk_widget_set_usize (atbutton4, 51, 26);

  atlabel3 = gtk_label_new ("Current Directory");
  gtk_widget_ref (atlabel3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel3", atlabel3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atlabel3, 16, 16);
  gtk_widget_set_uposition (atlabel3, 16, 16);
  gtk_widget_set_usize (atlabel3, 112, 24);

  atscrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atscrolledwindow1", atscrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atscrolledwindow1, 16, 56);
  gtk_widget_set_uposition (atscrolledwindow1, 16, 56);
  gtk_widget_set_usize (atscrolledwindow1, 160, 208);

  atclist1 = gtk_clist_new (1);
  gtk_widget_ref (atclist1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atclist1", atclist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atclist1);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow1), atclist1);
  gtk_clist_set_column_width (GTK_CLIST (atclist1), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (atclist1), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (atclist1));

  atlabel1 = gtk_label_new ("Directorys");
  gtk_widget_ref (atlabel1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel1", atlabel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel1);
  gtk_clist_set_column_widget (GTK_CLIST (atclist1), 0, atlabel1);
  gtk_label_set_justify (GTK_LABEL (atlabel1), GTK_JUSTIFY_LEFT);

  gtk_signal_connect (GTK_OBJECT (atwindow2), "realize",
                      GTK_SIGNAL_FUNC (on_awindow2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atfixed2), "realize",
                      GTK_SIGNAL_FUNC (on_afixed2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atentry1), "realize",
                      GTK_SIGNAL_FUNC (on_aentry1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton3), "clicked",
                      GTK_SIGNAL_FUNC (on_abutton3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "realize",
                      GTK_SIGNAL_FUNC (on_aclist2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "drag_data_get",
                      GTK_SIGNAL_FUNC (on_aclist2_drag_data_get),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "select_row",
                      GTK_SIGNAL_FUNC (on_aclist2_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist2), "unselect_row",
                      GTK_SIGNAL_FUNC (on_aclist2_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton4), "clicked",
                      GTK_SIGNAL_FUNC (on_abutton4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "realize",
                      GTK_SIGNAL_FUNC (on_aclist1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "select_row",
                      GTK_SIGNAL_FUNC (on_aclist1_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "drag_data_get",
                      GTK_SIGNAL_FUNC (on_aclist1_drag_data_get),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "unselect_row",
                      GTK_SIGNAL_FUNC (on_aclist1_unselect_row),
                      NULL);
gtk_clist_set_auto_sort ((GtkCList*)atclist1,1);
gtk_clist_set_auto_sort ((GtkCList*)atclist2,1);
  return atwindow2;
}


void
on_fclist2_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
fsel_num2=row;
}


void
on_fclist2_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
fsel_num2=-1;
}

void
on_ffixed2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_fwindow2_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
fl=widget;
fdata=NULL;
}


void
on_fentry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)widget,fdir);
fe=widget;
}

void
on_fbutton3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char *p;
GtkCList *cl=NULL;
GList *glist=NULL;
gint row;

cl=GTK_CLIST(fclist2);
glist = cl->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
if(row==-1)
{
fdata=NULL;
gtk_main_quit();
return;
}

gtk_clist_get_text((GtkCList*)fclist2,fsel_num2,0,&p);
fdata=(char*)malloc(strlen(p)+strlen(gtk_entry_get_text((GtkEntry*)fe))+2);
strcpy(fdata,gtk_entry_get_text((GtkEntry*)fe));
strcat(fdata,p);
gtk_main_quit();
}



void
on_fclist2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2],*dt;
struct dirent *dent;

fclist2=widget;
gtk_clist_set_column_auto_resize ((GtkCList*)widget,0,1);
fsel_num2=-1;


dir1_handle=opendir(fdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)
return;
}
while(1)
{
dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(fdir)+strlen(dent->d_name)+2);
strcpy(dt,fdir);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir==NULL)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
fsel_num2++;
}
else
closedir(t_dir);
t_dir=NULL;
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
fsel_num2++;
}
}
}

gtk_clist_set_auto_sort ((GtkCList*)widget,1);
closedir(dir1_handle);

}



void
on_fbutton4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
fdata=NULL;
fsel_num1=-1;
fsel_num2=-1;
gtk_main_quit();
}

void
on_fclist1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle,*t_dir;
char *t[2],*dt;
struct dirent *dent;


fsel_num1=-1;
fclist1=widget;
gtk_clist_set_column_auto_resize ((GtkCList*)widget,0,1);
dir1_handle=opendir(fdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)return;
strcpy(fdir,"/");
}
while(1)
{

dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type==DT_DIR || dent->d_type==DT_LNK)
{
 if(dent->d_type == DT_LNK)
{
dt=(char*)malloc(strlen(fdir)+strlen(dent->d_name)+2);
strcpy(dt,fdir);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
fsel_num1++;
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
fsel_num1++;
}
}

}

gtk_clist_set_auto_sort ((GtkCList*)widget,1);
closedir(dir1_handle);
}



void
on_fclist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *t,*p;
char *cwd,*nwd;
int b;

fsel_num1=-1;
fsel_num2=-1;

if(event->button.type==GDK_2BUTTON_PRESS)
{
cwd=(char *)malloc(10001);
nwd=(char *)malloc(10001);
getcwd(cwd,10000);
gtk_clist_get_text((GtkCList *)clist,row,column,&p);
t=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)fe))+ strlen(p)+2);
strcpy(t,gtk_entry_get_text((GtkEntry*)fe));
strcat(t,p);
strcat(t,"/");
chdir(t);
getcwd(nwd,10000);
if(strlen(nwd)>2 && nwd[strlen(nwd)-1]!='/')
strcat(nwd,"/");
b=ffill_list(t);
if(b)gtk_entry_set_text((GtkEntry*)fe,nwd);
chdir(cwd);
free(cwd);
free(nwd);
free(t);
}

}







int ffill_list(char *di)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2],*dt;
struct dirent *dent=NULL;


fsel_num1=0;
fsel_num2=0;

dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)fclist1);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type==DT_DIR || dent->d_type==DT_LNK)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(di)+strlen(dent->d_name)+2);
strcpy(dt,di);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)fclist1,t);
fsel_num1++;
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)fclist1,t);
fsel_num1++;
}
}
}
closedir(dir1_handle);


dir1_handle=NULL;
dent=NULL;

dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)fclist2);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(di)+strlen(dent->d_name)+2);
strcpy(dt,di);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir==NULL)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)fclist2,t);
fsel_num2++;
}
else
closedir(t_dir);
t_dir=NULL;
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)fclist2,t);
fsel_num2++;
}
}
}
closedir(dir1_handle);


return 1;
}







GtkWidget* create_single_dir_window (char *sd)
{
  GtkWidget *atwindow2;
  GtkWidget *atfixed2;
  GtkWidget *atentry1;
  GtkWidget *atbutton4;
  GtkWidget *atlabel3;
  GtkWidget *atscrolledwindow1;
  GtkWidget *atclist1;
  GtkWidget *atlabel1;
 GtkWidget *atbutton3;
DIR *dir1_handle=NULL;
char *root_dir="/";


dir1_handle=opendir(sd);
if(dir1_handle==NULL)
{
ddir=root_dir;
}
else
{
closedir(dir1_handle);
ddir=sd;
}

  atwindow2 = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (atwindow2), "atwindow2", atwindow2);
  gtk_window_set_title (GTK_WINDOW (atwindow2), "Sonic-Rainbow Select Directory");

  atfixed2 = gtk_fixed_new ();
  gtk_widget_ref (atfixed2);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atfixed2", atfixed2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atfixed2);
  gtk_container_add (GTK_CONTAINER (atwindow2), atfixed2);
  gtk_widget_set_usize (atfixed2, /*408*/290, 323);

  atentry1 = gtk_entry_new ();
  gtk_widget_ref (atentry1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atentry1", atentry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atentry1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atentry1, 15, 36);
  gtk_widget_set_uposition (atentry1, 15, 36);
  gtk_widget_set_usize (atentry1, 264, 24);

  atbutton3 = gtk_button_new_with_label ("Ok");
  gtk_widget_ref (atbutton3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton3", atbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton3, 56, 288);
  gtk_widget_set_uposition (atbutton3, 56, 288);
  gtk_widget_set_usize (atbutton3, 51, 26);



  atbutton4 = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (atbutton4);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atbutton4", atbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atbutton4);
  gtk_fixed_put (GTK_FIXED (atfixed2), atbutton4, 156, 288);
  gtk_widget_set_uposition (atbutton4, 156, 288);
  gtk_widget_set_usize (atbutton4, 51, 26);

  atlabel3 = gtk_label_new ("Current Directory");
  gtk_widget_ref (atlabel3);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel3", atlabel3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel3);
  gtk_fixed_put (GTK_FIXED (atfixed2), atlabel3, 8, 15);
  gtk_widget_set_uposition (atlabel3, 8, 15);
  gtk_widget_set_usize (atlabel3, 112, 24);

  atscrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atscrolledwindow1", atscrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow1);
  gtk_fixed_put (GTK_FIXED (atfixed2), atscrolledwindow1, 56, 66);
  gtk_widget_set_uposition (atscrolledwindow1, 56, 66);
  gtk_widget_set_usize (atscrolledwindow1, 160, 208);

  atclist1 = gtk_clist_new (1);
  gtk_widget_ref (atclist1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atclist1", atclist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atclist1);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow1), atclist1);
  gtk_clist_set_column_width (GTK_CLIST (atclist1), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (atclist1), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (atclist1));

  atlabel1 = gtk_label_new ("Directorys");
  gtk_widget_ref (atlabel1);
  gtk_object_set_data_full (GTK_OBJECT (atwindow2), "atlabel1", atlabel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel1);
  gtk_clist_set_column_widget (GTK_CLIST (atclist1), 0, atlabel1);
  gtk_label_set_justify (GTK_LABEL (atlabel1), GTK_JUSTIFY_LEFT);

  gtk_signal_connect (GTK_OBJECT (atwindow2), "realize",
                      GTK_SIGNAL_FUNC (on_dwindow2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atfixed2), "realize",
                      GTK_SIGNAL_FUNC (on_dfixed2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atentry1), "realize",
                      GTK_SIGNAL_FUNC (on_dentry1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton3), "clicked",
                      GTK_SIGNAL_FUNC (on_dbutton3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atbutton4), "clicked",
                      GTK_SIGNAL_FUNC (on_dbutton4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "realize",
                      GTK_SIGNAL_FUNC (on_dclist1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "select_row",
                      GTK_SIGNAL_FUNC (on_dclist1_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (atclist1), "unselect_row",
                      GTK_SIGNAL_FUNC (on_dclist1_unselect_row),
                      NULL);

//gtk_entry_set_text((GtkEntry*)de,ddir);



//gtk_clist_set_auto_sort ((GtkCList*)atclist1,1);

  return atwindow2;
}



void
on_dwindow2_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
dl=widget;
}

void
on_dfixed2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
dsel=-1;
if(ddata!=NULL)
free(ddata);
ddata=NULL;
}


void
on_dentry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

gtk_entry_set_text((GtkEntry*)widget,ddir);
de=widget;

}


void
on_dbutton3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char *p;
if(dsel==-1)
{
ddata=(char*)malloc(strlen(gtk_entry_get_text((GtkEntry*)de))+2);
strcpy(ddata,gtk_entry_get_text((GtkEntry*)de));
}
else
{
gtk_clist_get_text((GtkCList*)dclist1,dsel,0,&p);
ddata=(char*)malloc(strlen(p)+strlen(gtk_entry_get_text((GtkEntry*)de))+2);
strcpy(ddata,gtk_entry_get_text((GtkEntry*)de));
strcat(ddata,p);
strcat(ddata,"/");
}
gtk_main_quit();
}



void
on_dbutton4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if(ddata!=NULL)
free(ddata);
ddata=NULL;
dsel=-1;
gtk_main_quit();
}

void
on_dclist1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2],*dt;
struct dirent *dent;


dsel=-1;
dclist1=widget;

dir1_handle=opendir(ddir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)return;
}
while(1)
{

dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type==DT_DIR||dent->d_type==DT_LNK)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(ddir)+strlen(dent->d_name)+2);
strcpy(dt,ddir);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
}
}
}

gtk_clist_set_auto_sort ((GtkCList*)widget,1);
closedir(dir1_handle);
}


void
on_dclist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *t,*p;
char *cwd,*nwd;
int b;

dsel=-1;
if(event->button.type==GDK_2BUTTON_PRESS)
{
cwd=(char *)malloc(10001);
nwd=(char *)malloc(10001);
getcwd(cwd,10000);
gtk_clist_get_text((GtkCList *)dclist1,row,column,&p);
t=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)de))+ strlen(p)+2);
strcpy(t,gtk_entry_get_text((GtkEntry*)de));
strcat(t,p);
strcat(t,"/");
chdir(t);
getcwd(nwd,10000);
if(strlen(nwd)>2 && nwd[strlen(nwd)-1]!='/')
strcat(nwd,"/");
b=dfill_list(t);
if(b)gtk_entry_set_text((GtkEntry*)de,nwd);
chdir(cwd);
free(cwd);
free(nwd);
free(t);
}
else
dsel=row;
}


void
on_dclist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
dsel=-1;
}




int dfill_list(char *di)
{
DIR *dir1_handle,*t_dir=NULL;
char *t[2],*dt;
struct dirent *dent=NULL;


dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)dclist1);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type==DT_DIR || dent->d_type==DT_LNK)
{
if(dent->d_type==DT_LNK)
{
dt=(char*)malloc(strlen(di)+strlen(dent->d_name)+2);
strcpy(dt,di);
strcat(dt,dent->d_name);
t_dir=opendir(dt);
if(t_dir!=NULL)
{
closedir(t_dir);
t_dir=NULL;
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)dclist1,t);
}
free(dt);
}
else
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)dclist1,t);
}
}
}
closedir(dir1_handle);


return 1;
}




void mtitle(char *f,GtkWidget *widget)
{
size_t offset;
char string[ID3V2_MAX_STRING_LEN];
ID3Tag  *mtag=NULL;
ID3Frame *mid3_frame;
ID3Field *mid3_field;
int num_chars;

mtag= ID3Tag_New();
offset = ID3Tag_Link(mtag,f);

mid3_frame = ID3Tag_FindFrameWithID(mtag,ID3FID_TITLE);
mid3_field = ID3Frame_GetField(mid3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(mid3_field,string,ID3V2_MAX_STRING_LEN);

/*
if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_clist_append((GtkCList*)widget,string1);
}
*/

}
