/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <fcntl.h>
#include <linux/soundcard.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/videodev.h>
#include <string.h>
#include "umix_common.h"
#include "driver_oss.h"
#include "mixer.h"


GtkWidget *mixb,*mbbal,*eh=NULL;
GtkObject *mbadj;
char help[10000];

extern int which_player;
extern int tooltip;
extern int pcm_chan,vol_chan;

extern int cd_handle,completed;
extern int disk_present;
extern int sel_tracks[100];
extern char default_mixer[1000];
extern int display_radio;
extern int radio_dev;
extern char *music_dir;
extern struct video_audio va;
extern struct video_tuner vt;

extern union myu
{
unsigned int uv;
unsigned char bval[2];
}bal;


extern struct mdev
{
char *label;
int chan;
char anum[100];
int rec;
int value;
}mixer_devs[25];

extern GtkObject *mixer_adj[25],*mixer_badj;

int mi=0;

int destroy;
int hwstat=0;
int rip_timer;
int global_exit=0;
float global_volume;
float global_balance;

GtkWidget *cd_entry;
GtkWidget *hw=NULL;
GtkWidget *setw=NULL;
GtkWidget *ripw=NULL;
GtkWidget *radioplayer=NULL;
GtkWidget *helpbutton=NULL;
extern GtkTooltips *tooltips;

GtkWidget *main_blab,*main_bvol;
GtkWidget *te=NULL;


extern guint cd_timer;
extern GtkWidget *rlist_item,*freq_spin;
extern GtkWidget *rip_list;
extern float frequencys[11];
extern char  blabels[11][7];
extern int mixer_up;

GtkWidget* create_tag_window (char *);
int play_cdauto();
int ripper_cd();
void free_list();
void main_vol( GtkAdjustment *get, gpointer         user_data );
void main_bal( GtkAdjustment *get, gpointer         user_data );
void main_f( GtkAdjustment *get, gpointer         user_data );
void xstuff();
void main_bbal( GtkAdjustment *get, gpointer         user_data );

void show_cdplayer();
void hide_cdplayer();
void show_oggplayer();
void hide_oggplayer();
void hide_videoplayer();
void show_videoplayer();
void main_f( GtkAdjustment *get, gpointer         user_data );
void hide_radioplayer();
void show_radioplayer();
void reset_radio_button(int but);
void load_player(int);
int oss_readlevel(void);



/*
GtkWidget* create_convert_window (char *sd);
*/


GtkWidget *mvol,*mwin,*mbal,*sta,*main_fixed,*et;
GtkWidget *main_blab;
GtkObject *madj,*mbadj,*sadj,*main_badj;
void radio_buttons();
void do_save_config();
void do_error_message(char *text);
void do_help_message(char *text);

typedef struct _cd_track
{
int tracknum;
char *title;
char *artist;
int length;
}cd_tracks;

extern   struct rcds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}rcd_info;

extern struct cds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}cd_info;


extern int frames[100];


union
{
int x;
char l[2];
}vbal;



void
on_main_window_exit_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
global_exit=1;
stop_cd(cd_handle);
frequencys[10]=gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin);
if(radio_dev>0)
{
frequencys[10]=gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin);
va.audio = 0;
va.volume = 0;
va.flags = VIDEO_AUDIO_MUTE;
ioctl(radio_dev, VIDIOCSAUDIO, &va);

close(radio_dev);
radio_dev=-1;
}
do_save_config();
gtk_main_quit();
}


void
on_main_window_destroy                 (GtkObject       *object,
                                        gpointer         user_data)
{
 stop_cd(cd_handle);
 gtk_main_quit();
}



void
on_main_window_setup_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{

if(setw!=NULL)return;

/*
if(setw==NULL)
{
 destroy=0;
*/
 setw=create_setup_window();
 gtk_widget_show (setw);
/*
 gtk_main();
 if(destroy==0 || destroy==2)
 {
 gtk_widget_destroy(setw);
 setw=NULL;
 }
}
*/
}







void
on_main_window_rip_cd_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
int num;

if(ripw==NULL)
{
for(num=0;num<100;num++)
{
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}


rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.tracks=0;
rlist_item=NULL;

rip_list=NULL;

ripw=create_ripper_window();
gtk_widget_show (ripw);
 rip_timer=gtk_timeout_add(250,ripper_cd,NULL);
}

}





void
on_help_button_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

if(hw!=NULL)return;

strcpy(help,"Sonic-Rainbow Version 0.7.2.2\nCopyright Gary Baker\n");
strcat(help,"\nExtensive Help is available in the file\n/usr/share/Sonic-Rainbow/doc/Sonic-Rainbow.html\nThis file can be viewed in any Web Browser\n");
strcat(help,"\nThe Front Panel allows you to toggle between the\nFile Player, CD Player, DVD Player and Radio Player.\nThe Mixer, CD Ripper, Setup and Tag Editor are all\nexecuted in seperate windows.\nToggling between players does not change the player\nsettings or stop the player. The CD Ripper, Mixer, Setup\nand Tag Editor have their own Help Dialog accessed\nfrom their window.\n\nThe Volume and Balance Sliders will be disabled if the\nmixer dev coud not be opened. This can be rectified via\nthe Setup dialog.\n\nFILE PLAYER\nThe File Player will play Ogg, FLAC, Wav and MP3\nfiles. The Load File/Dir button will allow you to load an\nindividual music file or a directory of music files.\nDirectory's files and playlists can be loaded one after\nanother to create a large list of files.\nThe Clear List button will clear \nall currently listed files.\nSave Playlist will enable you to save the currently\nloaded files to a Playlist file. When the files are not being\nplayed but are loaded, clicking on the drop down List\nbutton will display a number of buttons to allow you to\nedit the the current list. You can Add, Del, Up or Down\nentries in the current list.\nTo select the files Right Click on them. Save List will\nthen enable you to save the modified Playlist to an\nexisting or new name.\nLoad Playlist enables you to load a Playlist.\nPlay will begin playing loaded files.\nThe Play progress slider can be used to move within a\nplaying file. Click on the slider, hold the mouse\nbutton down and move the slider to where you want it.\nThis is not supported with FLAC files.");

strcat(help,"\n\nCD Player\nThe CD player will play CD's. Selecting autoplay\nwill cause the CD Player to play a CD when it has been\ninserted. This can be set permanently in the Setup\nDialog. The device the CD player plays CD's from can\nalso be set in the Setup Dialog.");

strcat(help,"\n\nDVD Player\nThe DVD player can play DVD's, VCD's or Video Files.\nThe type of video files it can play depends on the\ninstalled Xine plugins and decoders. The DVD player\nuses the Xine engine and is dependant on Xine\nbeing fully installed and configured correctly.");

strcat(help,"\n\nRadio Player\nThe Radio Player requires an FM radio card to be\ninstalled, configued and working.\nThe Radio Player has been written to the video4linux\ninterface. The interface is accessed via a device file.\nBy default it is /dev/radio  but this can be altered in the\nSetup Dialog.\nThe Station slider allows you to tune the radio.\nThe Save button allows you to save a station to a\nbutton and put your own label on the button.\nThe buttons can also be used to select\na station once configured.\nThe Play button starts the radio and the stop button\nstops it. The Rec button brings up a dialog that allows\nyou to record the radio to a Wav or Ogg file.\nThe Rec channel allows you to set the recording\ndevice channel. This is often dependant on the card\ntype and how it is configured.");

strcat(help,"\n\nCD Ripper help is provided in the CD Ripper Dialog.\n\nSetup Help is privided in the Setup Dialog.\n\nTag Editor Help is provided in the Tag Editor Dialog.");


 hw=create_help_window();
 gtk_widget_show(hw);
}

void
on_help_ok_button_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
if(eh)
gtk_widget_destroy(eh);
eh=NULL;
gtk_widget_destroy(hw);
hw=NULL;
}




void
on_help_text_box_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
eh=widget;


gtk_text_insert((GtkText*)widget,NULL,NULL,NULL,help,-1);

}






void
on_main_window_fixed_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
char *ebuff;
GtkWidget *l23;
int num;
int a1,mb1=0;
main_fixed=widget;
xstuff();

if(tooltip)
{
gtk_tooltips_disable(tooltips);
}
else
{
gtk_tooltips_enable(tooltips);
}

load_player(which_player);

radio_buttons();

init_mixers();
a1=mixer_open(default_mixer);
if(a1!=-1)
mb1=mixer_init();


if(mb1==-1 || a1==-1)
{
  ebuff=(char *)malloc(5000);
strcpy(ebuff,"Errors accesing the Mixer Device\nSonic-Rainbow needs to be able to read and write\nto the Mixer device file to alter the Volume.\nThe Mixer has been configured as ");
strcat(ebuff,default_mixer);
strcat(ebuff,"\nYou may have the wrong device.\nThe mixer device can be re-selected in Setup.");
strcat(ebuff,"\nThis may also be a file permissions based\nproblem that can be resolved by changing the\npermissions on ");
strcat(ebuff,default_mixer);
strcat(ebuff,"\nor changing the runtime permissions of\nSonic-Rainbow\nThis Error message will not be redisplayed.");
strcat(ebuff,"\nThe volume slider and Mixer button will be disabled\nuntil this is resolved");
   do_error_message(ebuff);
   free(ebuff);
mi=0;
}
else
mi=1;

if(mi)
{
for(num=0;num<mixer_get_num_chan();num++)
{
chan_set_curr(num);
if(strcasecmp("Vol",chan_get_name())==0)
vol_chan=num;
if(strcasecmp("Pcm",chan_get_name())==0)
pcm_chan=num;
}
chan_set_curr(vol_chan);
global_volume=chan_get_vol();
global_balance=chan_get_bal();
}

  madj=gtk_adjustment_new (0, 0,10, 0, 0, 0);
  mvol= gtk_hscale_new (GTK_ADJUSTMENT (madj));
  gtk_widget_ref (mvol);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", mvol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mvol);
  gtk_fixed_put (GTK_FIXED (widget), mvol, 16,157);
  gtk_widget_set_uposition (mvol,16,157);
  gtk_widget_set_usize (mvol,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (mvol), FALSE);

  gtk_signal_connect (GTK_OBJECT (madj), "value_changed",
                        GTK_SIGNAL_FUNC (main_vol), NULL);

if(mi)
gtk_adjustment_set_value((GtkAdjustment*)madj,global_volume/10);
gtk_widget_set_sensitive (mvol, mi);

  l23 = gtk_label_new ("Volume");
  gtk_widget_ref (l23);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "l23", l23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (l23);
  gtk_fixed_put (GTK_FIXED (widget), l23, 16, 144);
  gtk_widget_set_uposition (l23, 16, 144);
  gtk_widget_set_usize (l23, 41, 16);


  main_blab = gtk_label_new ("Balance");
  gtk_widget_ref (main_blab);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_blab",main_blab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_blab);

  gtk_fixed_put (GTK_FIXED (widget),main_blab,117,144 );
  gtk_widget_set_uposition (main_blab,117,144);
  gtk_widget_set_usize (main_blab, 51, 16);

  mbadj=gtk_adjustment_new (0, -1,1, 0.1, 0, 0);
  mbbal= gtk_hscale_new (GTK_ADJUSTMENT (mbadj));
  gtk_widget_ref (mbbal);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "bscale1", mbbal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mbbal);
  gtk_fixed_put (GTK_FIXED (widget), mbbal, 120,157);
  gtk_widget_set_uposition (mbbal,120,157);
  gtk_widget_set_usize (mbbal,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (mbbal), FALSE);

if(mi)
gtk_adjustment_set_value((GtkAdjustment*)mbadj,global_balance/10);
gtk_widget_set_sensitive (mbbal, mi);

  gtk_signal_connect (GTK_OBJECT (mbadj), "value_changed",
                        GTK_SIGNAL_FUNC (main_bbal), NULL);

}


void
on_main_window_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

GtkTargetEntry target_entry[1];

target_entry[0].target="text/plain";
target_entry[0].flags=0;
target_entry[0].info=0;

gtk_drag_dest_set(widget,GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_HIGHLIGHT | GTK_DEST_DEFAULT_DROP,
target_entry,1,GDK_ACTION_COPY|GDK_ACTION_MOVE);

mwin=widget;
}

void main_vol( GtkAdjustment *get, gpointer         user_data )
{
static int b=0;

b=(int)get->value;
if(mixer_up)
gtk_adjustment_set_value((GtkAdjustment*)mixer_adj[vol_chan],b);
global_volume=b*10;
chan_set_curr(vol_chan);
chan_set_vol(global_volume);
  }

void main_bbal( GtkAdjustment *get, gpointer         user_data )
{
static float b=0;
int chan;

b=get->value;
if(mixer_up)
gtk_adjustment_set_value((GtkAdjustment*)mixer_badj,b);

chan=chan_get_curr();
chan_set_curr(vol_chan);
chan_set_bal(get->value);
chan_set_curr(pcm_chan);
chan_set_bal(get->value);
chan_set_curr(chan);
  }

void do_error_message(char *text)
{
GtkWidget *em;
   em=create_error_window();
   gtk_widget_show(em);
   gtk_text_insert((GtkText*)et,NULL,NULL,NULL,text,-1);
   gtk_main();
   gtk_widget_destroy(em);
}


void do_help_message(char *text)
{
GtkWidget *em;
   em=create_help_window();
   gtk_widget_show(em);
   gtk_text_insert((GtkText*)eh,NULL,NULL,NULL,text,-1);
   gtk_main();
   gtk_widget_destroy(em);
}


void
on_error_ok_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_main_quit();
}


void
on_error_text_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
et=widget;
}




void
on_cd_player_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(1);
}


void
on_ogg_player_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(2);
}


void
on_dvd_player_button_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(3);
}


void
on_radio_player_button_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
load_player(4);
}


void load_player(int w)
{
void show_cdplayer();
void hide_cdplayer();
void show_oggplayer();
void hide_videoplayer();
void main_f( GtkAdjustment *get, gpointer         user_data );
void hide_radioplayer();
void show_radioplayer();
void reset_radio_button(int but);

if(which_player)
{
 if(which_player==1)
 hide_cdplayer();
 else
 if(which_player==2)
 hide_oggplayer();
 else
 if(which_player==3)
 hide_videoplayer();
 else
 if(which_player==4)
 hide_radioplayer();
}

 if(w==1)
 show_cdplayer();
 else
 if(w==2)
 show_oggplayer();
 else
 if(w==3)
 show_videoplayer();
 else
 if(w==4)
 show_radioplayer();

which_player=w;

}





void
on_radio_player_button_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
radioplayer=widget;
}


void
on_help_button_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
helpbutton=widget;
}




void
on_tag_editor_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
if(te)return;

te=create_tag_window (music_dir);
gtk_widget_show(te);
/*
gtk_main();
gtk_widget_destroy(te);
te=NULL;
*/
}




/*

void
on_convert_files_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *w;
w=create_convert_window (music_dir);
gtk_widget_show(w);
gtk_main();
}
*/






void
on_mixer_button_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{
mixb=widget;
gtk_widget_set_sensitive (widget, mi);
}


void
on_setup_help_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
if(hw)return;
strcpy(help,"Sonic-Rainbow Version 0.7.2.2\nCopyright Gary Baker\n");
strcat(help,"\n\nCD Player Device\nis the device file used to access the CD Player. \nThe browse button enables you to select a different\ndevice if required. The default device is /dev/cdrom");

strcat(help,"\n\nMixer Device\nis the device file used to access the mixing capability of\nthe sound card such as the volume and balance control.\nIt is /dev/mixer by default but can be changed via\nthe Browse button.");

strcat(help,"\n\nMusic Directory\nis the base directory used to create subdirectories from\nfor ripped files.The path can be changed via the\nBrowse button.");

strcat(help,"\n\nPlaylist Directory\nis the directory used to save and retrieve playlists from.\nThe path can be changed via the Browse button.");

strcat(help,"\n\nDefault Playlist\nis the name and path of a Playlist File to be played when\nPlaylist Autoplay is enabled. The path can be changed\nvia the Browse button.");

strcat(help,"\n\nVideo Directory\nis the default directory to look for Video files in.\nThe path can be changed via the Browse button.");

strcat(help,"\n\nRadio Device\nis the device file used to access radio card functionality.\nThe default is /dev/radio .The radio card must be\nproperly installed and configured for the dev file to\nappear. The path can be changed via the Browse button.");

strcat(help,"\n\nRadio Directory\nis the default directory to look for and store recorded\nradio files in. The path can be changed via the\nBrowse button.");

strcat(help,"\n\nPlaylist Autoplay\nwhen enabled will cause the Default Playlist to play on\nstartup and when a playlist is selected it will start\nplaying automatically");

strcat(help,"\n\nCD Autoplay\nwhen enabled will cause a CD to be played\n automatically when it is inserted. This includes CD's\nfound on startup");

strcat(help,"\n\nFM Radio Autoplay\nwhen enabled will start the FM radio (if installed) playing\nwhen Sonic-Raonbow is started.");

strcat(help,"\n\nDisable HTTP Loookup\nwhen enabled prevents Sonic-Rainbow looking up CD\nrelated information on the internet");

strcat(help,"\n\nDisable Error Messages During Play\nwhen enabled disables the display of non-critical error\nmessages that would otherwise interrupt the track playing");

strcat(help,"\n\nDisable Tooltips\nwhen enabled prevents tooltips being displayed as the\nmouse moves over buttons");

strcat(help,"\n\nApply\nsaves the current configuration");

strcat(help,"\n\nDefault\nsets all values to default values but does not apply them");

strcat(help,"\n\nExit\ncloses the setup dialog without saving any changes,\nunless apply has already been clicked");

 hw=create_help_window();
 gtk_widget_show(hw);

}


void
on_ripper_help_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{

if(hw)return;

strcpy(help,"Sonic-Rainbow Version 0.7.2.2\nCopyright Gary Baker\n");

strcat(help,"\n\nFile Options\nCD's can be ripped to Ogg,WAV,FLAC and MP3 formats\nby selecting the corresponding button. The quality spin\nbutton only applies to Ogg and MP3 files, with 10\nbeing the highest quality and 0 the lowest. This can have\nan efect on output file size. If connected to the\ninternet and HTTP lookup is not disabled in the\nsetup dialog, the Track, Artist etc... fields should be\nfilled out automatically.\nIf the CD has been ripped or played before, the\ninformation may already be local. An inserted CD's info\nwill be displayed in the List Box. Clicking on a track\nwill allow you to edit fields associated with the track.\nThe fields will be entered into the files tags when it is\nripped. If information cannot be found on the CD you can\nenter it all manually. Unknown CD's will overwrite\neach others files unless a CD Title and Artist are\nprovided.");

strcat(help,"\n\nMusic Directory\nis the base directory that will be combined with CD Title\nand Artist to create the path where the ripped files\nwill be stored.");

strcat(help,"\n\nRip CD\nwill rip the entire CD\n\nRip Sel\nwill rip the selected(highlighted) tracks");
 hw=create_help_window();
 gtk_widget_show(hw);

}

