/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdlib.h>
#include <stdio.h>
#include <linux/cdrom.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "cd.h"

extern int cd_autoplay;


int status_cd(int fd)
{
int s;
struct cdrom_subchnl status;

 status.cdsc_format=CDROM_MSF;

 s =ioctl(fd,CDROMSUBCHNL,&status);
 if(s==-1)return -1;
 return (status.cdsc_audiostatus);
}

int open_cd(char cd[])
{
 return (open(cd, O_RDONLY|O_NONBLOCK));
}

int play_cd(int fd, int st) 
{
struct cdrom_ti ti;

 ti.cdti_trk0=st;
 ti.cdti_ind0=0;
 ti.cdti_ind1=0;

 ti.cdti_trk1=total_tracks_cd(fd, 0);
 ioctl(fd,CDROMSTART);

 return(ioctl(fd,CDROMPLAYTRKIND,&ti));
}

int total_tracks_cd(int fd, int first)
{
struct cdrom_tochdr toc;

 ioctl(fd, CDROMREADTOCHDR, &toc);
 if (first==1) return(toc.cdth_trk0);
 return(toc.cdth_trk1-toc.cdth_trk0+1);
}

int stop_cd(int fd)
{
 return(ioctl(fd,CDROMSTOP));
}

int pause_cd(int fd)
{
 return(ioctl(fd,CDROMPAUSE));
}

int resume_cd(int fd)
{
 return (ioctl(fd,CDROMRESUME));
}

int eject_cd(int fd)
{
 return(ioctl(fd,CDROMEJECT));
}

int drive_status_cd(int fd)
{
 return(ioctl(fd,CDROM_DRIVE_STATUS));
}

int disc_status_cd(int fd)
{
 return(ioctl(fd,CDROM_DISC_STATUS));
}

int is_audio_cd(int fd)
{
int n;

 n=ioctl(fd,CDROM_DISC_STATUS);
 if(n==100)return 1;
 else
 return 0;
}
