/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Sonic Rainbow (c) 2003-2010 Gary Baker http://ozscap.sourceforge.net
*/
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <cddb/cddb.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/cdrom.h>
#include <sys/ioctl.h>
#include <sys/ioctl.h>
#include<sys/stat.h>

#include "cddev.h"
#include "cd.h"



#define ENV_HTTP_PROXY "http_proxy"
#define HTTP_PREFIX "http://"
#define HTTP_PREFIX_LEN 7
/*
char *cats[]={"Rock","Country","Blues","Soundtrack","Jazz","Misc","Newage","Reggae","Classical","Folk"};
*/
char *cats[]={"reggae","unknown","country","blues","rock","misc","classical",
			    "data","folk","jazz","newage",
			    "soundtrack"};

extern int play_error;
extern int http_lookup;
extern GtkWidget *main_window_cdlist;
extern GtkWidget *main_window_cdscrolled;
extern GtkWidget *main_window_cd_autoplay;
extern GtkWidget *main_window_cd_entry;

int cd_changed=0;
int get_disc_id();
unsigned int cddb_sum(int n);
int do_display(cddb_disc_t *disc);
void bizzo();
int get_disc_id();
unsigned int cddb_sum(int n);
int file_read();
GtkWidget *list_item=NULL;
void do_error_message(char *text);
GtkWidget* create_cddb_window (void);


int tog=0;

char p[1000];
int list_first=0;
int scrolled_first=0;
void fill_list(char []);
void free_list();
int ripper_cd();

/*g_list_free */

extern int cd_handle,completed;
extern int cd_autoplay,cddb;
extern char *cd_dev;

int play_cdauto();


typedef struct _cd_track
{
int tracknum;
char *title;
char *artist;
int length;
}cd_tracks;

struct cds
{
int tracks;
char *title;
char *artist;
char *genre;
cd_tracks c_tracks[100];
}cd_info;

extern int frames[100];
extern int disc_time;
extern unsigned int disc_tracks;

int play_cdauto()
{
struct cdrom_subchnl status;
int s,r,num;
char cdbuff[1000];


 if(cd_handle<1)
   cd_handle=open_cd(cd_dev);

  if(cd_handle<1)
  return -1;

   status.cdsc_format=CDROM_MSF;
   ioctl(cd_handle,CDROMSUBCHNL,&status);

   s=drive_status_cd(cd_handle);

if(s==1)
{
gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"No Disc");

if(cd_info.tracks!=0)
{
free_list();
for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;
cd_info.tracks=0;
}

return 1;
}

else
if(s==2)
{
gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Tray Open");

completed=0;

if(cd_info.tracks!=0)
{
free_list();
for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;
cd_info.tracks=0;
}
return 1;
}
else
if(s==3)
{
gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Drive Not Ready");
if(cd_info.tracks!=0)
{
free_list();
for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;
cd_info.tracks=0;
}
return 1;
}
else
if(s==4)
{

 if(is_audio_cd(cd_handle) && cd_info.title==NULL)
   gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Unkown CD");
 else
if(is_audio_cd(cd_handle) && cd_info.title!=NULL)
  gtk_entry_set_text((GtkEntry*)main_window_cd_entry,cd_info.title);
 else
 if(!is_audio_cd(cd_handle))
  gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Non Audio CD");

}


 if(s==4)   /* good CD */
 {
   r=status_cd(cd_handle);

  if(r==0x11)
  {

    sprintf(cdbuff,"Track %s",cd_info.c_tracks[status.cdsc_trk-1].title);
    gtk_entry_set_text((GtkEntry*)main_window_cd_entry,cdbuff);
    return 1;
  }
  else
  if(r==0x13)
  {
   gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Completed");
   completed=1;
   return 1;
  }

  else
  if(r==0x12)
  {
  gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Paused");
   return 1;
  }
  else
  if(r==0x14)
  {
   gtk_entry_set_text((GtkEntry*)main_window_cd_entry,"Audio Error");
   return 1;
  }

if(s==4 && is_audio_cd(cd_handle))
{


if(cd_changed)
{
cd_changed=0;
free_list();
for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;
cd_info.tracks=0;

}


if(cd_info.tracks==0)
{
 bizzo();
}


if(cd_autoplay&&!completed)
{
gtk_clist_select_row((GtkCList*)main_window_cdlist,0,0);
completed=1;
}
return 1;
}


} /* if s == 100 */




return 1;
}

void
on_main_window_playcd_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_clist_select_row((GtkCList*)main_window_cdlist,0,0);
}


void
on_main_window_stop_cd_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
stop_cd(cd_handle);
completed=1;
}


void
on_main_window_cdprev_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
struct cdrom_subchnl status;
status.cdsc_format=CDROM_MSF;
ioctl(cd_handle,CDROMSUBCHNL,&status);
if(status.cdsc_audiostatus!=0 && status.cdsc_audiostatus!=0x11)
{
gtk_clist_select_row((GtkCList*)main_window_cdlist,0,0);
}
else
if(status.cdsc_trk-1>0)
gtk_clist_select_row((GtkCList*)main_window_cdlist,status.cdsc_trk-2,0);

}


void
on_main_window_cd_next_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
struct cdrom_subchnl status;
struct cdrom_tochdr toc;

ioctl(cd_handle, CDROMREADTOCHDR, &toc);
status.cdsc_format=CDROM_MSF;
ioctl(cd_handle,CDROMSUBCHNL,&status);

if(status.cdsc_audiostatus!=0 && status.cdsc_audiostatus!=0x11)
{
gtk_clist_select_row((GtkCList*)main_window_cdlist,0,0);
}
else
if(status.cdsc_trk+1<toc.cdth_trk1-toc.cdth_trk0+2)
{
gtk_clist_select_row((GtkCList*)main_window_cdlist,status.cdsc_trk,0);
}
}


void
on_main_window_cd_pause_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
pause_cd(cd_handle);
}


void
on_main_window_cd_resume_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
resume_cd(cd_handle);
}



void
on_main_window_cd_autoplay_toggled     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
cd_autoplay=gtk_toggle_button_get_active((GtkToggleButton *)togglebutton);
}


void
on_main_window_cd_eject_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
eject_cd(cd_handle);
}



void bizzo()
{
int id,num,back;
cddb_conn_t *conn = NULL;   /* libcddb connection structure */
cddb_disc_t *disc=NULL;   /* libcddb disc structure */
FILE *fptr;
char *ebuff;
struct cdrom_tochdr cdth;
int i,matches;
cddb_track_t *track=NULL;

/*
GtkWidget *wc;

wc=create_cddb_window ();
gtk_widget_show(wc);
*/

id=get_disc_id();

strcpy(p,getenv("HOME"));
strcat(p,"/sonic-rainbow");
mkdir(p,S_IRWXU|S_IRWXG|S_IRWXO);
strcat(p,"/cddb");
mkdir(p,S_IRWXU|S_IRWXG|S_IRWXO);
sprintf(p,"%s/%0x",p,id);


if((fptr=fopen(p,"rb"))!=NULL)
{
fclose(fptr);
if(file_read()==1)
{
/*gtk_widget_destroy(wc);*/
return;
}
if(!play_error)
{
/*gtk_widget_destroy(wc);*/
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"File %s\nis corrupt Sonic-Rainbow will attempt to re-create\nit from Freedb. If the details are listed as\nUnknown, Sonic-Rainbow was unable to re-create\nthe file from the net and it may be best to\ndelete the file. The file can only be re-created\nif you are connected to the internet when you load\nthe CD with Sonic-Rainbow running",p);
   do_error_message(ebuff);
   free(ebuff);
   }
}


id=get_disc_id();

if(!http_lookup)
{
conn = cddb_new();
if (conn)
{
disc=cddb_disc_new();

cddb_disc_set_length(disc,disc_time);

for (i = 0; i < disc_tracks; i++)
{
    track = cddb_track_new();
    if (track == NULL)
    {
      /* memory error */
      /* need to handle this */
    }
    cddb_track_set_frame_offset(track,frames[i]+SECONDS_TO_FRAMES(2));
    cddb_disc_add_track(disc, track);
}


matches = cddb_query(conn, disc);


if(matches>0)
{
  for(i=1;i<matches;i++)
  {
   if(id==disc->discid)break;
   back=cddb_query_next(conn,disc);
   }


    back=cddb_read(conn,disc);
    if(back)
    {
     if(do_display(disc));
     /*gtk_widget_destroy(wc);*/
     return;
    }

    ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
    cd_info.tracks=cdth.cdth_trk1;

    free_list();

    for(num=0;num<100;num++)
    {
     free(cd_info.c_tracks[num].title);
     free(cd_info.c_tracks[num].artist);
     cd_info.c_tracks[num].title=NULL;
     cd_info.c_tracks[num].artist=NULL;
    }

    free(cd_info.title);
    free(cd_info.artist);
    free(cd_info.genre);
    cd_info.title=NULL;
    cd_info.artist=NULL;
    cd_info.genre=NULL;

   for(num=0;num<cd_info.tracks;num++)
   {
    cd_info.c_tracks[num].title=(char*)malloc(20);
    sprintf(cd_info.c_tracks[num].title,"%d ",num+1);
    strcat(cd_info.c_tracks[num].title,"Unknown CD");
    fill_list(cd_info.c_tracks[num].title);
    cd_info.c_tracks[num].artist=(char*)malloc(20);
    strcpy(cd_info.c_tracks[num].artist,"Unknown CD");
   }
/*gtk_widget_destroy(wc);*/
   return;
  }

}
}


ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
cd_info.tracks=cdth.cdth_trk1;

if(list_item)
free_list();

for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;


for(num=0;num<cd_info.tracks;num++)
{
cd_info.c_tracks[num].title=(char*)malloc(20);
sprintf(cd_info.c_tracks[num].title,"%d ",num+1);
strcat(cd_info.c_tracks[num].title,"Unknown CD");
fill_list(cd_info.c_tracks[num].title);

cd_info.c_tracks[num].artist=(char*)malloc(20);
strcpy(cd_info.c_tracks[num].artist,"Unknown CD");
}
/*gtk_widget_destroy(wc);*/
return;
}




int get_disc_id()
{
    struct toc {
    int min, sec, frame;
    } cdtoc[100];
    struct cdrom_tochdr tochdr;
    struct cdrom_tocentry tocentry;
    unsigned int i, t = 0, n = 0;


disc_time=0;

if((ioctl(cd_handle, CDROMREADTOCHDR, &tochdr))==-1){printf("-1\n");}
    for (i = tochdr.cdth_trk0; i <= tochdr.cdth_trk1; i++) {
        tocentry.cdte_track = i;
        tocentry.cdte_format = CDROM_MSF;
        ioctl(cd_handle, CDROMREADTOCENTRY, &tocentry);
        cdtoc[i-1].min = tocentry.cdte_addr.msf.minute;
        cdtoc[i-1].sec = tocentry.cdte_addr.msf.second;
        cdtoc[i-1].frame = tocentry.cdte_addr.msf.frame;
        cdtoc[i-1].frame += cdtoc[i-1].min*60*75;
        cdtoc[i-1].frame += cdtoc[i-1].sec*75;
        frames[i-1]=cdtoc[i-1].frame;


    }
    disc_tracks=tochdr.cdth_trk1;

    tocentry.cdte_track = 0xAA;
    tocentry.cdte_format = CDROM_MSF;
    ioctl(cd_handle, CDROMREADTOCENTRY, &tocentry);
    cdtoc[tochdr.cdth_trk1].min = tocentry.cdte_addr.msf.minute;
    cdtoc[tochdr.cdth_trk1].sec = tocentry.cdte_addr.msf.second;
    disc_time=cdtoc[tochdr.cdth_trk1].min * 60;
    disc_time=disc_time+cdtoc[tochdr.cdth_trk1].sec;

    cdtoc[tochdr.cdth_trk1].frame = tocentry.cdte_addr.msf.frame;
    cdtoc[tochdr.cdth_trk1].frame += cdtoc[tochdr.cdth_trk1].min*60*75;
    cdtoc[tochdr.cdth_trk1].frame += cdtoc[tochdr.cdth_trk1].sec*75;


    i = 0;
    while (i < tochdr.cdth_trk1) {
      n = n + cddb_sum((cdtoc[i].min * 60) + cdtoc[i].sec);
      i++;
    }

    t = ((cdtoc[tochdr.cdth_trk1].min * 60) + cdtoc[tochdr.cdth_trk1].sec) -
      ((cdtoc[0].min * 60) + cdtoc[0].sec);
    disc_time=disc_time-2;


    return ((n % 0xff) << 24 | t << 8 | tochdr.cdth_trk1);

}


unsigned int cddb_sum(int n) {
    unsigned int ret;

    ret = 0;
    while (n > 0) {
      ret += (n % 10);
      n /= 10;
    }
    return ret;
}



#define STR_OR_NULL(s) ((s) ? s : "(null)")

int file_read()
{
    int num;
    FILE *fptr;
    struct cdrom_tochdr cdth;
 char tmp[1000];



   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
      return -2;

cd_info.tracks=cdth.cdth_trk1;

for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;





fptr=fopen(p,"rb");

    /* 1. The artist name, disc title and extended data. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr);return -1;}
tmp[strlen(tmp)-1]=0;
cd_info.artist=(char *)malloc(strlen(tmp)+1);
strcpy(cd_info.artist,tmp);

if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(cd_info.artist); cd_info.artist=NULL;return -1;}
tmp[strlen(tmp)-1]=0;
cd_info.title=(char *)malloc(strlen(tmp)+1);
strcpy(cd_info.title,tmp);

    /* 2. The music genre.  This field is similar to the category*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(cd_info.artist); free(cd_info.title);cd_info.artist=NULL;
cd_info.title=NULL; return -1;}
tmp[strlen(tmp)-1]=0;
cd_info.genre=(char *)malloc(strlen(tmp)+1);
strcpy(cd_info.genre,tmp);



    /* 3. The disc year. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);
cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL; return -1;}

    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
 /*   length = cddb_disc_get_length(disc);*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;return -1;}
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;return -1;}

free_list();

    for (num=0;num<cd_info.tracks;num++)
 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */

       if(( fgets(tmp,500,fptr))==NULL)
       {
 fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);
 cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;
 for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}
free_list();
 return -1;
       }

        /* 5.b. The track artist name and title. */

if((fgets(tmp,500,fptr))==NULL)
{
 fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);
 cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;
 for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}
free_list();
 return -1;
}

tmp[strlen(tmp)-1]=0;
cd_info.c_tracks[num].title=(char*)malloc(strlen(tmp)+4);
sprintf(cd_info.c_tracks[num].title,"%d ",num+1);
strcat(cd_info.c_tracks[num].title,tmp);
fill_list(cd_info.c_tracks[num].title);

if((fgets(tmp,500,fptr))==NULL)
{
 fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);
 cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;
 for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}
free_list();
 return -1;
}
tmp[strlen(tmp)-1]=0;
cd_info.c_tracks[num].artist=(char*)malloc(strlen(tmp)+1);
strcpy(cd_info.c_tracks[num].artist,tmp);
        /* 5.c. The track length. */
if((fgets(tmp,500,fptr))==NULL)
{
 fclose(fptr); free(cd_info.genre);free(cd_info.artist); free(cd_info.title);
 cd_info.artist=NULL;cd_info.title=NULL;cd_info.genre=NULL;
 for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}
free_list();
 return -1;
}


    }
fclose(fptr);
return 1;
}


#define STR_OR_NULL(s) ((s) ? s : "(null)")

int do_display(cddb_disc_t *disc)
{
    cddb_track_t *track = NULL; /* libcddb track structure */
    int length,num;
    FILE *fptr;
char *ebuff;

struct cdrom_tochdr cdth;
    int ret=1;
    int db=1;

   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
   {
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot read from CDROM Drive");
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
      return -1;
}


for(num=0;num<100;num++)
{
free(cd_info.c_tracks[num].title);
free(cd_info.c_tracks[num].artist);
cd_info.c_tracks[num].title=NULL;
cd_info.c_tracks[num].artist=NULL;
}

free(cd_info.title);
free(cd_info.artist);
free(cd_info.genre);
cd_info.title=NULL;
cd_info.artist=NULL;
cd_info.genre=NULL;
cd_info.tracks=0;

cd_info.tracks=cdth.cdth_trk1;


if((fptr=fopen(p,"wb"))==NULL)
{
if(!play_error)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create File\n%s\nThis may be a permissions based problem",p);
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
}
}

free_list();

    /* 1. The artist name, disc title and extended data. */
cd_info.artist=(char *)malloc(strlen(STR_OR_NULL(cddb_disc_get_artist(disc)))+1);
strcpy(cd_info.artist,STR_OR_NULL(cddb_disc_get_artist(disc)));
cd_info.title=(char*)malloc( strlen(cddb_disc_get_title(disc))+1);
strcpy(cd_info.title,cddb_disc_get_title(disc));

if(fptr)
    if((ret=fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_artist(disc))))!=strlen(STR_OR_NULL(cddb_disc_get_artist(disc))))
     db=0;
if(fptr)
    if((ret=fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_title(disc))))!=strlen(STR_OR_NULL(cddb_disc_get_title(disc))))
     db=0;

    /* 2. The music genre.  This field is similar to the category
       field initialized above.  It can be the same but it does not
       have to be.  The category can only be come from a set of CDDB
       predefined categories.  The genre can be any string. */
cd_info.genre=(char*)malloc(strlen(STR_OR_NULL(cddb_disc_get_genre(disc)))+1);
strcpy(cd_info.genre,STR_OR_NULL(cddb_disc_get_genre(disc)));

if(fptr)
    if((ret=fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_genre(disc))))!=strlen(STR_OR_NULL(cddb_disc_get_genre(disc))))
    db=0;


    /* 3. The disc year. */
if(fptr)
    fprintf(fptr,"%d\n", cddb_disc_get_year(disc));

    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
    length = cddb_disc_get_length(disc);
if(fptr)
{
    fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
    fprintf(fptr,"%d\n", cddb_disc_get_track_count(disc));
}
    /* 5. The tracks.  Track iteration can either be done by counting
       from 0 to (track_count - 1) and using the cddb_disc_get_track
       function.  Or by using the built-in iterator functions
       cddb_disc_get_track_first and cddb_disc_get_track_next.  We'll
       use the latter approach in this example. */


    for (track = cddb_disc_get_track_first(disc);
         track != NULL;
         track = cddb_disc_get_track_next(disc))


 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */
if(fptr)
{
        fprintf(fptr,"%d\n", cddb_track_get_number(track));

        /* 5.b. The track artist name and title. */

        fprintf(fptr,"%s\n%s\n", cddb_track_get_title(track), cddb_track_get_artist(track));
}

cd_info.c_tracks[cddb_track_get_number(track)-1].title=(char*)malloc(strlen(cddb_track_get_title(track))+4);
sprintf(cd_info.c_tracks[cddb_track_get_number(track)-1].title,"%d ",cddb_track_get_number(track));
strcat(cd_info.c_tracks[cddb_track_get_number(track)-1].title,cddb_track_get_title(track));
cd_info.c_tracks[cddb_track_get_number(track)-1].artist=(char*)malloc(strlen(cddb_track_get_artist(track))+1);
strcpy(cd_info.c_tracks[cddb_track_get_number(track)-1].artist,cddb_track_get_artist(track));

fill_list(cd_info.c_tracks[cddb_track_get_number(track)-1].title);

        /* 5.c. The track length. */
        length = cddb_track_get_length(track);

        if (length != -1) {
	 if(fptr)
            fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
        } else {
	if(fptr);
            fprintf(fptr,"0:0");
        }


    }
    if(fptr);
fclose(fptr);
return 1;
}






void
on_main_window_cd_entry_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{
/*
cd_entry=widget;
*/
}


void
on_main_window_listbutton_clicked      (GtkButton       *button,
                                        gpointer         user_data)
{
if(tog==0)
{
tog=1;
gtk_widget_show(main_window_cdscrolled);
gtk_widget_show(main_window_cdlist);
}
else
{
tog=0;
gtk_widget_hide(main_window_cdlist);
gtk_widget_hide(main_window_cdscrolled);
}

}

void
on_main_window_cdscrolled_map          (GtkWidget       *widget,
                                        gpointer         user_data)
{
/*
cd_scrolled=widget;

if(!scrolled_first)
{
gtk_widget_hide(widget);
scrolled_first=1;
}
*/
}




void free_list()
{
gtk_clist_clear((GtkCList*)main_window_cdlist);
}


void fill_list(char buffer[])
{
char *dat[3];

    dat[0]=buffer;
    dat[1]=NULL;
    gtk_clist_append((GtkCList *)main_window_cdlist,dat);
}


void
on_main_window_cd_autoplay_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_toggle_button_set_active((GtkToggleButton*)main_window_cd_autoplay,cd_autoplay);
}




void
on_main_window_cdlist_select_row       (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
tog=0;
gtk_widget_hide(main_window_cdlist);
gtk_widget_hide(main_window_cdscrolled);
play_cd(cd_handle,row+1);
}


void
on_main_window_cdlist_unselect_row     (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{

}


void
on_main_window_cdlist_map              (GtkWidget       *widget,
                                        gpointer         user_data)
{
/*
cd_list=widget;


if(!list_first)
{
gtk_widget_hide(widget);
list_first=1;
}
*/
}


void
on_main_window_cdlist_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


