 /*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

Sonic Rainbow (c) 2003-2010 Gary Baker http://ozscap.sourceforge.net
*/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtk.h>
#include <cddb/cddb.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/cdrom.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/poll.h>
#include "cddev.h"
#include "cd.h"
#include "interface.h"
#include <cdda_interface.h>
#include <cdda_paranoia.h>
#include <vorbis/vorbisenc.h>
#include <time.h>
#include <lame/lame.h>
#include <id3tag.h>
#include <id3.h>
#include "charset.h"
#include "vcedit.h"
#include <pthread.h>
#include <sys/select.h>
#include <FLAC/all.h>

#define ENV_HTTP_PROXY "http_proxy"
#define HTTP_PREFIX "http://"
#define HTTP_PREFIX_LEN 7

#define READ 1024
signed char readbuffer[READ*4+44];

FLAC__bool set_vc_field(const char *filename, FLAC__StreamMetadata *block, char *field, FLAC__bool *needs_write, FLAC__bool raw);
int add_flac_tag(char *fname,int c);
int wav_to_flac(char *flac,char *wav,int cnum);
int wav_to_mp3(char *targ,char *src,int,int);
void add_mp3_tag(char *tag_file,int c);
static void cd_encode_thread(void *);
int getline(char *s,int);
int ugetline(char *s,int);
char ebuff[1000],ebuff1[1000],ebase[1000];
char eb[1000],esfile[1000];

int rquality,rtype=0;

extern char *cats[];/*={"soundtrack","rock","jazz","misc","country","blues","newage","reggae","classical","folk"};*/
extern guint cd_timer;
extern char *music_dir,*cd_dev;
extern int rip_timer;
extern int http_lookup;
extern int cd_changed;
extern char *ddata;

int fdes[2];
int gdes[2];

static cdrom_drive *d=NULL;
static cdrom_paranoia *p=NULL;
int *global_rip_smile_level;
void cdda_to_wav(char *wf,int tn,int r);
static void WriteWav(int f,long bytes);
static void PutNum(long num,int f,int endianness,int bytes);
static void CDPCallback(long inpos,int function);
int wav_to_ogg(char *targ,char *sour,int r);
gboolean add_ogg_tag (char *tfile,int c);
int encoded=0;
int thread_finished=0;
char tbuff[100];
char rtbuff[100];

GtkWidget* create_single_dir_window (char *sd);
int get_disc_id();
unsigned int cddb_sum(int n);
void do_display(cddb_disc_t *disc);
void bizzo();
int get_disc_id();
unsigned int cddb_sum(int n);
void do_display(cddb_disc_t *disc);
int rfile_read();
int ripper_cd();
void list_disc();
void rfree_list();
void fill_list(char []);
void free_list();
void rfill_list(char buffer[],int );
int list_from_net(cddb_disc_t *disc);
int rfgets(FILE *fptr,char *b);
void on_rippper_window_ripsel_clicked       (GtkButton       *button,
                                        gpointer         user_data);
gboolean Ogg_Tag_Write_File (FILE *file_in, gchar *filename_in, vcedit_state *state);

/*g_list_free */
void do_error_message(char *text);
void do_ripcd(void);
void up_ripcd();

extern int cd_handle,completed;
extern int cd_autoplay,cddb;
extern char *cd_dev;
extern GtkWidget *cd_entry;
extern GtkWidget *ripw;

GtkWidget *progressbar1;
GtkWidget *rip_list,*cdtitle_entry,*cdartist_entry,*cdgenre_entry,*cdyear_spin;
GtkWidget *trackname_entry,*trackartist_entry;
GtkWidget *rip_fixed,*rip_win,*music_direntry,*ogg_form,*wav_form;
GtkWidget *exit_clicked,*cancel_clicked,*ripsel_clicked,*ripcd_clicked,*rqal;
GtkWidget *flac;

int stop_rip;
int ignore=0;
int my_idle;
lame_global_flags *gfp=NULL;

int play_cdauto();
int disk_present=0;
int rselnum=-1;
int sel_tracks[100];
int pt=0;

struct stat st;

void
on_ripper_window_track_title_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data);
char l[1000];
GtkWidget *rlist_item=NULL;
int prog;

typedef struct _cd_track
{
int tracknum;
char *title;
char *artist;
int length;
}cd_tracks;

struct rcds
{
int tracks;
char *title;
char *artist;
char *genre;
char *year;
cd_tracks c_tracks[100];
}rcd_info;


int frames[100];
int disc_time;
unsigned int disc_tracks;


void
on_ripper_window_exit_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
exit_clicked=widget;
}


void
on_ripper_window_cancel_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{
cancel_clicked=widget;
}


void
on_ripper_window_ripcd_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
ripcd_clicked=widget;
}


void
on_rippper_window_ripsel_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
ripsel_clicked=widget;
}









void
on_cdripper_list_select_row            (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_signal_handler_block_by_func((GtkObject *)trackname_entry,on_ripper_window_track_title_entry_changed,NULL);
rselnum=row;
gtk_entry_set_text((GtkEntry *)trackname_entry,rcd_info.c_tracks[rselnum].title);
gtk_entry_set_text((GtkEntry *)trackartist_entry,rcd_info.c_tracks[rselnum].artist);
sel_tracks[rselnum]=1;
gtk_signal_handler_unblock_by_func((GtkObject*)trackname_entry,on_ripper_window_track_title_entry_changed,NULL);
}


void
on_cdripper_list_unselect_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
rselnum=row;
sel_tracks[rselnum]=0;
}


void
on_cdripper_list_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
if(disk_present==0)disk_present=-1;
rip_list=widget;
}



void
on_ripper_window_track_title_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data)
{
char *b;
char nbuff[1000];

b=gtk_entry_get_text((GtkEntry *)trackname_entry);
free(rcd_info.c_tracks[rselnum].title);
rcd_info.c_tracks[rselnum].title=(char*)malloc(strlen(b)+1);
strcpy(rcd_info.c_tracks[rselnum].title,b);
sprintf(nbuff,"%d ",rselnum+1);
strcat(nbuff,b);
gtk_clist_set_text((GtkCList*)rip_list,rselnum,0,nbuff);
}

void
on_ripper_window_track_artist_entry_changed
                                        (GtkEditable     *editable,
                                        gpointer         user_data)
{
char *b;
char nbuff[1000];

b=gtk_entry_get_text((GtkEntry *)trackartist_entry);
free(rcd_info.c_tracks[rselnum].artist);
rcd_info.c_tracks[rselnum].artist=(char*)malloc(strlen(b)+1);
strcpy(rcd_info.c_tracks[rselnum].artist,b);
strcpy(nbuff,b);
gtk_clist_set_text((GtkCList*)rip_list,rselnum,1,nbuff);
}



void
on_fixed1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
rip_fixed=widget;
ignore=0;
pt=0;
}

void
on_ripper_window_artist_entry_realize  (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdartist_entry=widget;
}

void
on_ripper_window_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
rip_win=widget;
gtk_timeout_remove(cd_timer);
}



void
on_ripper_window_exit_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
int num;
disk_present=0;

stop_rip=1;


gtk_clist_clear((GtkCList*)rip_list);

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}


free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

gtk_timeout_remove(rip_timer);
pt=0;
 disk_present=0;

 gtk_widget_destroy(ripw);

if(ripw!=NULL)
 ripw=NULL;

cd_timer=gtk_timeout_add(250,play_cdauto,NULL);
}


void
on_ripper_window_cancel_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
stop_rip=1;
}






void
on_ripper_window_ripcd_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

if(pt==0)
{
pt=1;
do_ripcd();
}


}



void do_ripcd(void)
{

 int count=0;
 char buff[1000],buff1[1000],*token,ubuff[100];
 char mdir[1000];
 pthread_t ptsa;
 int back;
 int quality=10;
 if(ignore==1)return;
 ignore=1;


encoded=0;
thread_finished=0;
stop_rip=0;

quality=gtk_spin_button_get_value_as_int ((GtkSpinButton*)rqal);
rquality=gtk_spin_button_get_value_as_int ((GtkSpinButton*)rqal);


if(!gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
if(gtk_toggle_button_get_active((GtkToggleButton*)ogg_form))
rtype=1;
else
if(gtk_toggle_button_get_active((GtkToggleButton*)flac))
rtype=3;
else
rtype=2;
pipe(fdes);
pipe(gdes);
pthread_create(&ptsa,NULL,(void *)cd_encode_thread,NULL);
}


 strcpy(mdir,gtk_entry_get_text((GtkEntry *)music_direntry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
/* strcat(mdir,rcd_info.artist);*/
strcat(mdir,gtk_entry_get_text((GtkEntry *)cdartist_entry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 /*strcat(mdir,rcd_info.title);*/
strcat(mdir,gtk_entry_get_text((GtkEntry *)cdtitle_entry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");


gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);


while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
gtk_clist_set_text((GtkCList*)rip_list,count,2,"");


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
{
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripping");
stop_rip=0;
sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
cdda_to_wav(buff,count+1,count);
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripped");
if(!gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
sprintf(buff1,"%s\n%s\n%d\n",buff,mdir,count);
write(fdes[1],buff1,strlen(buff1));
encoded=1;
}
if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
if(stop_rip==1)break;
}  /* for tracks */

if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{

gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);

gtk_clist_unselect_all((GtkCList*)rip_list);
ignore=0;
stop_rip=0;
pt=0;
return;
}



encoded=2;
sprintf(buff1,"finished\n");
write(fdes[1],buff1,strlen(buff1));

while(1)
{
back=ugetline(ubuff,gdes[0]);
if(back)
{
token=strtok(ubuff," ");
back=atoi(token);
token=strtok(NULL,"\0");
gtk_clist_set_text((GtkCList*)rip_list,back,2,token);
}
else
sleep(1);

   while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
if(stop_rip || thread_finished)
{
encoded=0;
gtk_widget_destroy(progressbar1);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
gtk_clist_unselect_all((GtkCList*)rip_list);
ignore=0;
close(fdes[0]);
close(fdes[1]);
close(gdes[0]);
close(gdes[1]);
return;
}

}

}







int rfgets(FILE *fptr,char *b)
{
int num,n=0;


for(num=0;num<100;num++)
{
if(stop_rip==1)break;
n=fread(b+num,sizeof(char),1,fptr);
if(n==0)break;
if(b[num]=='\r')break;
if(b[num]=='\n')break;
}
b[num]=0;
return n;
}




void
on_rippper_window_ripsel_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
 int count=0;
 char buff[1000],buff1[1000],mdir[1000];
 int back;
 char *token,ubuff[100];
 int quality;
 pthread_t ptas;

 if(ignore==1)return;
 ignore=1;

encoded=0;
thread_finished=0;
stop_rip=0;
encoded=count;


quality=gtk_spin_button_get_value_as_int ((GtkSpinButton*)rqal);
rquality=gtk_spin_button_get_value_as_int ((GtkSpinButton*)rqal);

if(!gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
if(gtk_toggle_button_get_active((GtkToggleButton*)ogg_form))
rtype=1;
else
if(gtk_toggle_button_get_active((GtkToggleButton*)flac))
rtype=3;
else
rtype=2;

pipe(fdes);
pipe(gdes);
pthread_create(&ptas,NULL,(void*)cd_encode_thread,NULL);
}

 strcpy(mdir,gtk_entry_get_text((GtkEntry *)music_direntry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 /*strcat(mdir,rcd_info.artist);*/
strcat(mdir,gtk_entry_get_text((GtkEntry *)cdartist_entry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");
 /*strcat(mdir,rcd_info.title);*/
strcat(mdir,gtk_entry_get_text((GtkEntry *)cdtitle_entry));
 mkdir(mdir,S_IRWXU|S_IRWXG|S_IRWXO);
 strcat(mdir,"/");


gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,FALSE);
gtk_entry_set_editable((GtkEntry*)music_direntry,FALSE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_block_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
gtk_clist_set_text((GtkCList*)rip_list,count,2,"");


for(count=0;count<rcd_info.tracks;count++) /* outer for loop */
{
if(sel_tracks[count]!=1)continue;

gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripping");
stop_rip=0;
sprintf(buff,"%s/track%.2d.wav",mdir,count+1);
cdda_to_wav(buff,count+1,count);
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Ripped");
if(!gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
sprintf(buff1,"%s\n%s\n%d\n",buff,mdir,count);
write(fdes[1],buff1,strlen(buff1));
encoded=1;
}
if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
gtk_clist_set_text((GtkCList*)rip_list,count,2,"Finished");
if(stop_rip==1)break;
}  /* for tracks */


if(gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{

gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
gtk_clist_unselect_all((GtkCList*)rip_list);

ignore=0;
return;
}


encoded=2;
sprintf(buff1,"finished\n");
write(fdes[1],buff1,strlen(buff1));

while(1)
{
back=ugetline(ubuff,gdes[0]);
if(back)
{
token=strtok(ubuff," ");
back=atoi(token);
token=strtok(NULL,"\0");
gtk_clist_set_text((GtkCList*)rip_list,back,2,token);
}
else
sleep(1);

   while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
if(stop_rip || thread_finished)
{
encoded=0;
gtk_widget_destroy(progressbar1);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdtitle_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackname_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)trackartist_entry,TRUE);
gtk_entry_set_editable((GtkEntry*)music_direntry,TRUE);
gtk_entry_set_editable((GtkEntry*)cdgenre_entry,FALSE);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_select_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (rip_list),GTK_SIGNAL_FUNC (on_cdripper_list_unselect_row),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (exit_clicked),GTK_SIGNAL_FUNC (on_ripper_window_exit_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripcd_clicked),GTK_SIGNAL_FUNC (on_ripper_window_ripcd_clicked),NULL);
gtk_signal_handler_unblock_by_func(GTK_OBJECT (ripsel_clicked),GTK_SIGNAL_FUNC (on_rippper_window_ripsel_clicked),NULL);
gtk_clist_unselect_all((GtkCList*)rip_list);
close(gdes[0]);
close(gdes[1]);
close(fdes[0]);
close(fdes[1]);
ignore=0;
return;
}

}


}


void
on_ripper_window_title_entry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdtitle_entry=widget;
}


void
on_ripper_window_genre_entry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdgenre_entry=widget;
}


void
on_ripper_window_year_spin_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{
cdyear_spin=widget;
}


void
on_ripper_window_year_spin_changed     (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void
on_ripper_window_track_artist_entry_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
trackartist_entry=widget;
}



void
on_ripper_window_track_title_entry_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{
trackname_entry=widget;
}


int ripper_cd()
{
struct cdrom_subchnl status;
int s,num;

if(rip_list==NULL)return 1;

 if(cd_handle<1)
   cd_handle=open_cd(cd_dev);



   status.cdsc_format=CDROM_MSF;
   ioctl(cd_handle,CDROMSUBCHNL,&status);

   s=drive_status_cd(cd_handle);


if(s==1) /* no disc */
{
disk_present=-1;
cd_changed=1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

return 1;
}

else
if(s==2) /* tray open */
{
cd_changed=1;
disk_present=-1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

return 1;
}
else
if(s==3) /* drive not ready */
{
disk_present=-1;
cd_changed=1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
sel_tracks[num]=0;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

return 1;
}
else
if(s==4 && disk_present!=1)
{

 if(is_audio_cd(cd_handle) && rcd_info.title==NULL)
{
for(num=0;num<100;num++)
sel_tracks[num]=0;
 disk_present=1;
 list_disc();
cd_changed=1;
}

return 1;
}


 return 1;
}



void list_disc()
{
int id;
int matches,num,back;
    cddb_conn_t *conn = NULL;   /* libcddb connection structure */
    cddb_disc_t *disc=NULL;   /* libcddb disc structure */
    struct cdrom_tochdr cdth;
int i;
cddb_track_t *track=NULL;
gchar *dat[3];
char *ebuff=NULL;
FILE *fptr=NULL;


id=get_disc_id();


gtk_entry_set_text((GtkEntry*)music_direntry,music_dir);

strcpy(l,getenv("HOME"));
strcat(l,"/sonic-rainbow");
mkdir(l,S_IRWXU|S_IRWXG|S_IRWXO);
strcat(l,"/cddb");
mkdir(l,S_IRWXU|S_IRWXG|S_IRWXO);
sprintf(l,"%s/%0x",l,id);

if((fptr=fopen(l,"rb"))!=NULL)
{
fclose(fptr);
i=rfile_read();

if(i==1)return;

  ebuff=(char *)malloc(5000);
sprintf(ebuff,"File %s\nis corrupt Sonic-Rainbow will attempt to re-create\nit from Freedb. If the details are listed as\nUnknown, Sonic-Rainbow was unable to re-create\nthe file from the net and it may be best to\ndelete the file. The file can only be re-created\nif you are connected to the internet when you load\nthe CD with Sonic-Rainbow running",l);
   do_error_message(ebuff);
   free(ebuff);

}


if(!http_lookup)
{
id=get_disc_id();

conn = cddb_new();
if (conn)
{
disc=cddb_disc_new();

cddb_disc_set_length(disc,disc_time);


for (i = 0; i < disc_tracks; i++)
{
    track = cddb_track_new();
    if (track == NULL)
    {
      /* memory error */
      /* need to handle this */
    }
    cddb_track_set_frame_offset(track,frames[i]+SECONDS_TO_FRAMES(2));
    cddb_disc_add_track(disc, track);
}

matches = cddb_query(conn, disc);

if(matches>0)
{
for(i=1;i<matches;i++)
{
if(id==disc->discid)break;
back=cddb_query_next(conn,disc);
}

back=cddb_read(conn,disc);
if(back)
{
if(list_from_net(disc))
{
    cddb_disc_destroy(disc);
    cddb_destroy(conn);
return;
}

}
}


ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
rcd_info.tracks=cdth.cdth_trk1;

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

gtk_clist_clear((GtkCList*)rip_list);

    for (num=0;num<rcd_info.tracks;num++)
 {

rcd_info.c_tracks[num].title=(char*)malloc(8);
dat[0]=(char*)malloc(12);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,"Unknown");
strcat(dat[0],"Unknown");

rcd_info.c_tracks[num].artist=(char*)malloc(8);
dat[1]=(char*)malloc(12);
strcpy(rcd_info.c_tracks[num].artist,"Unknown");
strcpy(dat[1],"Unknown");
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
 }

rcd_info.artist=(char *)malloc(8);
strcpy(rcd_info.artist,"Unknown");
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);
rcd_info.title=(char *)malloc(8);
strcpy(rcd_info.title,"Unknown");
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);
rcd_info.genre=(char *)malloc(8);
strcpy(rcd_info.genre,"Unknown");
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,1980);
    cddb_disc_destroy(disc);
    cddb_destroy(conn);
return;
    }
}

ioctl(cd_handle,CDROMREADTOCHDR,&cdth) ;
rcd_info.tracks=cdth.cdth_trk1;
for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;

gtk_clist_clear((GtkCList*)rip_list);

    for (num=0;num<rcd_info.tracks;num++)
 {

rcd_info.c_tracks[num].title=(char*)malloc(8);
dat[0]=(char*)malloc(12);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,"Unknown");
strcat(dat[0],"Unknown");

rcd_info.c_tracks[num].artist=(char*)malloc(8);
dat[1]=(char*)malloc(12);
strcpy(rcd_info.c_tracks[num].artist,"Unknown");
strcpy(dat[1],"Unknown");
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
 }

rcd_info.artist=(char *)malloc(8);
strcpy(rcd_info.artist,"Unknown");
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

rcd_info.title=(char *)malloc(8);
strcpy(rcd_info.title,"Unknown");
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);
rcd_info.genre=(char *)malloc(8);
strcpy(rcd_info.genre,"Unknown");
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,1980);



   cddb_disc_destroy(disc);
    cddb_destroy(conn);

return;
}





#define STR_OR_NULL(s) ((s) ? s : "(null)")

int rfile_read()
{

    int num;
    FILE *fptr;
    struct cdrom_tochdr cdth;
    char tmp[1000];
    gchar *dat[3];

   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
      return -2;


rcd_info.tracks=cdth.cdth_trk1;

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;


gtk_clist_clear((GtkCList*)rip_list);

fptr=fopen(l,"rb");

    /* 1. The artist name, disc title and extended data. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr);return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.artist=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.artist,tmp);
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.artist); rcd_info.artist=NULL;return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.title=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.title,tmp);
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);

    /* 2. The music genre.  This field is similar to the category*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.artist); free(rcd_info.title);rcd_info.artist=NULL;
rcd_info.title=NULL; return -1;}
tmp[strlen(tmp)-1]=0;
rcd_info.genre=(char *)malloc(strlen(tmp)+1);
strcpy(rcd_info.genre,tmp);
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);


    /* 3. The disc year. */
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL; return -1;}
tmp[strlen(tmp)-1]=0;
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,atoi(tmp));
rcd_info.year=(char*)malloc(strlen(tmp)+1);
strcpy(rcd_info.year,tmp);

    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
 /*   length = cddb_disc_get_length(disc);*/
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);free(rcd_info.year);rcd_info.year=NULL;rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;return -1;}
if((fgets(tmp,500,fptr))==NULL){fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);free(rcd_info.year);rcd_info.year=NULL;rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;return -1;}
/*
    fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
    fprintf(fptr,"%d\n", cddb_disc_get_track_count(disc));
*/
    /* 5. The tracks.  Track iteration can either be done by counting
       from 0 to (track_count - 1) and using the cddb_disc_get_track
       function.  Or by using the built-in iterator functions
       cddb_disc_get_track_first and cddb_disc_get_track_next.  We'll
       use the latter approach in this example. */

    for (num=0;num<rcd_info.tracks;num++)
 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */

          if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;free(rcd_info.year);rcd_info.year=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }

        /* 5.b. The track artist name and title. */

if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;free(rcd_info.year);rcd_info.year=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
tmp[strlen(tmp)-1]=0;
rcd_info.c_tracks[num].title=(char*)malloc(strlen(tmp)+1);
dat[0]=(char*)malloc(strlen(tmp)+4);
sprintf(dat[0],"%d ",num+1);
strcpy(rcd_info.c_tracks[num].title,tmp);
strcat(dat[0],tmp);

if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;free(rcd_info.year);rcd_info.year=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
tmp[strlen(tmp)-1]=0;
rcd_info.c_tracks[num].artist=(char*)malloc(strlen(tmp)+1);
dat[1]=(char*)malloc(strlen(tmp)+1);
strcpy(rcd_info.c_tracks[num].artist,tmp);
strcpy(dat[1],tmp);
dat[2]=NULL;
        /* 5.c. The track length. */
if((fgets(tmp,500,fptr))==NULL)
	  {
	   fclose(fptr); free(rcd_info.genre);free(rcd_info.artist); free(rcd_info.title);
 rcd_info.artist=NULL;rcd_info.title=NULL;rcd_info.genre=NULL;free(rcd_info.year);rcd_info.year=NULL;
           for(num=0;num<100;num++)
            {
             free(rcd_info.c_tracks[num].title);
             free(rcd_info.c_tracks[num].artist);
             rcd_info.c_tracks[num].title=NULL;
            rcd_info.c_tracks[num].artist=NULL;
            }
            return -1;
          }
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);

    }
fclose(fptr);
return 1;
}



int list_from_net(cddb_disc_t *disc)
{
    cddb_track_t *track = NULL; /* libcddb track structure */
    int length,num=0;
    FILE *fptr;
char *ebuff;
struct cdrom_tochdr cdth;
gchar *dat[3];
int ret;
char sy[1000];


   if(ioctl(cd_handle,CDROMREADTOCHDR,&cdth)<0)
   {
     ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot read from CDROM Drive");
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
      return -1;
   }


gtk_clist_clear((GtkCList*)rip_list);

for(num=0;num<100;num++)
{
free(rcd_info.c_tracks[num].title);
free(rcd_info.c_tracks[num].artist);
rcd_info.c_tracks[num].title=NULL;
rcd_info.c_tracks[num].artist=NULL;
}

free(rcd_info.title);
free(rcd_info.artist);
free(rcd_info.genre);
free(rcd_info.year);
rcd_info.title=NULL;
rcd_info.artist=NULL;
rcd_info.genre=NULL;
rcd_info.year=NULL;
rcd_info.tracks=0;


rcd_info.tracks=cdth.cdth_trk1;

if((fptr=fopen(l,"wb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create File\n%s\nThis may be a permissions based problem",l);
   do_error_message(ebuff);
   free(ebuff);
   ret=-1;
}
    /* 1. The artist name, disc title and extended data. */
rcd_info.artist=(char *)malloc(strlen(STR_OR_NULL(cddb_disc_get_artist(disc)))+1);
strcpy(rcd_info.artist,STR_OR_NULL(cddb_disc_get_artist(disc)));
gtk_entry_set_text((GtkEntry *)cdartist_entry,rcd_info.artist);

rcd_info.title=(char*)malloc( strlen(cddb_disc_get_title(disc))+1);
strcpy(rcd_info.title,cddb_disc_get_title(disc));
gtk_entry_set_text((GtkEntry *)cdtitle_entry,rcd_info.title);

if(fptr)
{
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_artist(disc)));
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_title(disc)));
}
    /* 2. The music genre.  This field is similar to the category
       field initialized above.  It can be the same but it does not
       have to be.  The category can only be come from a set of CDDB
       predefined categories.  The genre can be any string. */
rcd_info.genre=(char*)malloc(strlen(STR_OR_NULL(cddb_disc_get_genre(disc)))+1);
strcpy(rcd_info.genre,STR_OR_NULL(cddb_disc_get_genre(disc)));
gtk_entry_set_text((GtkEntry *)cdgenre_entry,rcd_info.genre);

if(fptr)
    fprintf(fptr,"%s\n", STR_OR_NULL(cddb_disc_get_genre(disc)));

    /* 3. The disc year. */
if(fptr)
    fprintf(fptr,"%d\n", cddb_disc_get_year(disc));
    sprintf(sy,"%d", cddb_disc_get_year(disc));
gtk_spin_button_set_value((GtkSpinButton*)cdyear_spin,cddb_disc_get_year(disc));
rcd_info.year=(char*)malloc(strlen(sy)+1);
strcpy(rcd_info.year,sy);

    /* 4. The disc length and the number of tracks.  The length field
       is given in seconds. */
    length = cddb_disc_get_length(disc);
if(fptr)
{
    fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
    fprintf(fptr,"%d\n", cddb_disc_get_track_count(disc));
}
    /* 5. The tracks.  Track iteration can either be done by counting
       from 0 to (track_count - 1) and using the cddb_disc_get_track
       function.  Or by using the built-in iterator functions
       cddb_disc_get_track_first and cddb_disc_get_track_next.  We'll
       use the latter approach in this example. */


num=0;
    for (track = cddb_disc_get_track_first(disc);
         track != NULL;
         track = cddb_disc_get_track_next(disc))
 {

        /* 5.a. The track number on the disc.  This track number
           starts counting at 1.  So this is not the same number as
           the one used in cddb_disc_get_track. */
if(fptr)
{
        fprintf(fptr,"%d\n", cddb_track_get_number(track));
        fprintf(fptr,"%s\n%s\n", cddb_track_get_title(track),
               cddb_track_get_artist(track));
}

rcd_info.c_tracks[cddb_track_get_number(track)-1].title=(char*)malloc(strlen(cddb_track_get_title(track))+1);
strcpy(rcd_info.c_tracks[cddb_track_get_number(track)-1].title,cddb_track_get_title(track));
dat[0]=(char*)malloc(strlen(cddb_track_get_title(track))+4);
num++;
sprintf(dat[0],"%d ",num);
strcat(dat[0],cddb_track_get_title(track));

rcd_info.c_tracks[cddb_track_get_number(track)-1].artist=(char*)malloc(strlen(cddb_track_get_artist(track))+1);
dat[1]=(char*)malloc(strlen(cddb_track_get_artist(track))+1);
strcpy(dat[1],cddb_track_get_artist(track));
strcpy(rcd_info.c_tracks[cddb_track_get_number(track)-1].artist,cddb_track_get_artist(track));
dat[2]=NULL;
gtk_clist_append((GtkCList *)rip_list,dat);
free(dat[0]);
free(dat[1]);
free(dat[2]);
        /* 5.c. The track length. */
        length = cddb_track_get_length(track);

        if (length != -1) {
	if(fptr)
            fprintf(fptr,"%d:%02d\n", (length / 60), (length % 60));
        } else {
	if(fptr)
            fprintf(fptr,"0:0");
        }

    }
fclose(fptr);
return 1;
}

void
on_entry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
music_direntry=widget;
}




void
on_ripper_window_oggfile_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_toggle_button_set_active((GtkToggleButton*)widget,1);
ogg_form=widget;
}


void
on_setup_window_mp3_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_toggle_button_set_active((GtkToggleButton*)widget,1);
}


void on_edvd_clicked         (GtkButton       *button, gpointer         user_data)
{
int a;
a=open("/dev/dvd",O_RDONLY);
ioctl(a,CDROMEJECT);
close(a);
}

void
on_ripper_window_wav_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
wav_form=widget;
}


void
on_ripper_browse_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;

if(music_dir==NULL)exit(0);

f=create_single_dir_window (music_dir);
gtk_widget_show(f);
gtk_main();
if(ddata!=NULL)
{
gtk_entry_set_text((GtkEntry *)music_direntry,ddata);
free(music_dir);
music_dir=(char*)malloc(strlen(ddata)+1);
strcpy(music_dir,ddata);
free(ddata);
ddata=NULL;
}
gtk_widget_destroy(f);
}


void
on_qual_spin_realize                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
rqal=widget;
}


static void CDPCallback(long inpos,int function)
{
  static long c_sector=0,v_sector=0;
  static int last=0;
  static long lasttime=0;
  long sector,osector=0;
  struct timeval thistime;
  static char heartbeat=' ';
  static int overlap=0;
  static int slevel=0;
  static int slast=0;
  static int stimeout=0;
  long test;

  osector=inpos;
  sector=inpos/CD_FRAMEWORDS;
return;

  if(function==-2){
    v_sector=sector;
    return;
  }

  if(function==-1){
    last=8;
    heartbeat='*';
    slevel=0;
    v_sector=sector;
  } else
    switch(function){
    case PARANOIA_CB_VERIFY:
      if(stimeout>=30) {
	if(overlap>CD_FRAMEWORDS)
	  slevel=2;
	else
	  slevel=1;
      }
      break;
    case PARANOIA_CB_READ:
      if(sector>c_sector)c_sector=sector;
      break;

    case PARANOIA_CB_FIXUP_EDGE:
      if(stimeout>=5) {
	if(overlap>CD_FRAMEWORDS)
	  slevel=2;
	else
	  slevel=1;
      }
      break;
    case PARANOIA_CB_FIXUP_ATOM:
      if(slevel<3 || stimeout>5)slevel=3;
      break;
    case PARANOIA_CB_READERR:
      slevel=6;
      break;
    case PARANOIA_CB_SKIP:
      slevel=8;
      break;
    case PARANOIA_CB_OVERLAP:
      overlap=osector;
      break;
    case PARANOIA_CB_SCRATCH:
      slevel=7;
      break;
    case PARANOIA_CB_DRIFT:
      if(slevel<4 || stimeout>5)slevel=4;
      break;
    case PARANOIA_CB_FIXUP_DROPPED:
    case PARANOIA_CB_FIXUP_DUPED:
      slevel=5;
      break;
    }


  gettimeofday(&thistime,NULL);
  test=thistime.tv_sec*10+thistime.tv_usec/100000;

  if(lasttime!=test || function==-1 || slast!=slevel){
    if(lasttime!=test || function==-1){
      last++;
      lasttime=test;
      if(last>7)last=0;
      stimeout++;
      switch(last){
      case 0:
	heartbeat=' ';
	break;
      case 1:case 7:
	heartbeat='.';
	break;
      case 2:case 6:
	heartbeat='o';
	break;
      case 3:case 5:
	heartbeat='0';
	break;
      case 4:
	heartbeat='O';
	break;
      }

      if(function==-1)
	heartbeat='*';

    }
    if(slast!=slevel){
      stimeout=0;
    }
    slast=slevel;
  }

  if(slevel<8&&slevel>0) *global_rip_smile_level=slevel-1;
  else *global_rip_smile_level=0;
}





static void PutNum(long num,int f,int endianness,int bytes)
{
  int i;
  unsigned char c;

  if(!endianness)
    i=0;
  else
    i=bytes-1;
  while(bytes--){
    c=(num>>(i<<3))&0xff;
    if(write(f,&c,1)==-1){
      perror("Could not write to output.");
      exit(1);
    }
    if(endianness)
      i--;
    else
      i++;
  }
}

static void WriteWav(int f,long bytes)
{
  /* quick and dirty */

  write(f,"RIFF",4);               /*  0-3 */
  PutNum(bytes+44-8,f,0,4);        /*  4-7 */
  write(f,"WAVEfmt ",8);           /*  8-15 */
  PutNum(16,f,0,4);                /* 16-19 */
  PutNum(1,f,0,2);                 /* 20-21 */
  PutNum(2,f,0,2);                 /* 22-23 */
  PutNum(44100,f,0,4);             /* 24-27 */
  PutNum(44100*2*2,f,0,4);         /* 28-31 */
  PutNum(4,f,0,2);                 /* 32-33 */
  PutNum(16,f,0,2);                /* 34-35 */
  write(f,"data",4);               /* 36-39 */
  PutNum(bytes,f,0,4);             /* 40-43 */
}






void cdda_to_wav(char *wf,int tn,int r)
{
int b,out,bl,a;
int16_t *readbuf;
float tot,c;
char *token;
int paranoia_mode=PARANOIA_MODE_FULL^PARANOIA_MODE_NEVERSKIP;
long cursor;
long offset;

long first_sector;
long last_sector;
int batch_track;
int track1,track2;
long off1,off2;
char ubuff[100];
int back;


d=cdda_identify(cd_dev,1,NULL);
if(!d){printf("\ncannot open cd drive\n");return;}
cdda_verbose_set(d,CDDA_MESSAGE_PRINTIT,CDDA_MESSAGE_PRINTIT);
b=cdda_open(d);
if(b!=0){printf("\nfailed to open cd properly");return;}
first_sector=cdda_disc_firstsector(d);
last_sector=cdda_disc_lastsector(d);

track1=cdda_sector_gettrack(d,first_sector);
track2=cdda_sector_gettrack(d,last_sector);
off1=first_sector-cdda_track_firstsector(d,track1);
off2=last_sector-cdda_track_firstsector(d,track2);

  offset=cdda_track_firstsector(d,tn);
  first_sector+=offset;
  last_sector+=offset;


p=paranoia_init(d);
paranoia_modeset(p,paranoia_mode);

paranoia_seek(p,cursor=first_sector,SEEK_SET);
bl=cdda_track_lastsector(d,batch_track=cdda_sector_gettrack(d,cursor));
out=open(wf,O_RDWR|O_CREAT|O_TRUNC,0666);

cursor=first_sector;

WriteWav(out,(last_sector-first_sector+1)*CD_FRAMESIZE_RAW);

tot=bl-cursor;
c=0;
  while(cursor<=bl)
{
    /* read a sector */
    readbuf=paranoia_read(p,CDPCallback);
    if(!readbuf)break;
    cursor++;
    c++;
    CDPCallback(cursor*(CD_FRAMEWORDS)-1,-2);
   write(out,((char *)readbuf),CD_FRAMESIZE_RAW);
a=(c/tot)*100;
sprintf(rtbuff,"Ripped %.2f",(c/tot)*100);
gtk_clist_set_text((GtkCList*)rip_list,r,2,rtbuff);
if(!gtk_toggle_button_get_active((GtkToggleButton*)wav_form))
{
back=ugetline(ubuff,gdes[0]);
if(back)
{
token=strtok(ubuff," ");
back=atoi(token);
token=strtok(NULL,"\0");
gtk_clist_set_text((GtkCList*)rip_list,back,2,token);
}
}
while (gtk_events_pending ())
       gtk_main_iteration_do (FALSE);
if(stop_rip==1)break;
  }


  CDPCallback(cursor*(CD_FRAMESIZE_RAW/2)-1,-1);
  close(out);

  paranoia_free(p);
  cdda_close(d);
}




int wav_to_ogg(char *targ,char *sour,int r)
{
  ogg_stream_state os; /* take physical pages, weld into a logical
			  stream of packets */
  ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
  ogg_packet       op; /* one raw packet of data for decode */

  vorbis_info      vi; /* struct that stores all the static vorbis bitstream
			  settings */
  vorbis_comment   vc; /* struct that stores all the user comments */

  vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
  vorbis_block     vb; /* local working space for packet->PCM decode */

  int result;
  int eos=0,ret;
    float c,l;
  long i,bytes;
  float **buffer;
    ogg_packet header;
    ogg_packet header_comm;
    ogg_packet header_code;

 FILE *sptr,*tptr;


sptr=fopen(sour,"rb");
tptr=fopen(targ,"wb");

fseek(sptr,0,SEEK_END);
l=ftell(sptr);
rewind(sptr);

  vorbis_info_init(&vi);


  ret=vorbis_encode_init_vbr(&vi,2,44100,.5);

  if(ret)return 0;

  /* add a comment */
  vorbis_comment_init(&vc);
  vorbis_comment_add_tag(&vc,"ENCODER","Sonic-Rainbow");

  /* set up the analysis state and auxiliary encoding storage */
  vorbis_analysis_init(&vd,&vi);
  vorbis_block_init(&vd,&vb);


  srand(time(NULL));
  ogg_stream_init(&os,rand());


  {
    vorbis_analysis_headerout(&vd,&vc,&header,&header_comm,&header_code);
    ogg_stream_packetin(&os,&header); /* automatically placed in its own
					 page */
    ogg_stream_packetin(&os,&header_comm);
    ogg_stream_packetin(&os,&header_code);


	while(!eos){
		result=ogg_stream_flush(&os,&og);
		if(result==0)break;
		fwrite(og.header,1,og.header_len,tptr);
		fwrite(og.body,1,og.body_len,tptr);
	}

  }
c=0;
  while(!eos){
    bytes=fread(readbuffer,1,READ*4,sptr); /* stereo hardwired here */
c=c+bytes;
    if(bytes==0){

      vorbis_analysis_wrote(&vd,0);

    }else{
      /* data to encode */

      /* expose the buffer to submit data */
      buffer=vorbis_analysis_buffer(&vd,READ);

      /* uninterleave samples */
      for(i=0;i<bytes/4;i++){
	buffer[0][i]=((readbuffer[i*4+1]<<8)|
		      (0x00ff&(int)readbuffer[i*4]))/32768.f;
	buffer[1][i]=((readbuffer[i*4+3]<<8)|
		      (0x00ff&(int)readbuffer[i*4+2]))/32768.f;
      }

      /* tell the library how much we actually submitted */
      vorbis_analysis_wrote(&vd,i);
    }

    while(vorbis_analysis_blockout(&vd,&vb)==1){

      /* analysis, assume we want to use bitrate management */
      vorbis_analysis(&vb,NULL);
      vorbis_bitrate_addblock(&vb);

      while(vorbis_bitrate_flushpacket(&vd,&op)){

	/* weld the packet into the bitstream */
	ogg_stream_packetin(&os,&op);

	/* write out pages (if any) */
	while(!eos){
	  result=ogg_stream_pageout(&os,&og);
	  if(result==0)break;
	  fwrite(og.header,1,og.header_len,tptr);
	  fwrite(og.body,1,og.body_len,tptr);
	  if(ogg_page_eos(&og))eos=1;
	}
      }
    }
sprintf(tbuff,"%d Encoding %.2f\n",r,(c/l)*100);
write(gdes[1],tbuff,strlen(tbuff));

if(stop_rip==1)break;
  }


  ogg_stream_clear(&os);
  vorbis_block_clear(&vb);
  vorbis_dsp_clear(&vd);
  vorbis_comment_clear(&vc);
  vorbis_info_clear(&vi);

fclose(sptr);
fclose(tptr);

    return(1);
}







int wav_to_mp3(char *targ,char *src,int ra,int q)
{
int ret_code;
FILE *sptr;
FILE *tptr;
short int l[250];
short int r[250];
char bbuff[7200];
char ubuff[100];
int b,c;
float a;
long length;
short int buf[500];

if((sptr=fopen(src,"rb"))==NULL)return 0;
fseek(sptr,0,SEEK_END);
length=ftell(sptr);
if(length<=44){fclose(sptr);return 0;}
length=length-44;
length=length/2;
rewind(sptr);
fseek(sptr,44,SEEK_CUR);


if((tptr=fopen(targ,"wb"))==NULL)return 0;

   gfp = lame_init();
   if(gfp==NULL)return 0;
   lame_set_num_channels(gfp,2);
   lame_set_in_samplerate(gfp,44100);
   lame_set_brate(gfp,128);
   lame_set_mode(gfp,0);
   lame_set_quality(gfp,q);
   lame_set_VBR(gfp,1);
   lame_set_VBR_q(gfp,0);

   ret_code = lame_init_params(gfp);


for(a=0;a<length;a=a+500)
{
if(a+500 < length)
{

b=fread(buf,sizeof(short int),500,sptr);
c=0;
for(b=0;b<250;b++)
{
l[b]=buf[c++];
r[b]=buf[c++];
}
ret_code=lame_encode_buffer(gfp,l,r,250,bbuff,7200);
if(ret_code)
fwrite(bbuff,sizeof(char),ret_code,tptr);
sprintf(ubuff,"%d Encoding %f\n",ra,(a/length)*100);
write(gdes[1],ubuff,strlen(ubuff));
   if(stop_rip==1)break;
}
else
{
fread(buf,sizeof(short int),length-a,sptr);
c=0;
for(b=0;b<(length-a)/2;b++)
{
l[b]=buf[c++];
r[b]=buf[c++];
}
ret_code=lame_encode_buffer(gfp,l,r,(length-a)/2,bbuff,7200);
if(ret_code)
fwrite(bbuff,sizeof(char),ret_code,tptr);
break;
}

}

ret_code= lame_encode_flush(gfp,bbuff, 7200);
if(ret_code)
fwrite(bbuff,sizeof(char),ret_code,tptr);
fclose(tptr);
fclose(sptr);
lame_close(gfp);
return 1;
}






void add_mp3_tag(char *tag_file,int c)
{
char *string1;
size_t offset;

ID3Tag  *tag=NULL;
ID3Frame *id3_frame;
ID3Field *id3_field;

tag= ID3Tag_New();
offset = ID3Tag_Link(tag,tag_file);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_ALBUM);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_ALBUM);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(rcd_info.title);
ID3Field_SetASCII(id3_field,string1);


id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_LEADARTIST);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_LEADARTIST);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(rcd_info.c_tracks[c].artist);
ID3Field_SetASCII(id3_field,string1);


id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_TITLE);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_TITLE);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(rcd_info.c_tracks[c].title);
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_YEAR);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_YEAR);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(rcd_info.year);
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_CONTENTTYPE);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_CONTENTTYPE);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(rcd_info.genre);
ID3Field_SetASCII(id3_field,string1);

/*
id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_COMMENT);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_COMMENT);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_editable_get_chars ((GtkEditable*)text1,0,-1));
ID3Field_SetASCII(id3_field,string1);
*/

ID3Tag_NumFrames(tag);
ID3Tag_UpdateByTagType(tag,ID3TT_ID3V2);
ID3Tag_UpdateByTagType(tag,ID3TT_ID3V1);
if(tag!=NULL)
{
ID3Tag_Delete(tag);
tag=NULL;
}

}



/* This function is based on work of :
* ogg_tag.c - 2001/11/08
*
*  EasyTAG - Tag editor for MP3 and Ogg Vorbis files
*  Copyright (C) 2001-2003  Jerome Couderc <j.couderc@ifrance.com>
*
*/
gboolean add_ogg_tag (char *tfile,int c)
{
    FILE           *file_in;
    vcedit_state   *state;
    vorbis_comment *vc;
    gchar          *string, *string1;
   guchar tmp_id3[4];
    gulong id3v2size;

    if ( (file_in=fopen(tfile,"rb"))==NULL )
    {
              return FALSE;
    }


    // Skip the id3v2 tag


    // Check if there is an ID3v2 tag...
    fseek(file_in, 0L, SEEK_SET);
    if (fread(tmp_id3, 1, 4, file_in) == 4)
    {
        // Calculate ID3v2 length
        if (tmp_id3[0] == 'I' && tmp_id3[1] == 'D' && tmp_id3[2] == '3' && tmp_id3[3] < 0xFF)
        {
            // id3v2 tag skipeer $49 44 33 yy yy xx zz zz zz zz [zz size]
            fseek(file_in, 2, SEEK_CUR); // Size is 6-9 position
            if (fread(tmp_id3, 1, 4, file_in) == 4)
            {
                id3v2size = 10 + ( (long)(tmp_id3[3])        | ((long)(tmp_id3[2]) << 7)
                                   | ((long)(tmp_id3[1]) << 14) | ((long)(tmp_id3[0]) << 21) );
                fseek(file_in, id3v2size, SEEK_SET);
            }else
            {
                fseek(file_in, 0L, SEEK_SET);
            }
        }else
        {
            fseek(file_in, 0L, SEEK_SET);
        }
    }else
    {
        fseek(file_in, 0L, SEEK_SET);
    }


    state = vcedit_new_state();    // Allocate memory for 'state'
    if ( vcedit_open(state,file_in) < 0 )
    {
        fclose(file_in);
        return FALSE;
    }

    /* Get data from tag */

    vc = vcedit_comments(state);
    vorbis_comment_clear(vc);
    vorbis_comment_init(vc);

    /*********
     * Title *
     *********/

        string  = g_strconcat("TITLE=",rcd_info.c_tracks[c].title,NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /**********
     * Artist *
     **********/

        string  = g_strconcat("ARTIST=",rcd_info.c_tracks[c].artist,NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /*********
     * Album *
     *********/
        string  = g_strconcat("ALBUM=",rcd_info.title,NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /********
     * Year *
     ********/

        string  = g_strconcat("DATE=",rcd_info.year,NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);


    /*********
     * Genre *
     *********/

        string  = g_strconcat("GENRE=",rcd_info.genre,NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);



    /* Write tag */
    if ( Ogg_Tag_Write_File(file_in,tfile,state) == FALSE )
    {
        return FALSE;
    }

    vcedit_clear(state);

    return TRUE;
}




static void cd_encode_thread(void *v)
{
int count;

int quality;
int ab;

quality=rquality;

while(1)
{
sleep(1);

   if(stop_rip==1)break;


if(encoded==1 || encoded ==2)
{
if(encoded==1)encoded=0;
ab=getline(esfile,fdes[0]);
if(!ab)
{
thread_finished=1;pthread_exit(0);
}
if(strcmp(esfile,"finished\n")==0)
{
thread_finished=1;pthread_exit(0);return;
}
getline(ebase,fdes[0]);
getline(eb,fdes[0]);
esfile[strlen(esfile)-1]=0;
ebase[strlen(ebase)-1]=0;
eb[strlen(eb)-1]=0;
count=atoi(eb);


if(rtype==1)
{
if(strcmp(rcd_info.c_tracks[count].title,"Unknown")!=0)
sprintf(ebuff1,"%s/%s.ogg",ebase,rcd_info.c_tracks[count].title);
else
sprintf(ebuff1,"%s/track%.2d.ogg",ebase,count+1);

 sprintf(ebuff,"%s/track%.2d.wav",ebase,count+1);
 wav_to_ogg(ebuff1,ebuff,count);
sprintf(ebuff,"%d Finished\n",count);
write(gdes[1],ebuff,strlen(ebuff));
 add_ogg_tag(ebuff1,count);
  sprintf(ebuff,"%s/track%.2d.wav",ebase,count+1);

  unlink(ebuff);
  if(stop_rip==1)break;
 }
else   /* rip to MP3 */
if(rtype==2)
{
if(quality==10)quality--;
quality=9-quality;

if(strlen(rcd_info.c_tracks[count].title)>30)
rcd_info.c_tracks[count].title[30]=0;

if(strlen(rcd_info.title)>30)
rcd_info.title[30]=0;

if(strlen(rcd_info.c_tracks[count].artist)>30)
rcd_info.c_tracks[count].artist[30]=0;

if(strcmp(rcd_info.c_tracks[count].title,"Unknown")!=0)
sprintf(ebuff,"%s/%s.mp3",ebase,rcd_info.c_tracks[count].title);
else
sprintf(ebuff,"%s/track%.2d.mp3",ebase,count+1);
sprintf(ebuff1,"%s/track%.2d.wav",ebase,count+1);

wav_to_mp3(ebuff,ebuff1,count,quality);
add_mp3_tag(ebuff,count);
sprintf(ebuff,"%d Finished\n",count);
write(gdes[1],ebuff,strlen(ebuff));

sprintf(ebuff,"%s/track%.2d.wav",ebase,count+1);
unlink(ebuff);
}
else
{
if(quality==10)quality--;
quality=9-quality;

if(strlen(rcd_info.c_tracks[count].title)>30)
rcd_info.c_tracks[count].title[30]=0;

if(strlen(rcd_info.title)>30)
rcd_info.title[30]=0;

if(strlen(rcd_info.c_tracks[count].artist)>30)
rcd_info.c_tracks[count].artist[30]=0;

if(strcmp(rcd_info.c_tracks[count].title,"Unknown")!=0)
sprintf(ebuff,"%s/%s.flac",ebase,rcd_info.c_tracks[count].title);
else
sprintf(ebuff,"%s/track%.2d.flac",ebase,count+1);
sprintf(ebuff1,"%s/track%.2d.wav",ebase,count+1);

wav_to_flac(ebuff,ebuff1,count);
add_flac_tag(ebuff,count);
//add_mp3_tag(ebuff,count);
sprintf(ebuff,"%d Finished\n",count);
write(gdes[1],ebuff,strlen(ebuff));

sprintf(ebuff,"%s/track%.2d.wav",ebase,count+1);
unlink(ebuff);
}

   if(stop_rip==1)break;
  }



}
thread_finished=1;
pthread_exit(0);
return;
}



int getline(char *s,int h)
{
int count=0;
int b;
while(1)
{
b=read(h,s+count,1);
if(b==0)break;
if(b==-1)return b;
count++;
if(s[count-1]=='\n')break;
}
s[count]='\0';
return 1;
}





int ugetline(char *s,int h)
{
int count=0;
int b;
fd_set rfds;
struct timeval tv;
int retval;


FD_ZERO(&rfds);
FD_SET(gdes[0], &rfds);

tv.tv_sec = 0;
tv.tv_usec = 0;
retval = select(gdes[0]+1, &rfds, NULL, NULL, &tv);
if(!retval)
return retval;



while(1)
{
b=read(gdes[0],s+count,1);
if(b==0)break;
if(b==-1)return b;
count++;
if(s[count-1]=='\n')break;
}
s[count-1]='\0';
return 1;
}


int wav_to_flac(char *flac,char *wav,int cnum)
{
FILE *sptr;
FLAC__FileEncoder *fe;
FLAC__FileEncoderState fs;
char ubuff[100];
unsigned int l[5000];
unsigned char r[5000];
int b,c;
float a;
long length;
if((sptr=fopen(wav,"rb"))==NULL)return 0;
fseek(sptr,0,SEEK_END);
length=ftell(sptr);
length=length-44;
if(length<=44){fclose(sptr);return 0;}
rewind(sptr);
fseek(sptr,44,SEEK_CUR);


fe=FLAC__file_encoder_new();
FLAC__file_encoder_set_filename(fe,flac);
FLAC__file_encoder_set_bits_per_sample(fe,16);
FLAC__file_encoder_set_sample_rate(fe,44100);
FLAC__file_encoder_set_channels(fe,2);
fs=FLAC__file_encoder_init(fe);



for(a=0;a<length;a=a+4608)
{
if(a+4608 < length)
{
b=fread(r,sizeof(char),4608,sptr);
b=0;
for(c=0;c<2302;c++)
{
memcpy(l+c,r+b,2);
b=b+2;
}
FLAC__file_encoder_process_interleaved(fe,l,1151);
sprintf(ubuff,"%d Encoding %f\n",cnum,(a/length)*100);
write(gdes[1],ubuff,strlen(ubuff));
if(stop_rip==1)break;
}
else
{
b=fread(l,sizeof(char),length-a,sptr);
b=0;
for(c=0;c<(length-a)/2;c++)
{
memcpy(l+c,r+b,2);
b=b+2;
}
FLAC__file_encoder_process_interleaved(fe,l,(length-a)/4);
sprintf(ubuff,"%d Encoding %f\n",cnum,(a/length)*100);
write(gdes[1],ubuff,strlen(ubuff));
break;
}

}




FLAC__file_encoder_finish(fe);
FLAC__file_encoder_delete(fe);
fclose(sptr);
return 1;
}

void
on_ripper_window_flacfile_realize      (GtkWidget       *widget,
                                        gpointer         user_data)
{
flac=widget;
}

int add_flac_tag(char *fname,int c)
{
        gchar          *string,*string1=NULL;
	FLAC__bool ok = true, found_vc_block = false;
	FLAC__StreamMetadata *block = 0;
	FLAC__Metadata_Iterator *iterator = FLAC__metadata_iterator_new();
	FLAC__Metadata_Chain *chain = FLAC__metadata_chain_new();
int nw=1;

	if(0 == chain)
		return 0;

	if(!FLAC__metadata_chain_read(chain, fname)) {

		return false;
	}


	if(0 == iterator)
		return 0;

	FLAC__metadata_iterator_init(iterator, chain);

	do {
		block = FLAC__metadata_iterator_get_block(iterator);
		if(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT)
			found_vc_block = true;
	} while(!found_vc_block && FLAC__metadata_iterator_next(iterator));

	if(!found_vc_block) {
		/* create a new block if necessary */

			block = FLAC__metadata_object_new(FLAC__METADATA_TYPE_VORBIS_COMMENT);
			if(0 == block)
				return 0;
			while(FLAC__metadata_iterator_next(iterator))
				;
			if(!FLAC__metadata_iterator_insert_block_after(iterator, block)) {
				/*fprintf(stderr, "%s: ERROR: adding new VORBIS_COMMENT block to metadata, status =\"%s\"\n", filename,*/ FLAC__Metadata_ChainStatusString[FLAC__metadata_chain_status(chain)];
				return false;
			}
			/* iterator is left pointing to new block */
			FLAC__ASSERT(FLAC__metadata_iterator_get_block(iterator) == block);


	}

	FLAC__ASSERT(0 != block);
	FLAC__ASSERT(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT);


       string  = g_strconcat("TITLE=",rcd_info.c_tracks[c].title,NULL);
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);

     /**********
     * Artist *
     **********/

        string  = g_strconcat("ARTIST=",rcd_info.c_tracks[c].artist,NULL);
        string1 = convert_to_utf8(string);
        set_vc_field(fname, block,string1 , &nw,1);
        g_free(string);
        g_free(string1);


    /*********
     * Album *
     *********/
        string  = g_strconcat("ALBUM=",rcd_info.title,NULL);
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);


    /********
     * Year *
     ********/

        string  = g_strconcat("DATE=",rcd_info.year,NULL);
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);


    /*********
     * Genre *
     *********/

        string  = g_strconcat("GENRE=",rcd_info.genre,NULL);
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);

	FLAC__metadata_iterator_delete(iterator);
	ok = FLAC__metadata_chain_write(chain, 0,1);
	FLAC__metadata_chain_delete(chain);


return 1;

}




FLAC__bool set_vc_field(const char *filename, FLAC__StreamMetadata *block, char *field, FLAC__bool *needs_write, FLAC__bool raw)
{
	FLAC__StreamMetadata_VorbisComment_Entry entry;
	char *converted;
	FLAC__bool needs_free = false;

	FLAC__ASSERT(0 != block);
	FLAC__ASSERT(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT);
	FLAC__ASSERT(0 != field);
	FLAC__ASSERT(0 != needs_write);

	if(raw) {
		entry.entry = field;
	}
/*
	else if(utf8_encode(field->field, &converted) >= 0) {
		entry.entry = converted;
		needs_free = true;
	}
*/
//	else {
//		fprintf(stderr, "%s: ERROR: couldn't convert comment to UTF-8\n", filename);
//		return false;
//	}

	entry.length = strlen(entry.entry);

	if(!FLAC__metadata_object_vorbiscomment_insert_comment(block, block->data.vorbis_comment.num_comments, entry, /*copy=*/true)) {
		if(needs_free)
			free(converted);
//		fprintf(stderr, "%s: ERROR: memory allocation failure\n", filename);
		return false;
	}
	else {
		*needs_write = true;
		if(needs_free)
			free(converted);
		return true;
	}
return 1;
}




