/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "callbacks.h"

extern GtkTooltips *tooltips;

int cd_autoplay=0;
int fm_autoplay=0;
int display_cd,display_ripper,display_ogg,display_mixer,tooltip=0;
char *cd_dev,*music_dir=NULL;
extern char default_playlist_file[1000];
extern char default_playlist_dir[1000];
extern char default_mixer[1000];
extern char default_radio[1000];
extern char default_video[1000];
extern char default_radio_directory[1000];
extern int plist_autoplay;
extern int display_radio;
extern int play_error, http_lookup;
extern int which_player;

int get_config();
int set_defaults();
void mkdirs();

float frequencys[11];
char  blabels[11][7];

int get_config()
{
FILE *fptr;
char *e;
char h[1000];
char *token;
int num,lines;



for(num=0;num<11;num++)
{
frequencys[num]=87.9;
sprintf(blabels[num],"%d",num+1);
}

if(cd_dev)free(cd_dev);
if(music_dir)free(music_dir);

 e=getenv("HOME");
 strcpy(h,e);
 strcat(h,"/sonic-rainbow/sr.config");

 if((fptr=fopen(h,"rb"))==NULL)
  return set_defaults();

lines=0;

  while(1)
  {
  if((fgets(h,200,fptr))==NULL)break;
  lines++;
  }
  rewind(fptr);

if(lines<19){fclose(fptr); return -1;}



if((fgets(h,200,fptr))==NULL){fclose(fptr);return -1;}
if(strlen(h)>0)
h[strlen(h)-1]=0;
else
h[0]=0;
cd_dev=(char*)malloc(strlen(h)+1);
strcpy(cd_dev,h);

if((fgets(h,200,fptr))==NULL){fclose(fptr);free(cd_dev);return -1;}
if(strlen(h)>0)
h[strlen(h)-1]=0;
else
h[0]=0;
music_dir=(char*)malloc(strlen(h)+1);
strcpy(music_dir,h);

if((fgets(h,200,fptr))==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
h[strlen(h)-1]=0;
token=strtok(h," ");
if(token==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
cd_autoplay=atoi(token);

token=strtok(NULL," ");
if(token==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
display_cd=atoi(token);

token=strtok(NULL," ");
if(token==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
display_ripper=atoi(token);

token=strtok(NULL," ");
if(token==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
plist_autoplay=atoi(token);


if((token=strtok(NULL," "))==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
display_mixer=atoi(token);

if((token=strtok(NULL," "))==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
play_error=atoi(token);

if((token=strtok(NULL," "))==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
http_lookup=atoi(token);

if((token=strtok(NULL," "))==NULL){fclose(fptr);free(cd_dev);free(music_dir);return -1;}
tooltip=atoi(token);

if((fgets(h,900,fptr))!=NULL)
{
 if(strlen(h)>0)
 h[strlen(h)-1]=0;
 else
 h[0]=0;
 strcpy(default_playlist_file,h);
}
else
strcpy(default_playlist_file,"");

if((fgets(h,900,fptr))!=NULL)
{
 if(strlen(h)>0)
 h[strlen(h)-1]=0;
 else
 h[0]=0;
 strcpy(default_playlist_dir,h);
}
else
{
 e=getenv("HOME");
 strcpy(default_playlist_dir,e);
 strcat(default_playlist_dir,"/sonic-rainbow/playlist/");
}



if((fgets(h,900,fptr))!=NULL)
{
 if(strlen(h)>0)
 h[strlen(h)-1]=0;
 else
 h[0]=0;
 token=strtok(h," ");
 strcpy(default_mixer,token);
 token=strtok(NULL," ");
 if(token==NULL)
 {
  e=getenv("HOME");
  strcpy(default_video,e);
 strcat(default_video,"/sonic-rainbow/video/");
 }
 else
 strcpy(default_video,token);
}
else
strcpy(default_mixer,"/dev/mixer");




if((fgets(h,900,fptr))!=NULL)
{
if(strlen(h)>0)
 h[strlen(h)-1]=0;
 else
 h[0]=0;
 token=strtok(h," ");
 if(token!=NULL)
 strcpy(default_radio,token);
 else
 strcpy(default_radio,"87.9");

 token=strtok(NULL,"");
 if(token!=NULL)
 which_player=atoi(token);
 else
 which_player=1;

  for(num=0;num<11;num++)
  {
    if((fgets(h,900,fptr))!=NULL)
    {
     if(strlen(h)>0)
     h[strlen(h)-1]=0;
     else
     h[0]=0;
     token=strtok(h," ");
     if(token!=NULL)
     frequencys[num]=atof(token);
     else
     frequencys[num]=87.9;
     token=strtok(NULL,"");
     if(token!=NULL)
     strcpy(blabels[num],token);
     }
    else
    {
     frequencys[num]=87.9;
    }
   }

  if((fgets(h,900,fptr))!=NULL)
  {

   h[strlen(h)-1]=0;
   token=strtok(h," ");
   fm_autoplay=atoi(token);
  }
  else
  fm_autoplay=0;
}
else
{
strcpy(default_radio,"/dev/radio");
display_radio=0;
fm_autoplay=0;
}


if((fgets(h,900,fptr))!=NULL)
{
 if(strlen(h)>0)
 h[strlen(h)-1]=0;
 else
 h[0]=0;
 strcpy(default_radio_directory,h);
}
else
{
 e=getenv("HOME");
 strcpy(default_radio_directory,e);
 strcat(default_radio_directory,"/sonic-rainbow/radio/");
}



fclose(fptr);


mkdirs();

if(fm_autoplay==1)
on_play_radio_clicked(NULL,NULL);
return 1;
}



void mkdirs()
{
char *h;
char d[1000];

h=getenv("HOME");
strcpy(d,h);
strcat(d,"sonic-rainbow");
mkdir(d,S_IRWXU|S_IRWXG|S_IRWXO);
strcat(d,"/cddb");
mkdir(d,S_IRWXU|S_IRWXG|S_IRWXO);
mkdir(music_dir,S_IRWXU|S_IRWXG|S_IRWXO);
mkdir(default_playlist_dir,S_IRWXU|S_IRWXG|S_IRWXO);
mkdir(default_video,S_IRWXU|S_IRWXG|S_IRWXO);
mkdir(default_radio_directory,S_IRWXU|S_IRWXG|S_IRWXO);
}



int set_defaults()
{
char *h;
char b[1000];
FILE *fptr;
int num,rval=0;

 if(cd_dev)free(cd_dev);
 if(music_dir)free(music_dir);

 cd_autoplay=0;
 display_cd=0;
 display_ripper=0;
 display_ogg=0;
 display_mixer=0;
 plist_autoplay=0;
 display_radio=0;
 fm_autoplay=0;
 play_error=0;
 http_lookup=0;
 tooltip=0;

 which_player=1;

for(num=0;num<11;num++)
{
frequencys[num]=87.9;
sprintf(blabels[num],"%d",num+1);
}

gtk_tooltips_enable(tooltips);

 strcpy(default_radio,"/dev/radio");
 cd_dev=(char *)malloc(11);
 strcpy(cd_dev,"/dev/cdrom");
 strcpy(default_mixer,"/dev/mixer");
 h=getenv("HOME");
 music_dir=(char *)malloc(strlen(h)+22);
 strcpy(music_dir,h);
 strcpy(default_video,h);
 strcpy(default_playlist_dir,h);
 strcpy(default_playlist_file,"");
 strcat(default_playlist_dir,"/sonic-rainbow/playlist/");
 strcat(default_video,"/sonic-rainbow/video/");
 strcat(music_dir,"/sonic-rainbow");
 strcpy(b,music_dir);
 strcpy(default_radio_directory,b);
 strcat(default_radio_directory,"/radio/");

 if(mkdir(music_dir,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-2;
 strcat(b,"/sonic-rainbow/cddb");
 if(mkdir(b,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-3;
 strcat(music_dir,"/music/");
 if(mkdir(music_dir,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-4;
 if(mkdir(default_playlist_dir,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-5;
 sprintf(b,"%s/sonic-rainbow",getenv("HOME"));
 if(mkdir(b,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-6;
 strcat(b,"/sr.config");
 if(mkdir(default_video,S_IRWXU|S_IRWXG|S_IRWXO)==-1)rval=-2;

 if((fptr=fopen(b,"wb"))!=NULL)
 {
 fprintf(fptr,"%s\n%s\n",cd_dev,music_dir);
 fprintf(fptr,"%d %d %d %d %d %d %d %d\n",cd_autoplay,display_cd,display_ripper,plist_autoplay,display_mixer,play_error,http_lookup,tooltip);
 fprintf(fptr,"%s\n",default_playlist_file);
 fprintf(fptr,"%s\n",default_playlist_dir);
 fprintf(fptr,"%s %s\n",default_mixer,default_video);
 fprintf(fptr,"%s %d\n",default_radio,which_player);
 for(num=0;num<11;num++)
 {
  fprintf(fptr,"%-2.1f %s\n",frequencys[num],blabels[num]);
 }
 fprintf(fptr,"%d\n",fm_autoplay);
 fprintf(fptr,"%s\n",default_radio_directory);
 fclose(fptr);
 return 1;
 }
 else
 return -7;
}




