/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <fcntl.h>
#include <linux/soundcard.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/videodev.h>
#include <string.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <audiofile.h>
#include <ao/ao.h>
#include <mad.h>
#include <sys/mman.h>

#define BUFFER_FRAME_COUNT 65536


extern char *music_dir;
extern char *ddata;
char *ccdir;

int wav_to_mp3(char *targ,char *src,int ra,int q);

GtkWidget *tentry,*ce,*cl,*colist1,*colist2,*mp3button,*wavbutton,*oggbutton=NULL;
GtkWidget *del_source,*con_entry,*con_label,*con_bar=NULL;
char *cdata=NULL;
int csel=-1;
int csel_num2=-1;
int csel_num1=-1;
char *csel2=NULL;
char *wfile;
int mp3towave=0;

void on_cwindow_realize(GtkWidget *,gpointer);
void on_centry1_realize(GtkWidget *,gpointer);
void on_cfixed_realize(GtkWidget *,gpointer);
void on_cclist2_realize(GtkWidget *,gpointer);
void on_cclist1_realize(GtkWidget *,gpointer);
void on_cclist1_select_row(GtkCList *,gint,gint,GdkEvent *,gpointer);
void on_cclist1_unselect_row(GtkCList *,gint,gint,GdkEvent *,gpointer);
void on_cclist2_select_row(GtkCList *,gint,gint,GdkEvent *,gpointer);
void on_cclist2_unselect_row(GtkCList *,gint,gint,GdkEvent *,gpointer);
void on_cbutton3_clicked(GtkButton *,gpointer);
void on_cbutton4_clicked(GtkButton *,gpointer);
void on_mp3button_clicked(GtkButton *, gpointer);
void on_wavbutton_clicked(GtkButton *, gpointer);
void on_oggbutton_clicked(GtkButton *, gpointer);
int wavtoogg(char *s,char *t,int l);
int iswav(char *);
int cfill_list(char *di);
void wavtomp3(char *);
int isogg(char *);
void oggtomp3(char *f);
int towav(char *s,char *t);
int copyaudiodata (AFfilehandle infile, AFfilehandle outfile, int trackid,AFframecount totalFrameCount);
int oggtowav(char *s,char *t);
int ismp3(char *);
int play_mpeg(char mp3[]);
void on_tentry_realize(GtkWidget *widget,gpointer         user_data);
GtkWidget * create_single_dir_window (char *);
int rline(FILE *f,char *ptr);


GtkWidget* create_convert_window (char *sd)
{
  GtkWidget *cwindow;
  GtkWidget *cfixed;
  GtkWidget *centry1;
  GtkWidget *cbutton3;
  GtkWidget *atscrolledwindow2;
  GtkWidget *cclist2;
  GtkWidget *atlabel2;
  GtkWidget *cbutton4;
  GtkWidget *atlabel3;
  GtkWidget *atscrolledwindow1;
  GtkWidget *cclist1;
  GtkWidget *atlabel1;
  GtkWidget *atlabel5;
  GtkWidget *can_button;
  DIR *dir1_handle=NULL;
  char *root_dir="/";


dir1_handle=opendir(sd);
if(dir1_handle==NULL)
{
ccdir=root_dir;
}
else
{
closedir(dir1_handle);
ccdir=sd;
}
  ccdir=sd;


  cwindow = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (cwindow), "atwindow2", cwindow);
  gtk_window_set_title (GTK_WINDOW (cwindow), "Sonic-Rainbow Convert File Formats");

  cfixed = gtk_fixed_new ();
  gtk_widget_ref (cfixed);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atfixed2", cfixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cfixed);
  gtk_container_add (GTK_CONTAINER (cwindow), cfixed);
  gtk_widget_set_usize (cfixed, 447, 475);

  centry1 = gtk_entry_new ();
  gtk_widget_ref (centry1);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atentry1", centry1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (centry1);
  gtk_fixed_put (GTK_FIXED (cfixed), centry1, 128, 16);
  gtk_widget_set_uposition (centry1, 128, 16);
  gtk_widget_set_usize (centry1, 302, 24);


  tentry = gtk_entry_new ();
  gtk_widget_ref (tentry);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "tentry", tentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tentry);
  gtk_fixed_put (GTK_FIXED (cfixed), tentry, 16, 300);
  gtk_widget_set_uposition (tentry, 16,300);
  gtk_widget_set_usize (tentry, 302, 24);


  cbutton3 = gtk_button_new_with_label ("Browse");
  gtk_widget_ref (cbutton3);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atbutton3", cbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_show (cbutton3);
  gtk_fixed_put (GTK_FIXED (cfixed), cbutton3, 317, 300);
  gtk_widget_set_uposition (cbutton3, 317, 300);
  gtk_widget_set_usize (cbutton3, 51, 24);


  atlabel5 = gtk_label_new ("Target Directory");
  gtk_widget_ref (atlabel5);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atlabel5", atlabel5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel5);
  gtk_fixed_put (GTK_FIXED (cfixed), atlabel5, 4, 280);
  gtk_widget_set_uposition (atlabel5, 4, 280);
  gtk_widget_set_usize (atlabel5, 112, 24);



  oggbutton = gtk_button_new_with_label ("Convert\nFiles to\nOGG Format");
  gtk_widget_ref (oggbutton);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atbutton4", oggbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (oggbutton);
  gtk_fixed_put (GTK_FIXED (cfixed), oggbutton, 350, 55);
  gtk_widget_set_uposition (oggbutton, 350, 55);
  gtk_widget_set_usize (oggbutton, 80, 60);

  wavbutton = gtk_button_new_with_label ("Convert\nFiles to\nWAV Format");
  gtk_widget_ref (wavbutton);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atbutton4", wavbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (wavbutton);
  gtk_fixed_put (GTK_FIXED (cfixed), wavbutton, 350, 120);
  gtk_widget_set_uposition (wavbutton, 350, 120);
  gtk_widget_set_usize (wavbutton, 80, 60);

  mp3button = gtk_button_new_with_label ("Convert\nFiles to\nMP3 Format");
  gtk_widget_ref (mp3button);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atbutton4", mp3button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mp3button);
  gtk_fixed_put (GTK_FIXED (cfixed), mp3button, 350, 185);
  gtk_widget_set_uposition (mp3button, 350, 185);
  gtk_widget_set_usize (mp3button, 80, 60);


  atscrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atscrolledwindow2", atscrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow2);
  gtk_fixed_put (GTK_FIXED (cfixed), atscrolledwindow2, 174, 56);
  gtk_widget_set_uposition (atscrolledwindow2, 174, 56);
  gtk_widget_set_usize (atscrolledwindow2, 160, 208);

  cclist2 = gtk_clist_new (1);
  gtk_widget_ref (cclist2);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atclist2", cclist2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cclist2);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow2), cclist2);
  gtk_clist_set_column_width (GTK_CLIST (cclist2), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (cclist2), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (cclist2));

  atlabel2 = gtk_label_new ("Files");
  gtk_widget_ref (atlabel2);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atlabel2", atlabel2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel2);
  gtk_clist_set_column_widget (GTK_CLIST (cclist2), 0, atlabel2);
  gtk_label_set_justify (GTK_LABEL (atlabel2), GTK_JUSTIFY_LEFT);

  cbutton4 = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (cbutton4);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atbutton4", cbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cbutton4);
  gtk_fixed_put (GTK_FIXED (cfixed), cbutton4, 210, 440);
  gtk_widget_set_uposition (cbutton4, 210, 440);
  gtk_widget_set_usize (cbutton4, 51, 26);


  can_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (can_button);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "can_button", can_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  /*gtk_widget_show (can_button);*/
  gtk_fixed_put (GTK_FIXED (cfixed), can_button, 210, 440);
  gtk_widget_set_uposition (can_button, 210, 440);
  gtk_widget_set_usize (can_button, 51, 26);


  atlabel3 = gtk_label_new ("Current Directory");
  gtk_widget_ref (atlabel3);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atlabel3", atlabel3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel3);
  gtk_fixed_put (GTK_FIXED (cfixed), atlabel3, 12, 16);
  gtk_widget_set_uposition (atlabel3, 12, 16);
  gtk_widget_set_usize (atlabel3, 112, 24);

  atscrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (atscrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atscrolledwindow1", atscrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atscrolledwindow1);
  gtk_fixed_put (GTK_FIXED (cfixed), atscrolledwindow1, 16, 56);
  gtk_widget_set_uposition (atscrolledwindow1, 16, 56);
  gtk_widget_set_usize (atscrolledwindow1, 160, 208);

  cclist1 = gtk_clist_new (1);
  gtk_widget_ref (cclist1);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atclist1", cclist1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cclist1);
  gtk_container_add (GTK_CONTAINER (atscrolledwindow1), cclist1);
  gtk_clist_set_column_width (GTK_CLIST (cclist1), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (cclist1), GTK_SELECTION_MULTIPLE);
  gtk_clist_column_titles_show (GTK_CLIST (cclist1));

  atlabel1 = gtk_label_new ("Directorys");
  gtk_widget_ref (atlabel1);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "atlabel1", atlabel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel1);
  gtk_clist_set_column_widget (GTK_CLIST (cclist1), 0, atlabel1);
  gtk_label_set_justify (GTK_LABEL (atlabel1), GTK_JUSTIFY_LEFT);

  del_source = gtk_check_button_new_with_label ("Delete Source Files");
  gtk_widget_ref (del_source);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "del_source", del_source,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (del_source);
  gtk_fixed_put (GTK_FIXED (cfixed), del_source, 14, 332);
  gtk_widget_set_uposition (del_source, 14, 332);
  gtk_widget_set_usize (del_source, 136, 24);
  gtk_toggle_button_set_active((GtkToggleButton *)del_source,0);


  con_label = gtk_label_new ("Converting File");
  gtk_widget_ref (con_label);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "con_label", con_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (con_label);
  gtk_fixed_put (GTK_FIXED (cfixed), con_label, 60, 360);
  gtk_widget_set_uposition (con_label, 60, 360);
  gtk_widget_set_usize (con_label, 112, 24);

  con_entry = gtk_entry_new ();
  gtk_widget_ref (con_entry);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "con_entry", con_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (con_entry);
  gtk_fixed_put (GTK_FIXED (cfixed), con_entry, 70, 380);
  gtk_widget_set_uposition (con_entry, 70,380);
  gtk_widget_set_usize (con_entry, 302, 24);

  con_bar = gtk_progress_bar_new ();
  gtk_widget_ref (con_bar);
  gtk_object_set_data_full (GTK_OBJECT (cwindow), "con_bar", con_bar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (con_bar);
  gtk_fixed_put (GTK_FIXED (cfixed), con_bar, 170, 410);
  gtk_widget_set_uposition (con_bar, 170, 410);
  gtk_widget_set_usize (con_bar, 150, 20);
  gtk_progress_set_show_text (GTK_PROGRESS (con_bar), TRUE);


  gtk_signal_connect (GTK_OBJECT (cwindow), "realize",
                      GTK_SIGNAL_FUNC (on_cwindow_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cfixed), "realize",
                      GTK_SIGNAL_FUNC (on_cfixed_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (centry1), "realize",
                      GTK_SIGNAL_FUNC (on_centry1_realize),
                      NULL);
 gtk_signal_connect (GTK_OBJECT (tentry), "realize",
                      GTK_SIGNAL_FUNC (on_tentry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cbutton3), "clicked",
                      GTK_SIGNAL_FUNC (on_cbutton3_clicked), NULL);

  gtk_signal_connect (GTK_OBJECT (mp3button), "clicked",
                      GTK_SIGNAL_FUNC (on_mp3button_clicked), NULL);

 gtk_signal_connect (GTK_OBJECT (wavbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_wavbutton_clicked), NULL);

gtk_signal_connect (GTK_OBJECT (oggbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_oggbutton_clicked), NULL);

  gtk_signal_connect (GTK_OBJECT (cclist2), "realize",
                      GTK_SIGNAL_FUNC (on_cclist2_realize),
                      NULL);
/*
  gtk_signal_connect (GTK_OBJECT (cclist2), "drag_data_get",
                      GTK_SIGNAL_FUNC (on_cclist2_drag_data_get),
                      NULL);
*/
  gtk_signal_connect (GTK_OBJECT (cclist2), "select_row",
                      GTK_SIGNAL_FUNC (on_cclist2_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cclist2), "unselect_row",
                      GTK_SIGNAL_FUNC (on_cclist2_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cbutton4), "clicked",
                      GTK_SIGNAL_FUNC (on_cbutton4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cclist1), "realize",
                      GTK_SIGNAL_FUNC (on_cclist1_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (cclist1), "select_row",
                      GTK_SIGNAL_FUNC (on_cclist1_select_row),
                      NULL);
/*
  gtk_signal_connect (GTK_OBJECT (atclist1), "drag_data_get",
                      GTK_SIGNAL_FUNC (on_aclist1_drag_data_get),
                      NULL);
*/
  gtk_signal_connect (GTK_OBJECT (cclist1), "unselect_row",
                      GTK_SIGNAL_FUNC (on_cclist1_unselect_row),
                      NULL);

  return cwindow;
}


void
on_convert_files_button_clicked        (GtkButton       *button,
                                        gpointer         user_data)

{
GtkWidget *w=NULL;

w=create_convert_window (music_dir);
gtk_widget_show(w);
gtk_main();
if(cdata!=NULL)
{
printf("\n%s\n",cdata);
free(cdata);
}
gtk_widget_destroy(w);
}



void
on_cwindow_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
cl=widget;
}

void
on_cfixed_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
csel=-1;
}


void
on_centry1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)widget,ccdir);
ce=widget;
}





void
on_cclist1_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle;
char *t[2];
struct dirent *dent;


csel_num1=0;
colist1=widget;



dir1_handle=opendir(ccdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)return;
strcpy(ccdir,"/");
}
while(1)
{

dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type==DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
csel_num1++;
}

}


closedir(dir1_handle);
}








void
on_cclist2_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle;
char *t[2];
struct dirent *dent;
int num;

colist2=widget;
csel_num2=0;


dir1_handle=opendir(ccdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)
return;
}
while(1)
{
dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
csel_num2++;
}
}

if(csel2!=NULL){free(csel2);csel2=NULL;}
csel2=(char*)malloc(csel_num2);
for(num=0;num<csel_num2;num++)
csel2[num]=(char)0;

closedir(dir1_handle);

}





void
on_cclist1_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *t,*p;
char *cwd,*nwd;
int b;

csel_num1=-1;

if(event->button.type==GDK_2BUTTON_PRESS)
{
cwd=(char *)malloc(10001);
nwd=(char *)malloc(10001);
getcwd(cwd,10000);
gtk_clist_get_text((GtkCList *)colist1,row,column,&p);
t=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)ce))+ strlen(p)+2);
strcpy(t,gtk_entry_get_text((GtkEntry*)ce));
strcat(t,p);
strcat(t,"/");
chdir(t);
getcwd(nwd,10000);
if(strlen(nwd)>2 && nwd[strlen(nwd)-1]!='/')
strcat(nwd,"/");
b=cfill_list(t);
if(b)gtk_entry_set_text((GtkEntry*)ce,nwd);
chdir(cwd);
free(cwd);
free(nwd);
free(t);
}
else
csel=row;

}







int cfill_list(char *di)
{
DIR *dir1_handle=NULL;
char *t[2];
struct dirent *dent=NULL;
int num;

if(csel2!=NULL){free(csel2);csel2=NULL;}
csel_num1=(char)0;
csel_num2=(char)0;

dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)colist1);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type==DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)colist1,t);
csel_num1++;
}
}
closedir(dir1_handle);

dir1_handle=NULL;
dent=NULL;

dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)colist2);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)colist2,t);
csel_num2++;
}
}

csel2=(char*)malloc(csel_num2);
for(num=0;num<csel_num2;num++)
csel2[num]=(char)0;

closedir(dir1_handle);


return 1;
}



void
on_cclist1_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
csel=-1;
}


void
on_cclist2_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
csel2[row]=(char)1;
}


void
on_cclist2_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
csel2[row]=(char)0;
}



void
on_cbutton3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;

f=create_single_dir_window (ccdir);
gtk_widget_show(f);
gtk_main();
if(ddata!=NULL)
{
gtk_entry_set_text((GtkEntry *)tentry,ddata);
free(ddata);
ddata=NULL;
}
gtk_widget_destroy(f);

}


void
on_cbutton4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

if(csel2!=NULL){free(csel2);csel2=NULL;}

cdata=NULL;
csel_num2=0;
gtk_main_quit();
}



void on_mp3button_clicked(GtkButton       *button, gpointer         user_data)
{
GtkCList *cli=NULL;
GList *glist=NULL;
gint row=0;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num=0;

cli=GTK_CLIST(colist2);
glist = cli->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
en=NULL;

if(row!=-1)
{
en=gtk_entry_get_text((GtkEntry*)ce);
for(num=0;num<csel_num2;num++)
{
  if(csel2[num])
  {
   gtk_clist_get_text((GtkCList*)colist2,num,0,&p);
   d=(char *)malloc(strlen(p)+2+strlen(en)+2);
   strcpy(d,en);
   strcat(d,p);
    if(iswav(d))
    {
     wavtomp3(d);
    }
    else
    if(isogg(d))
    {
     oggtomp3(d);
    }
   free(d);
  }
}
}


}



void oggtomp3(char *f)
{
char buff[10000];
strcpy(buff,f);
strcat(buff,".wav");
oggtowav(f,buff);
wavtomp3(buff);
}





int oggtowav(char *s,char *t)
{
FILE *fptr;
OggVorbis_File vf;
vorbis_info *vi;
int eof=0;
int current_section;
char pcmout[4096];
ao_sample_format format1;
int default_driver1;
ao_device *device1=NULL;

fptr=fopen(s,"rb");

ov_open(fptr, &vf, NULL, 0);
vi=ov_info(&vf,-1);

format1.bits = 16;
format1.channels = vi->channels;
format1.rate = vi->rate;

format1.byte_format = AO_FMT_LITTLE;

	ao_initialize();
	default_driver1 = ao_driver_id("wav");
	device1 = ao_open_file(default_driver1, t,1,&format1, NULL);

	eof=0;

  while(!eof)
  {
    long ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
    if (ret == 0)
    eof=1;
    else
    ao_play(device1,pcmout, ret);
  }
ov_clear(&vf);
ao_close(device1);
ao_shutdown();
device1=NULL;
return 1;
}


void wavtomp3(char *f)
{
char tb[1000],sb[1000];

strcpy(sb,f);
if(strcmp(f+(strlen(f)-4),".wav")==0)
f[strlen(f)-4]=0;
strcpy(tb,f);
strcat(tb,".mp3");
wav_to_mp3(tb,sb,-1,0);
/*
sprintf(buff,"lame -h \"%s\" \"%s.mp3\" 2>&1",f,0);
*/
}



void on_wavbutton_clicked(GtkButton *button, gpointer  user_data)
{
GtkCList *cli=NULL;
GList *glist=NULL;
gint row=0;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num=0;
char buff[10000];

cli=GTK_CLIST(colist2);
glist = cli->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
en=NULL;

if(row!=-1)
{
en=gtk_entry_get_text((GtkEntry*)ce);
for(num=0;num<csel_num2;num++)
{
  if(csel2[num])
  {
   gtk_clist_get_text((GtkCList*)colist2,num,0,&p);
   d=(char *)malloc(strlen(p)+2+strlen(en)+2);
   strcpy(d,en);
   strcat(d,p);
    if(ismp3(d))
    {
      mp3towave=1;
      wfile=(char*)malloc(strlen(d)+5);
      strcpy(wfile,d);
      strcat(wfile,".wav");
      play_mpeg(d);
      free(wfile);
      mp3towave=0;
    }
    else
    if(isogg(d))
    {
     strcpy(buff,d);
     strcat(buff,".wav");
     oggtowav(d,buff);
    }
   free(d);
  }
}
}

}





void on_oggbutton_clicked(GtkButton *button, gpointer  user_data)
{
GtkCList *cli=NULL;
GList *glist=NULL;
gint row=0;
char *d=NULL;
char *p=NULL;
char *en=NULL;
int num=0;
char buff[10000];

cli=GTK_CLIST(colist2);
glist = cli->selection_end;
row = (glist != NULL) ? (gint)glist->data : -1;
en=NULL;

if(row!=-1)
{
en=gtk_entry_get_text((GtkEntry*)ce);
for(num=0;num<csel_num2;num++)
{
  if(csel2[num])
  {
   gtk_clist_get_text((GtkCList*)colist2,num,0,&p);
   d=(char *)malloc(strlen(p)+2+strlen(en)+2);
   strcpy(d,en);
   strcat(d,p);
    if(ismp3(d))
    {
      mp3towave=1;
      wfile=(char*)malloc(strlen(d)+5);
      strcpy(wfile,d);
      strcat(wfile,".wav");
      play_mpeg(d);
      free(d);
      d=(char*)malloc(strlen(wfile)+1);
      strcpy(d,wfile);
      free(wfile);
      wfile=(char*)malloc(strlen(d)+5);
      strcpy(wfile,d);
      strcat(wfile,".ogg");
      wavtoogg(d,wfile,50);
      free(wfile);
      mp3towave=0;
    }
    else
    if(iswav(d))
    {
     strcpy(buff,d);
     strcat(buff,".ogg");
     wavtoogg(d,buff,0);
    }
   free(d);
  }
}
}

}



int wavtoogg(char *s,char *t,int l)
{
char buff[10000];
FILE *fptr;
char *token=NULL;
sprintf(buff,"oggenc \"-q 10\" \"%s\" 2>&1",s);
fptr=popen(buff,"r");

while(1)
{
if(!rline(fptr,buff))break;
  token=strtok(buff,"[");
  if(token!=NULL)
  token=strtok(NULL,"%");
  if(token!=NULL)
{
/*if(atoi(token)>last)*/
  gtk_progress_set_value(GTK_PROGRESS(con_bar),atoi(token));
/*last=atoi(token);*/
}
  while (gtk_events_pending ())
       gtk_main_iteration_do(FALSE);

}

pclose(fptr);

return 1;
}



void
on_tentry_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)widget,ccdir);
tentry=widget;
}



int rline(FILE *fptr,char buff[])
{
int num;
int f=0;
char c;
num=0;


while(1)
{
f=fread(&c,sizeof(char),1,fptr);
if(f==0)return f;
if(c=='\r')break;
printf("%c",c);
buff[num]=c;
num++;
}
buff[num]=0;
return 1;
}



