/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */
/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003,2004 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <gdk/gdkkeysyms.h>
#include <glib.h>
#include <pthread.h>

#include "interface.h"
#include "support.h"
#include "configs.h"
#include <unistd.h>

int which_player=0;

extern int cd_autoplay;
extern char default_playlist_file[1000];
extern int plist_autoplay;
extern int global_exit;

guint cd_timer;
int completed;
int cd_handle;
int display_radio=0;
int r,start_error=0;
int get_config();
int cdstat();
int play_cdauto();
int stop_cd(int);
void load_play(char *);
void on_main_window_playogg_clicked(GtkButton *button, gpointer         user_data);
void do_error_message(char *text);
int play_mpeg(char mp3[]);
void on_main_window_setup_clicked(GtkButton       *button, gpointer         user_data);
int cddb=0;
void xstuff();
int iswav(char *);
int isplaylist(char *fn);
int ismp3(char *);
int isogg(char *);
int play_commandline=0;
void play_single_ogg(char *);
void play_single_mp3(char t[]);
void play_single_wav(char t[]);

int
main (int argc, char *argv[])
{
  GtkWidget *main_window;
  char *ebuff,*t;
  FILE *fptr;


  gtk_set_locale ();

  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");



cddb=1;


if(argc>1)
{
if(strcasecmp(argv[1],"--version")==0)
{
printf("Sonic-Rainbow ALPHA-0.7.2.2\n");
exit(0);
}
else
if(strcasecmp(argv[1],"-version")==0)
{
printf("Sonic-Rainbow ALPHA-0.7.2.2\n");
exit(0);
}
else
if(argc<3)
if((fptr=fopen(argv[1],"rb"))!=NULL)
{
fclose(fptr);

if(ismp3(argv[1]))
play_commandline=2;
else
if(isogg(argv[1]))
play_commandline=3;
else
if(isplaylist(argv[1]))
play_commandline=4;
else
if(iswav(argv[1]))
play_commandline=1;
}

}



  r=get_config();

    if(r!=1)
  {
   if(r==-1)
   {
   ebuff=(char *)malloc(5000);
   t=getenv("HOME");
   sprintf(ebuff,"Errors starting up Sonic-Rainbow\nconfig file %s/sonic-rainbow/sr.config exists but\nis corrupt after clicking OK the setup window will\ncome up and you can re-configure Sonic-Rainbow.\nEnsure you click on the Apply button before the\nExit button. Sonic-Rainbow will then exit and\nrequire you to re-start it.\n\nAlternatively Exit the setup window and then\nwhen Sonic-Rainbow Exits, delete the config file\n%s/sonic-rainbow/sr.config.\nSonic-Rainbow will then attempt to create a default\n%s/sonic-rainbow/sr.config\nnext time you start it.",t,t,t);
   do_error_message(ebuff);
   free(ebuff);
   start_error=1;
on_main_window_setup_clicked(NULL,NULL);
   exit(0);
   }
else
if(r!=1)
{
   ebuff=(char *)malloc(5000);
   t=getenv("HOME");
   sprintf(ebuff,"Errors starting up Sonic-Rainbow\nconfig file %s/sonic-rainbow/sr.config\ndoes not exist. Sonic-Rainbow was unable to\ncreate its directory structure under\n%s\nThis is likely to be a permissions based problem",t,t);
   do_error_message(ebuff);
   free(ebuff);
   start_error=1;
   exit(0);
}

  }


  main_window = create_main_window ();
  gtk_widget_show (main_window);

  completed=0;
 cd_handle=-2;
  stop_cd(cd_handle);

   cd_timer=gtk_timeout_add(250,play_cdauto,NULL);


   close(2);

if(play_commandline==4)
{
  load_play(argv[1]);
  on_main_window_playogg_clicked(NULL,NULL);
}
else
if(play_commandline==3)
{
play_single_ogg(argv[1]);
on_main_window_playogg_clicked(NULL,NULL);
}
else
if(play_commandline==2)
{
play_single_mp3(argv[1]);
on_main_window_playogg_clicked(NULL,NULL);
}
else
if(play_commandline==1)
{
play_single_wav(argv[1]);
on_main_window_playogg_clicked(NULL,NULL);
}
else
 if(default_playlist_file[0]!=0)
 {
  load_play(default_playlist_file);
  if(plist_autoplay)
  on_main_window_playogg_clicked(NULL,NULL);
 }

if(global_exit)
exit(0);

//gdk_threads_enter();
  gtk_main ();
//gdk_threads_leave();

  return 0;
}











