/*
sonic-rainbow (c) 2003-2010 Gary Baker http://sonic-rainbow.sourceforge.net
*/

#include <gtk/gtk.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/ioctl.h>
#include <linux/videodev.h>
#include <linux/soundcard.h>
#include <math.h>

#include <sys/time.h>
#include <signal.h>
#include <malloc.h>
#include "mixer.h"

extern char default_mixer[1000];
void do_error_message(char *text);

void get_mixer_devices(void);
void mixer_bal( GtkAdjustment *get,
                   gpointer         user_data );


static char anum[25][10];
static char rnum[25][10];
static char cnum[25][10];

int mixer_up=0;
extern unsigned int global_volume;
extern int global_balance;
extern GtkObject *madj,*mbadj;

int pcm_chan,vol_chan=-1;

void
on_mexit_clicked                       (GtkButton       *button,
                                        gpointer         user_data);
void
on_radiobutton12_toggled               (GtkToggleButton *get,
                                        gpointer         user_data);

void mixer_sliders( GtkAdjustment *get,
                   gpointer         user_data );

void
on_radiobutton11_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

GtkWidget *mixer_window=NULL;
GtkObject *mixer_adj[25],*mixer_badj;
GtkWidget *mixer_fixed=NULL;
GtkWidget *mixer_vscale[25];
GtkWidget *recm[25];
GtkWidget *mixradm[25];
GtkWidget *mixer_exit=NULL;
GtkWidget *mixer_bvol,*mixer_blab=NULL;
int n,r,chan;
int mixer_devtot=0;


GtkWidget*
create_mixer_window (void)
{
  int num,last;
  GtkWidget *mixlabels[25];
  float b1;


  GSList *fred_group = NULL;
  GtkWidget *reclab,*mutelab;


if(mixer_up)return NULL;
mixer_up=1;


n=mixer_get_num_chan();

for(num=0;num<n;num++)
mixer_adj[num]=NULL;

  mixer_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (mixer_window), "mixer_window", mixer_window);
  gtk_window_set_title (GTK_WINDOW (mixer_window), "Sonic-Rainbow Mixer");

  mixer_fixed = gtk_fixed_new ();
  gtk_widget_ref (mixer_fixed);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "mixer_fixed", mixer_fixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixer_fixed);
  gtk_container_add (GTK_CONTAINER (mixer_window), mixer_fixed);

  gtk_widget_set_usize (mixer_fixed,252,(n*24)+88);

 gtk_widget_show (mixer_window);

  mixer_exit = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (mixer_exit);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "mexit", mixer_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixer_exit);
  gtk_fixed_put (GTK_FIXED (mixer_fixed), mixer_exit,98,(n*24)+56);
  gtk_widget_set_uposition (mixer_exit,98,(n*24)+56);
  gtk_widget_set_usize (mixer_exit, 47, 22);
  last=10;


  mutelab = gtk_label_new ("Mute");
  gtk_widget_ref (mutelab);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "label28",mutelab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mutelab);
  gtk_fixed_put (GTK_FIXED (mixer_fixed),mutelab,170,(n*24)+10 );
  gtk_widget_set_uposition (mutelab,170,(n*24)+10 );
  gtk_widget_set_usize (mutelab, 30, 16);


  reclab = gtk_label_new ("Rec");
  gtk_widget_ref (reclab);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "label28",reclab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (reclab);
  gtk_fixed_put (GTK_FIXED (mixer_fixed),reclab,210,(n*24)+10);
  gtk_widget_set_uposition (reclab,210,(n*24)+10);
  gtk_widget_set_usize (reclab, 30, 16);


  for(num=0;num<n;num++)
  {
chan=chan_get_curr();
chan_set_curr(num);
   mixer_adj[num]=gtk_adjustment_new (chan_get_vol()/10, 0, 10, 1, 0, 0);
chan_set_curr(chan);

   mixer_vscale[num]= gtk_hscale_new (GTK_ADJUSTMENT (mixer_adj[num]));
  gtk_widget_ref (mixer_vscale[num]);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "vscale1", mixer_vscale[num],
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixer_vscale[num]);
  gtk_fixed_put (GTK_FIXED (mixer_fixed), mixer_vscale[num], 70,last);
  gtk_widget_set_uposition (mixer_vscale[num],70,last);
  gtk_widget_set_usize (mixer_vscale[num],100,24);
  gtk_scale_set_draw_value (GTK_SCALE (mixer_vscale[num]), FALSE);
  sprintf(anum[num],"%d",num);

  gtk_signal_connect (GTK_OBJECT (mixer_adj[num]), "value_changed",
                        GTK_SIGNAL_FUNC (mixer_sliders),anum[num]);
chan=chan_get_curr();
chan_set_curr(num);
  mixlabels[num] = gtk_label_new (chan_get_label());
chan_set_curr(chan);
  gtk_widget_ref (mixlabels[num]);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "label28",mixlabels[num],
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixlabels[num]);
  gtk_fixed_put (GTK_FIXED (mixer_fixed),mixlabels[num],0,last);
  gtk_widget_set_uposition (mixlabels[num],0,last);
  gtk_widget_set_usize (mixlabels[num], 61, 16);

  sprintf(cnum[num],"%d",num);

  mixradm[num] = gtk_check_button_new();
  gtk_widget_ref (mixradm[num]);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "checkbutton1", mixradm[num],
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixradm[num]);
  gtk_fixed_put (GTK_FIXED (mixer_fixed), mixradm[num],175, last);
  gtk_widget_set_uposition (mixradm[num],175,last);
  gtk_widget_set_usize (mixradm[num], 20, 15);

chan=chan_get_curr();
chan_set_curr(num);
gtk_toggle_button_set_active((GtkToggleButton*)mixradm[num],chan_is_mute());
chan_set_curr(chan);

  gtk_signal_connect (GTK_OBJECT (mixradm[num]), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton11_toggled),cnum[num]);

chan=chan_get_curr();
chan_set_curr(num);
r=chan_is_record();
chan_set_curr(chan);

if(r)
{

  recm[num] = gtk_radio_button_new(fred_group);
  fred_group = gtk_radio_button_group (GTK_RADIO_BUTTON (recm[num]));
  gtk_widget_ref (recm[num]);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "radiobutton1", recm[num],
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (recm[num]);
  gtk_fixed_put (GTK_FIXED (mixer_fixed), recm[num],215, last);
  gtk_widget_set_uposition (recm[num],215, last);
  gtk_widget_set_usize (recm[num], 20, 20);

sprintf(rnum[num],"%d",num);

  gtk_signal_connect (GTK_OBJECT (recm[num]), "toggled",
                      GTK_SIGNAL_FUNC (on_radiobutton12_toggled),rnum[num]);
chan=chan_get_curr();
chan_set_curr(num);
r=chan_is_recsrc();
chan_set_curr(chan);
if(r)
gtk_toggle_button_set_active((GtkToggleButton*)recm[num],TRUE);


}
  last=last+24;

  }



  gtk_signal_connect (GTK_OBJECT (mixer_exit), "clicked",
                      GTK_SIGNAL_FUNC (on_mexit_clicked),
                      NULL);


chan=chan_get_curr();
chan_set_curr(vol_chan);
b1=chan_get_bal();
   mixer_badj=gtk_adjustment_new (b1, -1, 1, 0.1, 0, 0);
chan_set_curr(pcm_chan);
chan_set_bal(b1);
chan_set_curr(chan);

   mixer_bvol= gtk_hscale_new (GTK_ADJUSTMENT (mixer_badj));
  gtk_widget_ref (mixer_bvol);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "vscale1", mixer_bvol,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixer_bvol);
  gtk_fixed_put (GTK_FIXED (mixer_fixed), mixer_bvol, 70,last+12);
  gtk_widget_set_uposition (mixer_bvol,70,last+12);
  gtk_widget_set_usize (mixer_bvol,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (mixer_bvol), FALSE);

  gtk_signal_connect (GTK_OBJECT (mixer_badj), "value_changed",
                        GTK_SIGNAL_FUNC (mixer_bal), NULL);


  mixer_blab = gtk_label_new ("Balance");
  gtk_widget_ref (mixer_blab);
  gtk_object_set_data_full (GTK_OBJECT (mixer_window), "label28",mixer_blab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (mixer_blab);
  gtk_fixed_put (GTK_FIXED (mixer_fixed),mixer_blab,0,last+18 );
  gtk_widget_set_uposition (mixer_blab,0,last+18);
  gtk_widget_set_usize (mixer_blab, 50, 16);

  return mixer_window;
}



void mixer_bal( GtkAdjustment *get,
                   gpointer         user_data )
{
int chan;
gtk_adjustment_set_value((GtkAdjustment*)mbadj,get->value);
chan=chan_get_curr();
chan_set_curr(vol_chan);
chan_set_bal(get->value);
chan_set_curr(pcm_chan);
chan_set_bal(get->value);
chan_set_curr(chan);
}




void mixer_sliders( GtkAdjustment *get,
                   gpointer         user_data )
{
int p;

p=atoi(user_data);
if(p==vol_chan)
gtk_adjustment_set_value((GtkAdjustment *)madj,get->value);
chan=chan_get_curr();
chan_set_curr(p);
chan_set_vol(get->value*10);
chan_set_curr(chan);
}



void
on_radiobutton12_toggled               (GtkToggleButton *get,
                                        gpointer         user_data)
{
int chan,p,a;


p=atoi(user_data);

a=gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (get));
if(a)
{
chan=chan_get_curr();
chan_set_curr(p);
chan_set_rec(3);
chan_set_curr(chan);
}
else
{
chan=chan_get_curr();
chan_set_curr(p);
chan_set_rec(0);
chan_set_curr(chan);
}

}


void
on_radiobutton11_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
int which;
int chan;

which=atoi(user_data);
chan=chan_get_curr();
chan_set_curr(which);
chan_toggle_mute();
chan_set_curr(chan);
}


void
on_mixer_button_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
create_mixer_window();
}



void
on_mexit_clicked                       (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(mixer_window);
mixer_up=0;
}




