/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <ao/ao.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <mad.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <time.h>
#include <math.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <sys/types.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <audiofile.h>
#include <FLAC/all.h>
#include<FLAC/seekable_stream_decoder.h>
#include <FLAC/stream_decoder.h>

extern GtkWidget *pslide;
extern GtkObject *padj;
extern GtkWidget *main_window_oggscrolled,*hw;
extern GtkWidget *main_window_oggclist;
extern int global_exit;
extern char *adata;
extern char *fdata;
extern char *ddata;
extern char help[];
GtkWidget *main_window_ogg_entry;
extern int tooltip;

char *playlist_dir=NULL;

static FLAC__StreamDecoderWriteStatus write_cb(const FLAC__StreamDecoder *decoder, const FLAC__Frame *frame, const FLAC__int32 * const buffer[], void * client_data);

static FLAC__StreamDecoderReadStatus read_cb(const FLAC__StreamDecoder *decoder, FLAC__byte buffer[], unsigned *bytes, void *client_data);

static void meta_cb(const FLAC__StreamDecoder *decoder, const FLAC__StreamMetadata *metadata, void * client_data);

static void error_cb(const FLAC__StreamDecoder *decoder, FLAC__StreamDecoderErrorStatus status, void *client_data);

void on_nb_clicked(GtkButton       *button, gpointer         user_data);

FILE *flac_ptr;

int get_flac_labels(char *fn, int n);
int isflac(char *fn);
int play_flac(char *fn);

int prelease=0;

long ogg_length(char *f);
long wav_length(char *f);
int load_m3u(char *sfile);
int load_play();
int ismp3(char *);
void play_wav();
int isdir(char *is);
GtkWidget* create_awindow2 (char *);
GtkWidget* create_single_dir_window (char *sd);

extern int cd_handle,completed;
extern int disk_present;
extern int sel_tracks[100];
extern guint cd_timer;
extern GtkWidget *rlist_item;
extern GtkWidget *rip_list;
extern char *music_dir;
extern int isok,plist_autoplay;
extern char default_playlist_file[1000];
extern char default_playlist_dir[1000];
extern int play_error;
extern int http_lookup;
extern int mp3towave;
extern char *wfile;

GtkWidget *oggf,*playlist_direntry,*gw,*create_plist,*fentry,*dentry,*lp,*cp,*cpa,*bpa=NULL;
GtkWidget *mp,*mpa,*mpb,*mod_playlist_direntry,*addfrom_list=NULL;
GtkWidget *addfrom_save=NULL;
GtkWidget *load_filedir=NULL;
GtkWidget *save_pl=NULL;

GtkWidget *dw=NULL;
extern GtkWidget *radioplayer;
extern GtkWidget *helpbutton;
extern GtkWidget *vbuttonbox1;
extern GtkWidget *vbutton2;
extern GtkWidget *vbutton3;
extern GtkWidget *vbutton4;
extern GtkWidget *vbutton5;
extern GtkWidget *vbutton6;
extern GtkWidget *ffw,*rew;

int MpegAudioDecoder(char *fn);

int snum=-1;
int afile=0;
int dowhat=0;
int play_num=0;
int ogglist_first=0;
int oggscrolled_first=0;
char oggfiledir[1000];
int ogg_files=0;
int ogg_file_count();
int isogg(char *);
void free_ogg_files();
int play_ogg(int ofp);
void play_single_mp3(char t[]);
void single_mp3(char *p,int n);
void single_wav(char *t,int n);
void single_ogg(char *t,int n);
char * nline(char *str, char *ptr);
char *loaded_play_list=NULL;

int psel=-1;
int ismod=0;
int pauseres=0;
int inplayogg=0;
float g_p=0;

struct buffer {
  unsigned char const *start;
  unsigned long length;
};

struct oggdir
{
char *file_path;
char *fname;
char *title;
char *artist;
} **ogg_dir;


ao_device *device=NULL;
ao_sample_format format;
int default_driver;
int play_mpeg(char *mp3);
void single_dir(char *b, GtkCList *);
void shuffle_list();

static enum mad_flow input(void *data,struct mad_stream *stream);
static inline signed int scale(mad_fixed_t sample);
static enum mad_flow error(void *data,struct mad_stream *stream,struct mad_frame *frame);
static int decode(unsigned char const *start, unsigned long length);
static enum mad_flow output(void *data,struct mad_header const *header,struct mad_pcm *pcm);
void do_error_message(char *text);
void do_help_message(char *text);
int iswav(char *);
int isplaylist(char *fn);
void play_single_ogg(char *);
void play_single_wav(char t[]);
void p_release(GtkWidget *widget,GdkEventButton  *event,gpointer user_data);
void p_press(GtkWidget *widget,GdkEventButton  *event,gpointer user_data);


void
on_main_window_drag_data_received      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data);

void on_ffw_clicked(GtkButton       *button, gpointer         user_data);
void on_rew_clicked(GtkButton       *button, gpointer         user_data);
void p_change( GtkAdjustment *get, gpointer         user_data );

void shuffle_list()
{
int num,b;
void *o;
char *dat[3];

if(ogg_files<3)return;

gtk_clist_clear((GtkCList*)main_window_oggclist);


srand(time(NULL));
for(num=0;num<ogg_files;num++)
{
o=ogg_dir[num];
b=(rand()%ogg_files);
ogg_dir[num]=ogg_dir[b];
ogg_dir[b]=o;
}

dat[2]=NULL;

for(num=0;num<ogg_files;num++)
{
    dat[0]=ogg_dir[num]->title;
    dat[1]=ogg_dir[num]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

if(inplayogg)
{
dowhat=3;
play_num=0;
}
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}


void
on_main_window_drag_data_received      (GtkWidget       *widget,
                                        GdkDragContext  *drag_context,
                                        gint             x,
                                        gint             y,
                                        GtkSelectionData *data,
                                        guint            info,
                                        guint            time,
                                        gpointer         user_data)
{
char *mtoken=NULL;
char *t;
char *dat[3];
char *db=NULL;

gtk_drag_finish(drag_context,1,0,time);
dowhat=-1;


db=data->data;


while(1)
{

if(mtoken)
free(mtoken);
mtoken=NULL;
mtoken=nline(db,mtoken);
if(mtoken==NULL)break;
db=db+strlen(mtoken)+1;


if(strncasecmp(mtoken,"file:/",6)==0)
{
 if(isdir(mtoken+5))
 {
  t=(char *)malloc(strlen(mtoken));
  strcpy(t,mtoken+5);
  strcat(t,"/");
  single_dir(t,(GtkCList*)main_window_oggclist);
  free(t);
 }
else
if(isflac(mtoken+5))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 get_flac_labels(mtoken+5,ogg_files);

/*
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
*/
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
}
else
if(ismp3(mtoken+5))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_mp3(mtoken+5,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}
else
if(iswav(mtoken+5))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_wav(mtoken+5,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}
else
if(isogg(mtoken+5))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_ogg(mtoken+5,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}

}

else
{
 if(isdir(mtoken))
 {
  t=(char *)malloc(strlen(mtoken)+1);
  strcpy(t,mtoken);
  strcat(t,"/");
  single_dir(t,(GtkCList*)main_window_oggclist);
  free(t);
 }
else
if(ismp3(mtoken))
{

ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);

single_mp3(mtoken,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}
else
if(isflac(mtoken))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 get_flac_labels(mtoken+5,ogg_files);

/*
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
*/
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
}
else
if(iswav(mtoken))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_wav(mtoken,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}
else
if(isogg(mtoken))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_ogg(mtoken,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);

ogg_files++;
}
}


}

if(ogg_files)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
play_num=0;
return;
}



void play_single_wav(char t[])
{
int n=0;
char  *dat[3];

    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;

    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");


for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}




void play_single_ogg(char t[])
{
int n=0;
FILE *fptr;
OggVorbis_File vf;
char *token, *dat[3];
int i;


   if((fptr=fopen(t,"rb"))!=NULL)
   {

   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;

       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }

for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}




}






void play_single_mp3(char t[])
{
int n=0;
char *dat[3];
struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b;



    ogg_files=1;
    n=0;
    ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;


    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);




    id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);

    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {

          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */


if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}


if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;


for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}


gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}


void on_main_window_blank_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
if(loaded_play_list!=NULL)
{
free(loaded_play_list);
loaded_play_list=NULL;
}

if(playlist_dir!=NULL)
{
free(playlist_dir);
playlist_dir=NULL;
}

if(inplayogg)
dowhat=-1;
gtk_clist_clear((GtkCList*)main_window_oggclist);

if(ogg_files)
free_ogg_files();
ogg_files=0;
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
play_num=0;
}


void on_main_window_shuffle_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
shuffle_list();
}


void on_main_window_sal_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
if(save_pl!=NULL)return;
 save_pl=create_create_playlist_window();
if(playlist_dir)
 gtk_file_selection_set_filename ((GtkFileSelection *)save_pl,playlist_dir);
else
gtk_file_selection_set_filename ((GtkFileSelection *)save_pl,default_playlist_dir);

 gtk_widget_show(save_pl);

gtk_entry_set_text((GtkEntry*)fentry,loaded_play_list);
gtk_main();

gtk_widget_destroy(save_pl);
save_pl=NULL;
return;
}



void on_main_window_playogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
static int num=-1;


if(!ogg_files)return;

inplayogg=1;

dowhat=0;



if(num==-1)
{
num=0;
while(1)
{
dowhat=0;
gtk_signal_handler_block_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
gtk_clist_select_row ((GtkCList*)main_window_oggclist,play_num,0);
gtk_signal_handler_unblock_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
if(ismp3(ogg_dir[play_num]->file_path))
{
play_mpeg(ogg_dir[play_num]->file_path);
}
else
if(isflac(ogg_dir[play_num]->file_path))
{
play_flac(ogg_dir[play_num]->file_path);
}
else
if(iswav(ogg_dir[play_num]->file_path))
{
play_wav(ogg_dir[play_num]->file_path);
}
else
play_ogg(play_num);

if(global_exit)break;

if(dowhat==-2){load_play("/tmp/sr.tmp");continue;}

if(dowhat==-1)break;   /* stop */
if(dowhat==2)continue;/*{num=play_num;continue;}*/
if(dowhat==3)continue;/*{play_num--;continue;}*/

if(play_num<ogg_files-1)
play_num++;
else
break;
}


num=-1;
}

inplayogg=0;

dowhat=0;
}






void
on_main_window_playogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{
dowhat=0;
}


void
on_main_window_stopogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
dowhat=-1;
pauseres=0;
}


void
on_main_window_stopogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_prevogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

if(play_num>0)play_num--;
if(ogg_dir!=NULL)
{
if(!inplayogg)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
gtk_signal_handler_block_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
gtk_clist_select_row ((GtkCList*)main_window_oggclist,play_num,0);
gtk_signal_handler_unblock_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
dowhat=2;
}
pauseres=0;
}


void
on_main_window_prevogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_nextogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
if(play_num<ogg_files-1)play_num++;
if(ogg_dir!=NULL)
{
if(!inplayogg)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
gtk_signal_handler_block_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
gtk_clist_select_row ((GtkCList*)main_window_oggclist,play_num,0);
gtk_signal_handler_unblock_by_func((GtkObject *)main_window_oggclist,on_main_window_oggclist_select_row,NULL);
dowhat=3;
}
pauseres=0;
}


void
on_main_window_nextogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_pauseogg_clicked        (GtkButton       *button,
                                        gpointer         user_data)
{
pauseres=1;
}


void
on_main_window_pauseogg_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_resogg_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
pauseres=0;
}


void
on_main_window_resogg_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}



void
on_main_window_browaeogg_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{

}



void
on_main_window_listogg_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{

/*
gtk_clist_all((GtkCList *)main_window_oggclist);
*/

if(ogglist_first==0)
{
gtk_widget_show(main_window_oggscrolled);
gtk_widget_show(main_window_oggclist);
if(!inplayogg)
{
gtk_widget_hide(radioplayer);
gtk_widget_hide(helpbutton);
gtk_widget_show(vbuttonbox1);
gtk_widget_show(vbutton2);
gtk_widget_show(vbutton3);
gtk_widget_show(vbutton4);
gtk_widget_show(vbutton5);
gtk_widget_show(vbutton6);
}
ogglist_first=1;
}
else
{
gtk_widget_hide(main_window_oggclist);
gtk_widget_hide(main_window_oggscrolled);
gtk_widget_show(radioplayer);
gtk_widget_show(helpbutton);
gtk_widget_hide(vbuttonbox1);
gtk_widget_hide(vbutton2);
gtk_widget_hide(vbutton3);
gtk_widget_hide(vbutton4);
gtk_widget_hide(vbutton5);
gtk_widget_hide(vbutton6);
ogglist_first=0;
if(addfrom_list!=NULL){gtk_widget_destroy(addfrom_list);addfrom_list=NULL;adata=NULL;gtk_main_quit();}
}

}





void
on_main_window_listogg_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_main_window_oggclist_select_row     (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
snum=-1;
if(event!=NULL)
{
if(((GdkEventButton*)event)->button==1)
{
gtk_widget_hide(main_window_oggscrolled);
gtk_widget_hide(main_window_oggclist);

gtk_widget_show(radioplayer);
gtk_widget_show(helpbutton);
gtk_widget_hide(vbuttonbox1);
gtk_widget_hide(vbutton2);
gtk_widget_hide(vbutton3);
gtk_widget_hide(vbutton4);
gtk_widget_hide(vbutton5);
ogglist_first=0;
oggscrolled_first=1;
play_num=row;
snum=row;
/*
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[play_num]->title);
*/
if(inplayogg==0)
{
pauseres=0;
on_main_window_playogg_clicked(NULL,NULL);
}
else              /* playing ledt button clicked  next or prev */
{
pauseres=0;
play_num=row;
dowhat=3;
}
}
else        /* right button */
{
snum=row;
}
}

else
{
if(inplayogg==0)
{
play_num=row;
on_main_window_playogg_clicked(NULL,NULL);
}
else
{
play_num=row;
dowhat=3;
/*snum=play_num;*/   /* next and prev */
;/* allready playing select forced */
}


}

}


void
on_main_window_oggclist_realize        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_main_window_oggclist_map            (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_scrolledwindow2_map                 (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_scrolledwindow2_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{

}






void
on_main_window_ogg_entry_realize       (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


int ogg_file_count()
{
DIR *d=NULL;
int n;
char t[1000];
FILE *fptr1=NULL;
struct dirent *dent=NULL;
OggVorbis_File vf1;
int a;

n=0;
d=opendir(oggfiledir);
if(d==NULL)return 0;


while(1)
{
dent=readdir(d);
if(dent==NULL)break;
if(dent->d_name[0]!='.')
{
 strcpy(t,oggfiledir);
 if(t[strlen(t)-1]!='/')
 strcat(t,"/");
 strcat(t,dent->d_name);



   if((fptr1=fopen(t,"r"))!=NULL)
   {
      a=ov_open(fptr1, &vf1, NULL, 0);
      if(a>=0)
      {
        n++;
        ov_clear(&vf1);
      }
      else
     {
       fclose(fptr1);
       if(ismp3(t))
       n++;
       else
       if(iswav(t))
       n++;
       else
       if(isflac(t))
       n++;
     }


   }
}
}
   closedir(d);
   return n;
}




int isogg(char *b)
{
FILE *p;
OggVorbis_File vf;

if((p=fopen(b,"rb"))==NULL)return 0;
if(ov_open(p, &vf, NULL, 0) < 0) {fclose(p);return 0;}
ov_clear(&vf);
return 1;
}



void free_ogg_files()
{
int n;

for(n=0;n<ogg_files;n++)
{
 free(ogg_dir[n]->file_path);
ogg_dir[n]->file_path=NULL;
 free(ogg_dir[n]->fname);
ogg_dir[n]->fname=NULL;
 free(ogg_dir[n]->title);
ogg_dir[n]->title=NULL;
 free(ogg_dir[n]->artist);
ogg_dir[n]->artist=NULL;
 free(ogg_dir[n]);
ogg_dir[n]=NULL;
}
free(ogg_dir);
ogg_dir=NULL;
ogg_files=0;
}




int play_ogg(int ofp)
{
FILE *fptr;
OggVorbis_File vf;
vorbis_info *vi;
char *ebuff;
int eof=0;
int current_section;
char pcmout[4096];
long ret;
float x;
int l=0;

if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,0);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}

if((fptr=fopen(ogg_dir[ofp]->file_path,"rb"))==NULL)
{
if(!play_error)
{
  ebuff=(char *)malloc(5000);
 sprintf(ebuff,"Sonic-Rainbow cannot open file %s",ogg_dir[ofp]->file_path);
   do_error_message(ebuff);
   free(ebuff);
   }
   return 0;
}

ov_open(fptr, &vf, NULL, 0);
vi=ov_info(&vf,-1);

format.bits = 16;
format.channels = vi->channels;
format.rate = vi->rate;

format.byte_format = AO_FMT_LITTLE;
	ao_initialize();
	default_driver = ao_default_driver_id();
	device = ao_open_live(default_driver, &format, NULL /* no options */);
	if (device == NULL) {
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Sound Driver");
fclose(fptr);
   do_error_message(ebuff);
   free(ebuff);
		return 0;
	}

	eof=0;

  while(!eof)
  {
    if(dowhat!=4 && dowhat !=5 && dowhat!=6)
    {
    if(dowhat!=0)break;
    }
    if(global_exit)break;
    if(pauseres==0)
    {
     gtk_main_iteration_do(FALSE);
     gtk_main_iteration_do(FALSE);
      ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
      if(dowhat==4)
      {
        ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
        if(ret==0){dowhat=0;break;}
        ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
        if(ret==0){dowhat=0;break;}
        ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
        if(ret==0){dowhat=0;break;}
        ret=ov_read(&vf,pcmout,4096,0,2,1,&current_section);
        if(ret==0){dowhat=0;break;}
      }
      else
     if(dowhat==5)
     {
      if(vf.pcm_offset-4096>-1)
      ov_pcm_seek(&vf,vf.pcm_offset-4096);
     }
     else
     if(dowhat==6)
     {
      dowhat=0;
      x=g_p/100;
      x=x*ov_pcm_total(&vf,0);
      ov_pcm_seek(&vf,x);
     }

       if (ret == 0)
       {
         /* EOF */
         eof=1;
       }
        else
        if (ret < 0)
        {
         /* error in the stream.  Not a problem, just reporting it in
	 case we (the app) cares.  In this case, we don't. */
        }
         else
         {
           /* we don't bother dealing with sample rate changes, etc, but
	   you'll have to*/
        	   ao_play(device,pcmout, ret);

          x=(float)vf.pcm_offset/(float)ov_pcm_total(&vf,0);
          x=x*100;
if(l!=(int)x)
{
if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,x);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}
}
l=(int)x;

        }
      if(dowhat!=4 && dowhat!=5)
      {
      if(dowhat!=0)break;
      }
      if(global_exit)break;
     }
    else
    {
      gtk_main_iteration_do(FALSE);
      if(dowhat!=0)break;
      if(global_exit)break;
    }
  }
ov_clear(&vf);
ao_close(device);
ao_shutdown();
device=NULL;
return 1;
}





void
on_main_window_delplaylist_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
char *mtoken=NULL;
char *db=NULL;
GtkWidget *a;

afile=1;
a=create_awindow2(default_playlist_dir);
gtk_widget_show(a);
gtk_main();


db=adata;

mtoken=NULL;

if(adata!=NULL)
{

while(1)
{
if(mtoken)
free(mtoken);
mtoken=NULL;
mtoken=nline(db,mtoken);
if(mtoken==NULL)break;
remove(mtoken);
db=db+strlen(mtoken)+1;
}

}

gtk_widget_destroy(a);
free(adata);
adata=NULL;
}



void
on_main_window_delplaylist_realize     (GtkWidget       *widget,
                                        gpointer         user_data)
{

}





void
on_main_window_loadplaylist_clicked    (GtkButton       *button,
                                        gpointer         user_data)
{
if(lp)return;
lp=single_file_window (default_playlist_dir);
 gtk_widget_show(lp);
gtk_main();
if(fdata!=NULL)
{
load_play(fdata);
free(fdata);
fdata=NULL;
}
gtk_widget_destroy(lp);
lp=NULL;
}


void
on_main_window_loadplaylist_ok_clicked (GtkButton       *button,
                                        gpointer         user_data)
{

char b[1000];


play_num=0;
 strcpy(b,gtk_file_selection_get_filename ((GtkFileSelection *)lp));
 if(b[strlen(b)-1]!='/')
 {
  load_play(b);
 }

gtk_widget_destroy(lp);
lp=NULL;
}




int  load_play(char bu[])
{
FILE *fptr,*fptr1,*fptr2;
char t[1000];
DIR *d;
char *ebuff;
struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b=NULL;
int num=0;
int n=0;
int i=0;
int j=0;

struct dirent *dent;
char *dat[3],*token;
OggVorbis_File vf;
struct oggdir *ta;

if(ogg_files)
free_ogg_files();

ogg_files=0;

gtk_clist_clear((GtkCList*)main_window_oggclist);

if(load_m3u(bu))
{


if(playlist_dir!=NULL)
{
free(playlist_dir);
playlist_dir=NULL;
}
if(loaded_play_list!=NULL)
{
free(loaded_play_list);
loaded_play_list=NULL;
}

playlist_dir=(char*)malloc(strlen(bu)+2);
strcpy(playlist_dir,bu);
playlist_dir[strlen(bu)+1-strlen(strrchr(bu,47))]=0;

if(ogg_files>0)
{
for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    dat[2]=NULL;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

//if(n==0)
//gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
//else
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
}

play_num=0;
return 1;
}



if(playlist_dir!=NULL)
{
free(playlist_dir);
playlist_dir=NULL;
}
if(loaded_play_list!=NULL)
{
free(loaded_play_list);
loaded_play_list=NULL;
}

playlist_dir=(char*)malloc(strlen(bu)+2);
strcpy(playlist_dir,bu);
playlist_dir[strlen(bu)+1-strlen(strrchr(bu,47))]=0;

if((fptr=fopen(bu,"rb"))==NULL)
{
   ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Playlist %s",bu);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}
fgets(t,900,fptr); /* Sonic-Rainbow Header */

loaded_play_list=(char*)malloc(strlen(bu)+1);
strcpy(loaded_play_list,strrchr(bu,'/')+1);

while(1)
{
 if((fgets(t,900,fptr))==NULL)break;
 if(t[strlen(t)-1]==10)
 t[strlen(t)-1]=0;
 if((d=opendir(t))!=NULL)
 {
  closedir(d);
  strcpy(oggfiledir,t);
  num=num + ogg_file_count();
 }
 else
 if(isogg(t))
 num++;
 else
 if(iswav(t))
 num++;
 else
 if(ismp3(t))
 num++;
 else
 if(isflac(t))
 num++;
}
fclose(fptr);


ogg_files=num;
n=0;

if(ogg_files!=0)
{
ogg_dir=(struct oggdir **)calloc(ogg_files,sizeof(struct oggdir *));
/*
ogg_dir=malloc(ogg_files * sizeof(struct oggdir *));
*/
}
else
ogg_dir=NULL;



if((fptr1=fopen(bu,"rb"))==NULL)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open Playlist %s",bu);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}


fgets(t,900,fptr1); /* Sonic-Rainbow Header */



while(1)
{
 if((fgets(t,900,fptr1))==NULL)break;
  if(t[strlen(t)-1]==10)
   t[strlen(t)-1]=0;

 if((d=opendir(t))!=NULL)/* fill dir */
 {
  strcpy(oggfiledir,t);
  if(t[strlen(t)-1]!='/')
  strcat(oggfiledir,"/");
  while(1)
  {
   dent=readdir(d);
  if(dent==NULL)break;
  if(dent->d_name[0]!='.')
  {

   strcpy(t,oggfiledir);
   strcat(t,dent->d_name);

if(isflac(t))
{
/*
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
*/
 get_flac_labels(t,n);
    n++;
}
else
if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
    n++;
}
else
   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(dent->d_name)+1);
    strcpy(ogg_dir[n]->fname,dent->d_name);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 ov_clear(&vf);
  }
  else
  {
    fclose(fptr);
       if(ismp3(t))
    {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

         if(ogg_dir[n]->title==NULL)
         {
           ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
           strcpy(ogg_dir[n]->title,"Unknown");
         }

           if(ogg_dir[n]->artist==NULL)
           {
             ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
             strcpy(ogg_dir[n]->artist,"Unknown");
            }

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    }
  }

 }



}
}

  closedir(d);

for(;j<n;j++)
for(i=j;i<n-1;i++)
{
if(strcmp(ogg_dir[j]->file_path,ogg_dir[i+1]->file_path)>0)
{
ta=ogg_dir[i+1];
ogg_dir[i+1]=ogg_dir[j];
ogg_dir[j]=ta;
}
}


}


 else
  if(ismp3(t))
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char*)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char*)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->artist==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}
    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    n++;
    j++;
    }
 else
if(iswav(t))
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
    n++;
}
else
 if(isogg(t))
 {

    if((fptr2=fopen(t,"rb"))!=NULL)
   {

   if(ov_open(fptr2, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;


       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
               }
               else
              if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
              {
               token=strtok(vf.vc->user_comments[i],"=");
               token=strtok(NULL,"");
               ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->artist,token);
               dat[1]=ogg_dir[n]->artist;
              }

         }


 n++;
 j++;
 ov_clear(&vf);
  }
  else
  {
    fclose(fptr2);
  }

 }

  /* fill one struct */
 }




} /* end of while loop */
fclose(fptr1);



ogg_files=n;



if(ogg_files>0)
{

for(n=0;n<ogg_files;n++)
{
    dat[0]=ogg_dir[n]->title;
    dat[1]=ogg_dir[n]->artist;
    dat[2]=NULL;
    gtk_clist_append((GtkCList *)main_window_oggclist,dat);
}

if(n==0)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
else
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
}

play_num=0;
return 1;
}






void
on_create_playlist_window_fixed_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)
{

}





void
on_create_playlist_direntry_realize    (GtkWidget       *widget,
                                        gpointer         user_data)
{
playlist_direntry=widget;
if(playlist_dir)
gtk_entry_set_text((GtkEntry *)playlist_direntry,playlist_dir);
else
gtk_entry_set_text((GtkEntry *)playlist_direntry,default_playlist_dir);
}




void
on_create_playlist_fileentry_realize   (GtkWidget       *widget,
                                        gpointer         user_data)
{
fentry=widget;
}






void
on_create_playlist_browse_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
if(bpa)return;
if(playlist_dir)
bpa=create_single_dir_window (playlist_dir);
else
bpa=create_single_dir_window (default_playlist_dir);

gtk_widget_show(bpa);
gtk_main();
if(ddata!=NULL)
{
if(playlist_dir)
free(playlist_dir);
playlist_dir=NULL;
playlist_dir=(char*)malloc(strlen(ddata)+1);
strcpy(playlist_dir,ddata);
gtk_entry_set_text((GtkEntry *)playlist_direntry,ddata);
free(ddata);
ddata=NULL;
}
gtk_widget_destroy(bpa);
bpa=NULL;
}




void
on_create_playlist_exit_button_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_main_quit();
}





int
on_create_playlist_save_button_clicked (GtkButton       *button,
                                        gpointer         user_data)
{
char *a=NULL;
char *b=NULL;
char *p=NULL;
FILE *fptr;
char *ebuff;
int num;
char sb[1000];
long len;

a=gtk_entry_get_text((GtkEntry*)fentry);
b=gtk_entry_get_text((GtkEntry*)playlist_direntry);


if(strlen(a)!=0 && strlen(b)!=0)
{
p=(char*)malloc(strlen(a)+strlen(b)+2);
strcpy(p,b);

if(p[strlen(p)-1]!='/')strcat(p,"/");
strcat(p,a);

if((fptr=fopen(p,"wb"))==NULL)
{
free(p);
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create Playlist %s",p);
   do_error_message(ebuff);
   free(ebuff);
gtk_main_quit();
   return 0;
}

/*
fprintf(fptr,"Sonic-Rainbow Playlist\n");
*/
fprintf(fptr,"#EXTM3U\n");
for(num=0;num<ogg_files;num++)
{
if(iswav(ogg_dir[num]->file_path))
len=wav_length(ogg_dir[num]->file_path);
else
if(isogg(ogg_dir[num]->file_path))
len=ogg_length(ogg_dir[num]->file_path);
else
len=0;

sprintf(sb,"#EXTINF:%ld,%s\n",len,ogg_dir[num]->title);
fprintf(fptr,"%s",sb);
fprintf(fptr,"%s\n",ogg_dir[num]->file_path);
}

fclose(fptr);
free(p);
gtk_main_quit();
return 1;
}
else
{
free(p);
 ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot create Playlist");
   do_error_message(ebuff);
   free(ebuff);
gtk_main_quit();
   return 0;
}

gtk_main_quit();
return 0;

}





void
on_create_playlist_cancel_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_main_quit();
}







static int decode(unsigned char const *start, unsigned long length)
{
  struct buffer buffer;
  struct mad_decoder decoder;
  int result;

  /* initialize our private message structure */

  buffer.start  = start;
  buffer.length = length;

  /* configure input, output, and error functions */

  mad_decoder_init(&decoder, &buffer,
		   input, 0 /* header */, 0 /* filter */, output,
		   error, 0 /* message */);

  /* start decoding */

  result = mad_decoder_run(&decoder, MAD_DECODER_MODE_SYNC);

  /* release the decoder */

  mad_decoder_finish(&decoder);

  return result;
}

static enum mad_flow input(void *data,struct mad_stream *stream)
{
  struct buffer *buffer = data;

  if (!buffer->length)
    return MAD_FLOW_STOP;

  mad_stream_buffer(stream, buffer->start, buffer->length);

  buffer->length = 0;

  return MAD_FLOW_CONTINUE;
}

static inline signed int scale(mad_fixed_t sample)
{
  /* round */
  sample += (1L << (MAD_F_FRACBITS - 16));

  /* clip */
  if (sample >= MAD_F_ONE)
    sample = MAD_F_ONE - 1;
  else if (sample < -MAD_F_ONE)
    sample = -MAD_F_ONE;

  /* quantize */
  return sample >> (MAD_F_FRACBITS + 1 - 16);
}

static enum mad_flow error(void *data,struct mad_stream *stream,struct mad_frame *frame)
{
  return MAD_FLOW_BREAK;
}



int play_mpeg(char mp3[])
{
 struct stat stat;
 void *fdm;
 FILE *mpg;
 char *ebuff;

if((mpg=fopen(mp3,"rb"))==NULL)
{
if(!play_error)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open File\n%s\nThis may be a permissions based problem",mp3);
   do_error_message(ebuff);
   free(ebuff);
}
return -1;
}

   if(device!=NULL)
   {
   ao_close(device);
   ao_shutdown();
   device=NULL;
   }

if(mpg==NULL)return 0;

fclose(mpg);

MpegAudioDecoder(mp3);

if(device!=NULL)
{
   ao_close(device);
   ao_shutdown();
   device=NULL;
}

return 1;

   if (fstat(fileno(mpg), &stat) == -1 ||
      stat.st_size == 0) return -1;

  fdm = mmap(0, stat.st_size, PROT_READ, MAP_SHARED,fileno(mpg) , 0);

  fclose(mpg);

  if (fdm == MAP_FAILED)
  {
  return -2;
}


  decode(fdm, stat.st_size);

gtk_signal_handler_unblock_by_func((GtkObject *)ffw,on_ffw_clicked,NULL);
gtk_signal_handler_block_by_func((GtkObject *)rew,on_rew_clicked,NULL);


if(device!=NULL)
{
   ao_close(device);
   ao_shutdown();
   device=NULL;
}

gtk_widget_set_sensitive (ffw, TRUE);

  if (munmap(fdm, stat.st_size) == -1)
  {
    return -3;
    }

return 0;
}





static
enum mad_flow output(void *data,
		     struct mad_header const *header,
		     struct mad_pcm *pcm)
{
  unsigned int nchannels, nsamples;
  mad_fixed_t const *left_ch, *right_ch;
  char *b;
  int c=0;

  nchannels = pcm->channels;
  nsamples  = pcm->length;
  left_ch   = pcm->samples[0];
  right_ch  = pcm->samples[1];




if(device==NULL)
{
   ao_initialize();
   default_driver = ao_default_driver_id();
   format.bits =16;
   format.channels = pcm->channels;
   format.rate = pcm->samplerate;
   format.byte_format = AO_FMT_LITTLE;
   device = ao_open_live(default_driver, &format, NULL );
   if(device==NULL)return MAD_FLOW_STOP;
}


while(pauseres)
{
  while (gtk_events_pending())
          gtk_main_iteration();
	  if(dowhat!=0|| global_exit)
{
return MAD_FLOW_STOP;
}
}


 b=(char*)malloc(nsamples*4);

  while (nsamples--) {
    signed int sample;

    /* output sample(s) in 16-bit signed little-endian PCM */

    if (nchannels == 2) {
    sample = scale(*left_ch++);
      b[0+c]=(sample >> 0) & 0xff;
      b[1+c]=(sample >> 8) & 0xff;
      sample = scale(*right_ch++);
      b[2+c]=(sample >> 0) & 0xff;
      b[3+c]=(sample >> 8) & 0xff;
      c=c+4;
      }
      else
      {
      b[0+c]=b[2];
      b[1+c]=b[3];
      c=c+2;
      }

  }
    if (nchannels == 2)
  ao_play(device, b, pcm->length*4);
else
 ao_play(device, b, pcm->length*2);
  free(b);
  while (gtk_events_pending())
          gtk_main_iteration();
	  if(dowhat!=0|| global_exit)
{
return MAD_FLOW_STOP;
}
  return MAD_FLOW_CONTINUE;
}


int isplaylist(char *fn)
{
FILE *f;
char b[80];

if((f=fopen(fn,"rb"))==NULL)return 0;
if((fgets(b,79,f))==NULL){fclose(f);return 0;}
fclose(f);
b[strlen(b)-1]=0;

if(strcmp(b,"Sonic-Rainbow Playlist")==0)return 1;
return 0;
}


int ismp3(char *fn)
{
 char *p;
 if(strlen(fn)<5)return 0;
 p=fn+strlen(fn)-3;
 if(strcasecmp(p,"mp3")==0)return 1;
 else
 return 0;
}


int iswav(char *fn)
{

AFfilehandle	file;
int a,v;



file = afOpenFile(fn, "r", NULL);
a=afGetFileFormat (file, &v);
afCloseFile(file);
if(a==AF_FILE_WAVE)
return 1;
else
return 0;

}


void play_wav(char *fn)
{
	AFfilehandle	file;
	AFframecount	frameCount, framesRead;
	int		sampleFormat, sampleWidth, channelCount;
	float		frameSize;
	void		*buffer;
int a,v=0;
float n,x=0;
double sampleRate;
int l=0;

gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,0);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);

	file = afOpenFile(fn, "r", NULL);
a=afGetFileFormat (file, &v);

if(a!=AF_FILE_WAVE)
{
afCloseFile(file);
return;
}
	frameCount = afGetFrameCount(file, AF_DEFAULT_TRACK);

	channelCount = afGetVirtualChannels(file, AF_DEFAULT_TRACK);
	afGetVirtualSampleFormat(file, AF_DEFAULT_TRACK, &sampleFormat,
		&sampleWidth);
        sampleRate = afGetRate(file, AF_DEFAULT_TRACK);
	frameSize = afGetVirtualFrameSize(file, AF_DEFAULT_TRACK, 1);


	if ((sampleFormat != AF_SAMPFMT_TWOSCOMP) &&
		(sampleFormat != AF_SAMPFMT_UNSIGNED))
	{
afCloseFile(file);
return;
	}

	if (channelCount > 2)
	{
afCloseFile(file);
return;
	}

	buffer = malloc(4096 * frameSize);

   if(device!=NULL)
   {
   ao_close(device);
   ao_shutdown();
   device=NULL;
   }

format.bits = sampleWidth;
format.channels = channelCount;
format.rate =(int)sampleRate;



format.byte_format = AO_FMT_LITTLE;
	ao_initialize();
	default_driver = ao_default_driver_id();
	device = ao_open_live(default_driver, &format, NULL /* no options */);

	framesRead = afReadFrames(file, AF_DEFAULT_TRACK, buffer,
		4096);

	while (framesRead > 0)
	{
         while (gtk_events_pending ())
          gtk_main_iteration_do(FALSE);
          if(dowhat!=0)
          {
           if(dowhat==4 || dowhat==5 || dowhat==6)
           {
            if(dowhat==5)
            afSeekFrame(file,AF_DEFAULT_TRACK,afSeekFrame(file,AF_DEFAULT_TRACK,-1)-4096*6);
            else
            if(dowhat==4)
            afSeekFrame(file,AF_DEFAULT_TRACK,afSeekFrame(file,AF_DEFAULT_TRACK,-1)+4096*5);
            else
            if(dowhat==6)
            {
             x=g_p/100;
             x=(float)x*(float)afGetFrameCount(file,AF_DEFAULT_TRACK);
             afSeekFrame(file,AF_DEFAULT_TRACK,x);
             dowhat=0;
            }
	    framesRead = afReadFrames(file, AF_DEFAULT_TRACK, buffer,
		4096);
           }
           else
           break;
          }
          if(global_exit)break;
          ao_play(device,buffer,framesRead * frameSize);
          n=(float)afSeekFrame(file,AF_DEFAULT_TRACK,-1)/(float)afGetFrameCount(file,AF_DEFAULT_TRACK);
          x=n*100;
if(l!=(int)x)
{
if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,x);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}
}
l=(int)x;
        	framesRead = afReadFrames(file, AF_DEFAULT_TRACK, buffer,4096);
	}

afCloseFile(file);
	free(buffer);
   ao_close(device);
   ao_shutdown();
   device=NULL;
}

void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{

if(hw)return;

sprintf(help,"The Add,Del,Up and Dwn buttons allow you to \nperform those functions on the current playlist.");
strcat(help,"\nIf no Playlist or files are loaded or you have\npreviously clicked Clear List you can Add,Del, Up\nand Dwn files. Then click on list again to close the \ndrop down box and then click on Save Playlist,\nto be able to save the selections to a Playlist file.");
strcat(help,"\n\nIf files or a Playlist are already loaded via the\nLoad Playlist button or the Load File/Dir button you\ncan use the same functions to modify the existing list.\nClicking Save Playlist will let you save the modified \nlist to the same or a new name.\n\nThe Playlists can only be modified/created when\nfiles are not being played\nTo select a file or files to Del, Up or Dwn use the\nright mouse button.");
 hw=create_help_window();
 gtk_widget_show(hw);
}

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
char *dat[3];
GtkTargetEntry target_entry[1];
char *mtoken=NULL;
char *t=NULL;
char *db=NULL;

if(addfrom_list!=NULL)
return;

play_num=0;
dowhat=-1;
target_entry[0].target="text/plain";
target_entry[0].flags=GTK_TARGET_SAME_APP;
target_entry[0].info=0;


afile=1;
addfrom_list=create_awindow2(music_dir);
gtk_widget_show(addfrom_list);
gtk_main();


db=adata;
mtoken=NULL;


if(adata!=NULL)
{

while(1)
{
if(mtoken)
free(mtoken);
mtoken=NULL;
mtoken=nline(db,mtoken);
if(mtoken==NULL)break;
db=db+strlen(mtoken)+1;


if(strncasecmp(mtoken,"file:/",6)==0)
{
 if(isdir(mtoken+5))
 {
  t=(char *)malloc(strlen(mtoken));
  strcpy(t,mtoken+5);
  strcat(t,"/");
  single_dir(t,(GtkCList*)main_window_oggclist);
  free(t);
 }
 else
if(isflac(mtoken+5))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 get_flac_labels(mtoken+5,ogg_files);

/*
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);
*/
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
}
else
 if(ismp3(mtoken+5))
 {
  ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
  single_mp3(mtoken+5,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
   ogg_files++;
  }
  else
  if(iswav(mtoken+5))
  {
   ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
   single_wav(mtoken+5,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
   ogg_files++;
  }
  else
  if(isogg(mtoken+5))
  {
   ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
   single_ogg(mtoken+5,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
  }

 }

else
{
 if(isdir(mtoken))
 {
  t=(char *)malloc(strlen(mtoken)+1);
  strcpy(t,mtoken);
  single_dir(t,(GtkCList*)main_window_oggclist);
  free(t);
 }
  else
 if(isflac(mtoken))
 {

 ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
  get_flac_labels(mtoken,ogg_files);

    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
   ogg_files++;
 }
else
  if(ismp3(mtoken))
 {
  ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
  single_mp3(mtoken,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
   ogg_files++;
 }
 else
 if(iswav(mtoken))
 {
 ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 single_wav(mtoken,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
 ogg_files++;
 }
 else
 if(isogg(mtoken))
 {
  ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
  single_ogg(mtoken,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;

   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
}

}


}

if(ogg_files)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
free(adata);
adata=NULL;
}





gtk_widget_destroy(addfrom_list);
addfrom_list=NULL;
return;
}




void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
int num;
void *o;

if(snum<0)return;


for(num=snum;num<ogg_files-1;num++)
{
o=ogg_dir[num];
ogg_dir[num]=ogg_dir[num+1];
ogg_dir[num+1]=o;
gtk_clist_swap_rows((GtkCList *)main_window_oggclist,num+1,num);
}


 free(ogg_dir[num]->file_path);
ogg_dir[num]->file_path=NULL;
 free(ogg_dir[num]->fname);
ogg_dir[num]->fname=NULL;
 free(ogg_dir[num]->title);
ogg_dir[num]->title=NULL;
 free(ogg_dir[num]->artist);
ogg_dir[num]->artist=NULL;
 free(ogg_dir[num]);
ogg_dir[num]=NULL;


ogg_files--;

if(ogg_files!=0)
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files);
else
{
free(ogg_dir);
ogg_dir=NULL;
}
gtk_clist_remove((GtkCList *)main_window_oggclist,ogg_files);

snum--;

if(play_num>=ogg_files)
play_num=0;

if(ogg_files)
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);
else
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,"");
snum=-1;
}



void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
void *o;


if(snum<1){snum=-1;return;}


o=ogg_dir[snum-1];
ogg_dir[snum-1]=ogg_dir[snum];
ogg_dir[snum]=o;


gtk_clist_swap_rows((GtkCList *)main_window_oggclist,snum,snum-1);
snum--;

gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);


}









void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
void *o;

if(snum>ogg_files-2 || snum==-1)return;


o=ogg_dir[snum];
ogg_dir[snum]=ogg_dir[snum+1];
ogg_dir[snum+1]=o;

gtk_clist_swap_rows((GtkCList *)main_window_oggclist,snum+1,snum);
snum++;
gtk_entry_set_text((GtkEntry *)main_window_ogg_entry,ogg_dir[0]->title);

}





void single_mp3(char *t,int n)
{

struct id3_file *id3_f=NULL;
struct id3_tag *id3_t=NULL;
struct id3_frame *fr=NULL;
id3_latin1_t *b=NULL;


    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

   id3_f=id3_file_open(t,ID3_FILE_MODE_READONLY);
    if(id3_f!=NULL)
    {
     id3_t= id3_file_tag(id3_f);
      if(id3_t!=NULL)
      {
          fr=id3_tag_findframe(id3_t,"TIT2",0);
	  if(fr!=NULL)
	  {
	  if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	  {
	  b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	  ogg_dir[n]->title=(char *)malloc(strlen(b)+1);
          strcpy(ogg_dir[n]->title,b);
	  free(b);
	  }
	  else
	  {
           ogg_dir[n]->title=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
           strcpy(ogg_dir[n]->title,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }


          fr=id3_tag_findframe(id3_t,"TPE1",0);
          if(fr!=NULL)
	  {
	   if(fr->fields[1].type==4 || fr->fields[1].type==5 ||fr->fields[1].type==6 )
	   {
	   b=id3_ucs4_latin1duplicate(fr->fields[1].stringlist.strings[0]);
	   ogg_dir[n]->artist=(char *)malloc(strlen(b)+1);
           strcpy(ogg_dir[n]->artist,b);
	   free(b);
	   }
	   else
	   {
            ogg_dir[n]->artist=(char *)malloc(strlen((char *)fr->fields[1].stringlist.strings[0])+1);
            strcpy(ogg_dir[n]->artist,(char *)fr->fields[1].stringlist.strings[0]);
	   }
	  }

      }  /* id3_t !=NULL */
    } /* id3 !=NULL */

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}



}

void single_wav(char *t,int n)
{
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}




void single_ogg(char *t,int n)
{

FILE *fptr;

char *dat[3],*token;
OggVorbis_File vf;
int i=0;



   if((fptr=fopen(t,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->file_path,t);
    ogg_dir[n]->fname=(char*)malloc(strlen(t)+1);
    strcpy(ogg_dir[n]->fname,t);

    dat[0]=NULL;
    dat[1]=NULL;
    dat[2]=NULL;
       for(i=0;i<vf.vc->comments;i++)
        {
             if(strncasecmp("title=",vf.vc->user_comments[i],6)==0)
               {

                 token=strtok(vf.vc->user_comments[i],"=");
                token=strtok(NULL,"");
                ogg_dir[n]->title=(char *)malloc(strlen(token)+1);
               strcpy(ogg_dir[n]->title,token);
              dat[0]=ogg_dir[n]->title;
        }
        else
          if(strncasecmp("artist=",vf.vc->user_comments[i],6)==0)
       {

        token=strtok(vf.vc->user_comments[i],"=");
        token=strtok(NULL,"");
        ogg_dir[n]->artist=(char *)malloc(strlen(token)+1);
        strcpy(ogg_dir[n]->artist,token);
         dat[1]=ogg_dir[n]->artist;
        }

       }


 ov_clear(&vf);
 }
 else
 fclose(fptr);
  }

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->title=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->title,"Unknown");
}

if(ogg_dir[n]->title==NULL)
{
    ogg_dir[n]->artist=(char *)malloc(strlen("Unknown")+1);
    strcpy(ogg_dir[n]->artist,"Unknown");
}

}








void single_dir(char *md, GtkCList *l)
{
DIR *d=NULL;
char *t=NULL;
char *dat[3];
struct dirent *dent=NULL;


  d=opendir(md);
  if(d==NULL)return;

  while(1)
  {
     dent=readdir(d);
     if(dent==NULL)break;
     if(dent->d_name[0]!='.')
     {
      t=(char *)malloc(strlen(md)+1+strlen(dent->d_name)+2);
      strcpy(t,md);
      strcat(t,"/");
      strcat(t,dent->d_name);
if(isflac(t))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 get_flac_labels(t,ogg_files);
    dat[0]=ogg_dir[ogg_files]->title;
    dat[1]=ogg_dir[ogg_files]->artist;
    dat[2]=NULL;
   gtk_clist_append((GtkCList *)main_window_oggclist,dat);
ogg_files++;
}
else
      if(iswav(t))
      {
       ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
       single_wav(t,ogg_files);
       dat[0]=ogg_dir[ogg_files]->title;
       dat[1]=ogg_dir[ogg_files]->artist;
       dat[2]=NULL;
       gtk_clist_append((GtkCList *)l,dat);
       ogg_files++;
      }
      else
      if(ismp3(t))
      {
       ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
       single_mp3(t,ogg_files);
       dat[0]=ogg_dir[ogg_files]->title;
       dat[1]=ogg_dir[ogg_files]->artist;
       dat[2]=NULL;
       gtk_clist_append((GtkCList *)l,dat);
       ogg_files++;
      }
      else
      if(isogg(t))
      {
       ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
       single_ogg(t,ogg_files);
       dat[0]=ogg_dir[ogg_files]->title;
       dat[1]=ogg_dir[ogg_files]->artist;
       dat[2]=NULL;
       gtk_clist_append((GtkCList *)l,dat);
       ogg_files++;
      }
       free(t);
     }
  }
 closedir(d);

}


int isdir(char *md)
{
DIR *d=NULL;

  d=opendir(md);
  if(d==NULL)return 0;
  closedir(d);
 return 1;
}





char * nline(char *str,char *ptr)
{
int num;
int f=0;

if(strlen(str)==0||strlen(str)==1)return NULL;

for(num=0;num<strlen(str);num++)
{
if(str[num]==0 || str[num]=='\n'){f=1;break;}
}

if(!f)return NULL;

ptr=(char *)malloc(num+1);
strncpy(ptr,str,num);
ptr[num]='\0';
return ptr;
}


void on_rew_clicked(GtkButton       *button, gpointer         user_data)
{
if(dowhat==0)
dowhat=5;
else
dowhat=0;
}


void on_ffw_clicked(GtkButton       *button, gpointer         user_data)
{
if(dowhat==0)
dowhat=4;
else
dowhat=0;
}

void p_change( GtkAdjustment *get, gpointer         user_data )
{
g_p=get->value;
if(!prelease)
{
g_p=get->value;
dowhat=6;
}
}


/* This function is based upon the work of Bertrand Petit in the program
madlld.c A simple program decoding an mpeg audio stream to 16-bit
PCM from stdin to stdout. (c) 2001, 2002 Bertrand Petit
*/

#define INPUT_BUFFER_SIZE	(2*8192)
#define OUTPUT_BUFFER_SIZE	8192
int MpegAudioDecoder(char *fn)
{
struct mad_stream Stream;
struct mad_frame Frame;
struct mad_synth Synth;
mad_timer_t Timer;
unsigned char InputBuffer[INPUT_BUFFER_SIZE],OutputBuffer[OUTPUT_BUFFER_SIZE],
*OutputPtr=OutputBuffer;

const unsigned char *OutputBufferEnd=OutputBuffer+OUTPUT_BUFFER_SIZE;
int Status=0,i;
unsigned long FrameCount=0;
size_t ReadSize,Remaining;
unsigned char *ReadStart;
unsigned short	Sample;
int first_time=0;
FILE *fptr;
long length;
float x;


if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,0);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}

if((fptr=fopen(fn,"rb"))==NULL)return 0;

fseek(fptr,0,SEEK_END);
length=ftell(fptr);
fseek(fptr,0,SEEK_SET);

 mad_stream_init(&Stream);
 mad_frame_init(&Frame);
 mad_synth_init(&Synth);
 mad_timer_reset(&Timer);




 do
 {


	if(Stream.buffer==NULL || Stream.error==MAD_ERROR_BUFLEN)
	{

	if(Stream.next_frame!=NULL)
	{
    	Remaining=Stream.bufend-Stream.next_frame;
	memmove(InputBuffer,Stream.next_frame,Remaining);
	ReadStart=InputBuffer+Remaining;
	ReadSize=INPUT_BUFFER_SIZE-Remaining;
	}
	else
	ReadSize=INPUT_BUFFER_SIZE,ReadStart=InputBuffer,Remaining=0;

	ReadSize=fread(ReadStart,1,ReadSize,fptr);
	if(ReadSize<=0)
	{
	break;
	}


	mad_stream_buffer(&Stream,InputBuffer,ReadSize+Remaining);
	Stream.error=0;
	}


	if(mad_frame_decode(&Frame,&Stream))
        {

	if(MAD_RECOVERABLE(Stream.error))
	{
	continue;
	}
	else
        {
	if(Stream.error==MAD_ERROR_BUFLEN)
	continue;
	else
	{
	Status=1;
	break;
	}
	}
	}



	FrameCount++;
	mad_timer_add(&Timer,Frame.header.duration);


	mad_synth_frame(&Synth,&Frame);


if(!first_time)
{
   ao_initialize();
   default_driver = ao_default_driver_id();
   format.bits =16;
   format.channels = Synth.pcm.channels;
   format.rate = Synth.pcm.samplerate;
   format.byte_format = AO_FMT_LITTLE;
   device = ao_open_live(default_driver, &format, NULL );
   first_time=1;
}
	for(i=0;i<Synth.pcm.length;i++)
	{

       	Sample=scale(Synth.pcm.samples[0][i]);
	*(OutputPtr++)=(Sample>>0) & 0xff;
	*(OutputPtr++)=(Sample>>8) &0xff;

	if(MAD_NCHANNELS(&Frame.header)==2)
	Sample=scale(Synth.pcm.samples[1][i]);
	*(OutputPtr++)=(Sample>>0)&0xff;
	*(OutputPtr++)=(Sample>>8) &0xff;

	if(OutputPtr==OutputBufferEnd)
	{
          ao_play(device,OutputBuffer,OUTPUT_BUFFER_SIZE);
	  OutputPtr=OutputBuffer;
	}
	}

(long)x=ftell(fptr);
x=x/length;
x=x*100;

if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,(long)x);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}

         while (gtk_events_pending ())
          gtk_main_iteration_do(FALSE);

	while(pauseres)
	{
  	 while (gtk_events_pending())
          gtk_main_iteration();
          if(dowhat||global_exit)break;
	}

if(dowhat!=0)
{
 if(dowhat==6)  /*foward */
 {
  x=g_p/100;
  x=(float)x*length;
  fseek(fptr,(long)x,SEEK_SET);
  dowhat=0;
 }
 else
 if(dowhat==5)
 {
 x=ftell(fptr);
 x=x-(8192*8);
 if(x<0)
 x=0;
 fseek(fptr,(long)x,SEEK_SET);
 }
 else
 if(dowhat==4)
 {
 x=ftell(fptr);
 x=x+(8192*8);
 if(x>length)
 x=length-8192;
 fseek(fptr,(long)x,SEEK_SET);
 }
 else
 break;
}
if(global_exit)break;

	}while(1);


	mad_synth_finish(&Synth);
	mad_frame_finish(&Frame);
	mad_stream_finish(&Stream);


	if(OutputPtr!=OutputBuffer && Status!=2)
	{
	size_t	BufferSize=OutputPtr-OutputBuffer;
	ao_play(device,OutputBuffer,BufferSize);
	}

fclose(fptr);
	return(Status);
}




int load_m3u(char *sfile)
{
FILE *fptr;
char *token,lbuff[1000];
int len;
char name[1000];


if((fptr=fopen(sfile,"rb"))==NULL)return 0;
if((fgets(lbuff,900,fptr))==NULL){fclose(fptr);return 0;}
lbuff[strlen(lbuff)-1]=0;
if(strcmp(lbuff,"Sonic-Rainbow Playlist")==0){fclose(fptr);return 0;}
rewind(fptr);

while(1)
{
if((fgets(lbuff,900,fptr))==NULL)break;
lbuff[strlen(lbuff)-1]=0;
if(strcmp(lbuff,"#EXTM3U")==0)continue;
if(strncmp(lbuff,"#EXTINF:",8)==0)
 {
token=strtok(lbuff,":");
token=strtok(NULL,",");
if(token!=NULL)
 {
  len=atoi(token);
  token=strtok(NULL,"\0");
  if(token!=NULL)
  {
   strcpy(name,token);
  }
  else
  name[0]=0;
 }
if((fgets(lbuff,900,fptr))==NULL)break;
lbuff[strlen(lbuff)-1]=0;
if(isflac(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 get_flac_labels(lbuff,ogg_files);
if(strcmp(ogg_dir[ogg_files]->title,"Unknown")==0)
{
if(strlen(name)!=0)
{
free(ogg_dir[ogg_files]->title);
ogg_dir[ogg_files]->title=(char *)malloc(strlen(name)+1);
strcpy(ogg_dir[ogg_files]->title,name);
}
}
ogg_files++;
}
else
if(iswav(lbuff))
{
 ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 single_wav(lbuff,ogg_files);
if(strcmp(ogg_dir[ogg_files]->title,"Unknown")==0)
{
if(strlen(name)!=0)
{
free(ogg_dir[ogg_files]->title);
ogg_dir[ogg_files]->title=(char *)malloc(strlen(name)+1);
strcpy(ogg_dir[ogg_files]->title,name);
}
}
  ogg_files++;
}
else
if(ismp3(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_mp3(lbuff,ogg_files);
if(strcmp(ogg_dir[ogg_files]->title,"Unknown")==0)
{
if(strlen(name)!=0)
{
free(ogg_dir[ogg_files]->title);
ogg_dir[ogg_files]->title=(char *)malloc(strlen(name)+1);
strcpy(ogg_dir[ogg_files]->title,name);
}
}
ogg_files++;
}
else
if(isogg(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_ogg(lbuff,ogg_files);
if(strcmp(ogg_dir[ogg_files]->title,"Unknown")==0)
{
if(strlen(name)!=0)
{
free(ogg_dir[ogg_files]->title);
ogg_dir[ogg_files]->title=(char *)malloc(strlen(name)+1);
strcpy(ogg_dir[ogg_files]->title,name);
}
}
ogg_files++;
}
else
continue;
}

else  /* is just a file */
{
if(isflac(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_mp3(lbuff,ogg_files);
ogg_files++;
}
else
if(iswav(lbuff))
{
 ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
 single_wav(lbuff,ogg_files);
 ogg_files++;
}
else
if(ismp3(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_mp3(lbuff,ogg_files);
ogg_files++;
}
else
if(isogg(lbuff))
{
ogg_dir=(struct oggdir **)realloc(ogg_dir,sizeof(struct oggdir *) * ogg_files+1);
single_ogg(lbuff,ogg_files);
ogg_files++;
}
}

}

fclose(fptr);
return 1;
}


long wav_length(char *f)
{
AFfilehandle	file;
long len;

file = afOpenFile(f, "r", NULL);
len=afGetFrameCount(file, AF_DEFAULT_TRACK) /afGetRate(file, AF_DEFAULT_TRACK);
afCloseFile(file);
return len;
}

long ogg_length(char *f)
{
FILE *fptr;
OggVorbis_File vf;
float b;

   if((fptr=fopen(f,"rb"))!=NULL)
   {
   if(ov_open(fptr, &vf, NULL, 0)>=0)
   {
    ov_pcm_seek(&vf,ov_pcm_total(&vf,-1));
    b=ov_time_tell(&vf);
    ov_clear(&vf);
   return (long)b;

   }
   fclose(fptr);

  }
  return 0;
}


void p_release(GtkWidget *widget,GdkEventButton  *event,gpointer user_data)
{
prelease=0;
gtk_adjustment_set_value ((GtkAdjustment*)padj,g_p);
dowhat=6;
}

void p_press(GtkWidget *widget,GdkEventButton  *event,gpointer user_data)
{
prelease=1;
}



int isflac(char *fn)
{
char buf[5];
FILE *fptr;
if((fptr=fopen(fn,"rb"))==NULL)return 0;
fread(buf,sizeof(char),4,fptr);
fclose(fptr);
buf[4]=0;
if((strcmp("fLaC",buf))==0)
return 1;
else
return 0;
}



int get_flac_labels(char *fn, int n)
{
FLAC__bool found_vc_block = false;
FLAC__StreamMetadata *block = 0;
FLAC__Metadata_Iterator *iterator = FLAC__metadata_iterator_new();
FLAC__Metadata_Chain *chain = FLAC__metadata_chain_new();
int i;

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(fn)+1);
    strcpy(ogg_dir[n]->file_path,fn);
    ogg_dir[n]->fname=(char*)malloc(strlen(fn)+1);
    strcpy(ogg_dir[n]->fname,fn);


if(0 == chain)
{
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->title,"Unknown");
ogg_dir[n]->artist=(char *)malloc(8);
strcpy(ogg_dir[n]->artist,"Unknown");
return 0;
}

if(!FLAC__metadata_chain_read(chain, fn))
 {
FLAC__metadata_chain_delete(chain);
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->title,"Unknown");
ogg_dir[n]->artist=(char *)malloc(8);
strcpy(ogg_dir[n]->artist,"Unknown");
return false;
}

if(0 == iterator)
{
FLAC__metadata_chain_delete(chain);
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->title,"Unknown");
ogg_dir[n]->artist=(char *)malloc(8);
strcpy(ogg_dir[n]->artist,"Unknown");
return 0;
}

FLAC__metadata_iterator_init(iterator, chain);
do {
block = FLAC__metadata_iterator_get_block(iterator);
if(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT)
found_vc_block = true;
} while(!found_vc_block && FLAC__metadata_iterator_next(iterator));

if(!found_vc_block)
{
FLAC__metadata_iterator_delete(iterator);
FLAC__metadata_chain_delete(chain);
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->title,"Unknown");
ogg_dir[n]->artist=(char *)malloc(8);
strcpy(ogg_dir[n]->artist,"Unknown");
return 0;
}

    ogg_dir[n]=calloc(1,sizeof(struct oggdir));
    ogg_dir[n]->file_path=NULL;
    ogg_dir[n]->fname=NULL;
    ogg_dir[n]->title=NULL;
    ogg_dir[n]->artist=NULL;

    ogg_dir[n]->file_path=(char*)malloc(strlen(fn)+1);
    strcpy(ogg_dir[n]->file_path,fn);
    ogg_dir[n]->fname=(char*)malloc(strlen(fn)+1);
    strcpy(ogg_dir[n]->fname,fn);

i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"TITLE");

if((strcmp((block->data.vorbis_comment.comments+i)->entry,"TITLE="))==0)
{
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->title,"Unknown");
}
else
{
ogg_dir[n]->title=(char *)malloc((block->data.vorbis_comment.comments+i)->length+1-6);   strncpy(ogg_dir[n]->title,(block->data.vorbis_comment.comments+i)->entry+6,(block->data.vorbis_comment.comments+i)->length+1-6);
ogg_dir[n]->title[(block->data.vorbis_comment.comments+i)->length-6]=0;
}

i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"ARTIST");
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"ARTIST="))==0)
{
ogg_dir[n]->title=(char *)malloc(8);
strcpy(ogg_dir[n]->artist,"Unknown");
}
else
{
ogg_dir[n]->artist=(char *)malloc((block->data.vorbis_comment.comments+i)->length+1-7);
strncpy(ogg_dir[n]->artist,(block->data.vorbis_comment.comments+i)->entry+7,(block->data.vorbis_comment.comments+i)->length+1-7);
ogg_dir[n]->artist[(block->data.vorbis_comment.comments+i)->length-7]=0;
}

FLAC__metadata_iterator_delete(iterator);
FLAC__metadata_chain_delete(chain);

return 1;
}




int play_flac(char *fn)
{
FLAC__StreamDecoder *dec;
long length;
float x;

if((flac_ptr=fopen(fn,"rb"))==NULL)return(0);
fseek(flac_ptr,0,SEEK_END);
length=ftell(flac_ptr);
rewind(flac_ptr);

if(device!=NULL)
{
ao_close(device);
ao_shutdown();
device=NULL;
}

format.bits = 16;
format.channels = 2;
format.rate =44100;



format.byte_format = AO_FMT_LITTLE;
ao_initialize();
default_driver = ao_default_driver_id();
device = ao_open_live(default_driver, &format, NULL /* no options */);

dec=FLAC__stream_decoder_new();
//dec=FLAC__seekable_stream_decoder_new();
FLAC__stream_decoder_set_read_callback(dec,read_cb);
FLAC__stream_decoder_set_write_callback(dec,write_cb);
FLAC__stream_decoder_set_metadata_callback(dec,meta_cb);
FLAC__stream_decoder_set_error_callback(dec,error_cb);



FLAC__stream_decoder_init(dec);

while(1)
{
if(!FLAC__stream_decoder_process_single(dec))break;
(long)x=ftell(flac_ptr);
if(x>=length)break;
x=x/length;
x=x*100;
if(!prelease)
{
gtk_signal_handler_block_by_func((GtkObject*)padj,p_change,NULL);
gtk_adjustment_set_value((GtkAdjustment*)padj,(long)x);
gtk_signal_handler_unblock_by_func((GtkObject*)padj,p_change,NULL);
}
while (gtk_events_pending ())
gtk_main_iteration_do(FALSE);


while(pauseres)
{
  while (gtk_events_pending())
          gtk_main_iteration();
	  if(dowhat!=0|| global_exit)
break;
}






if(global_exit)break;

if(dowhat!=0)
{
 if(dowhat==6)  /*slider */
 {
/*
  x=g_p/100;
  x=(float)x*length;
  fseek(flac_ptr,(long)x,SEEK_SET);
  dowhat=0;
*/
;
 }
 else
 if(dowhat==5) /* rewind */
 {
/*
 x=ftell(flac_ptr);
 x=x-(8192*8);
 if(x<0)
 x=0;
 fseek(flac_ptr,(long)x,SEEK_SET);
*/
;
 }
 else
 if(dowhat==4) /* foward button */
 {
/*
 x=ftell(flac_ptr);
 x=x+(8192*8);
 if(x>length)
 x=length-8192;
 fseek(flac_ptr,(long)x,SEEK_SET);
*/
 }
else
break;
}

}

FLAC__stream_decoder_finish(dec);
fclose(flac_ptr);
ao_close(device);
ao_shutdown();
device=NULL;
return 0;
}


static void meta_cb(const FLAC__StreamDecoder *decoder, const FLAC__StreamMetadata *metadata, void * client_data)
{
;
}

static void error_cb(const FLAC__StreamDecoder *decoder, FLAC__StreamDecoderErrorStatus status, void *client_data)
{
;
}

static FLAC__StreamDecoderReadStatus read_cb(const FLAC__StreamDecoder *decoder, FLAC__byte buffer[], unsigned *bytes, void *client_data)
{
int b;
b=*bytes=fread(buffer,sizeof(char),*bytes,flac_ptr);
if(b<=0){dowhat=7;return FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM;}
return FLAC__STREAM_DECODER_READ_STATUS_CONTINUE;
}

static FLAC__StreamDecoderWriteStatus write_cb(const FLAC__StreamDecoder *decoder, const FLAC__Frame *frame, const FLAC__int32 * const buffer[], void * client_data)
{
int num,count;
int mybuff[400];


count=0;
for(num=0;num<frame->header.blocksize;num++)
{
mybuff[0]=buffer[0][num];
mybuff[1]=buffer[1][num];
ao_play(device,(char*)mybuff,4);
while (gtk_events_pending ())
gtk_main_iteration_do(FALSE);


while(pauseres)
{
  while (gtk_events_pending())
          gtk_main_iteration();
	  if(dowhat!=0|| global_exit)
break;
}


if(global_exit)
return FLAC__STREAM_DECODER_WRITE_STATUS_ABORT;

if(dowhat)
{
if(dowhat==4);
else
if(dowhat==5);
else
if(dowhat==6);
else
break;
}
}

if(dowhat)
{
if(dowhat==4);
else
if(dowhat==5);
else
if(dowhat==6);
else
return FLAC__STREAM_DECODER_WRITE_STATUS_ABORT;
}

if(global_exit)
return FLAC__STREAM_DECODER_WRITE_STATUS_ABORT;

return FLAC__STREAM_DECODER_WRITE_STATUS_CONTINUE;
}


void on_nb_clicked(GtkButton       *button, gpointer         user_data)
{
if(lp)return;
if(playlist_dir)
lp=single_file_window (playlist_dir);
else
lp=single_file_window (default_playlist_dir);
gtk_widget_show(lp);
gtk_main();
if(fdata!=NULL)
{

if(playlist_dir)
free(playlist_dir);

playlist_dir=(char*)malloc(strlen(fdata)+2);
strcpy(playlist_dir,fdata);

playlist_dir[strlen(fdata)+1-strlen(strrchr(fdata,47))]=0;
gtk_entry_set_text((GtkEntry*)fentry,strrchr(fdata,47)+1);
gtk_entry_set_text((GtkEntry *)playlist_direntry,playlist_dir);
free(fdata);
fdata=NULL;
}
gtk_widget_destroy(lp);
lp=NULL;
}
