/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <string.h>
#include <malloc.h>
#include <unistd.h>
#include <linux/soundcard.h>
#include <ao/ao.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <mad.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/mman.h>

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <sys/types.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <linux/videodev.h>
#include <math.h>
#include <signal.h>

extern int display_radio,fm_autoplay;
extern char default_radio[1000];
extern char default_mixer[1000];
extern GtkWidget *sta,*main_fixed,*mwin;
extern GtkObject *sadj;
extern GtkTooltips *tooltips;
extern float frequencys[11];
extern char  blabels[11][7];
extern char *ddata;
extern char *fdata;
extern char default_radio_directory[1000];
extern GtkWidget *bt1,*bt2,*bt3,*bt4,*bt5,*bt6,*bt7,*bt8,*bt9,*bt10,*radprog,*radplay,*radstop;
extern GtkWidget *vt1,*vt2,*vt3,*vt4,*rlab,*flabel,*freq_spin;
extern GtkWidget *radsave_window,*save_list,*save_spin,*save_entry;

extern GtkObject *freq_spin_adj;
int radio_dev=-1;
int rowsel=-1;
int tradio=0;
int f_stop_rec=0;
GtkWidget *timed_record_button,*fspin;

void main_f( GtkAdjustment *get, gpointer         user_data );
GtkWidget* create_single_dir_window (char *sd);
GtkWidget *start_record;
GtkWidget *stop_record;
GtkWidget *rad_stop;
GtkWidget *rf_combo_entry,*radio_speed_combo,*c_combo_entry,*chan_combo;
GtkWidget *record_hours;
GtkWidget *record_minutes;
GtkWidget *record_ogg_button;
GtkWidget *record_wav_button;
GtkWidget *record_mp3_button;

void radio_timer();
void radio_buttons();
void do_save_config();
void reset_radio_button(int but);
void do_error_message(char *text);
void
on_stop_record_clicked                (GtkButton       *button,
                                       gpointer         user_data);

void
on_radio_speed_combo_realize          (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_timed_record_button_toggled         (GtkWidget       *widget,
                                        gpointer         user_data);



int record_radio();
#define TRIES 1 /* get 25 samples                 */
#define LOCKTIME 100000 /* wait 400ms for card to lock on */
#define SAMPLEDELAY 0		/* wait 15ms between samples      */
#define THRESHOLD .5    /* minimum acceptable signal %    */
struct video_audio va;
struct video_tuner vt;
float fact;

struct dev
{
char label[100];
int chan;
char anum[100];
int rec;
int value;
}devs[25];


GtkWidget *rde,*fde=NULL;

void record_it();

int devtot=1;

void
on_station_1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[0] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[0]);
}



void
on_station_2_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;

freq=ceil(frequencys[1] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[1]);
}


void
on_station_3_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[2] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[2]);
}


void
on_station_4_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[3] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[3]);
}


void
on_station_5_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[4] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[4]);
}


void
on_station_6_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[5] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[5]);
}


void
on_station_7_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[6] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[6]);
}


void
on_station_8_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[7] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[7]);
}


void
on_statio_9_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[8] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[8]);
}


void
on_station_10_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
unsigned long freq;


freq=ceil(frequencys[9] * fact);
ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,frequencys[9]);
}


void
on_play_radio_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
int ret;
unsigned long freq;
char *ebuff;
if(radio_dev==-2)return;

if(radio_dev==-1)
{
radio_dev=open(default_radio,O_RDWR);
if(radio_dev==-1)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file. Your radio device has\nbeen configured as %s\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
radio_dev=-2;
return;
}



ret = ioctl(radio_dev, VIDIOCGAUDIO, &va);

vt.tuner=0;
ret = ioctl(radio_dev, VIDIOCSTUNER, &vt);	/* set tuner # */

ret = ioctl(radio_dev, VIDIOCGTUNER, &vt);	/* get frequency range */

if ((ret == -1) || ((vt.flags & VIDEO_TUNER_LOW) == 0))
fact = 16;
else
fact = 16000;

if(freq_spin!=NULL)
freq = ceil(gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin) * fact);
else
freq=ceil(frequencys[10] *fact);

ret = ioctl(radio_dev, VIDIOCSFREQ, &freq);

va.audio = 0;
va.volume = 0;
/*va.flags = VIDEO_AUDIO_MUTE;*/
va.mode = VIDEO_SOUND_STEREO;
ret = ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}




void
on_stop_radio_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
va.audio = 0;
va.volume = 0;
va.flags = VIDEO_AUDIO_MUTE;
ioctl(radio_dev, VIDIOCSAUDIO, &va);

close(radio_dev);
radio_dev=-1;
}


void
on_radio_program_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
radsave_window=create_radio_save_window();
gtk_widget_show(radsave_window);
gtk_main();
}



void
on_play_radio_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}


void
on_stop_radio_realize                  (GtkWidget       *widget,
                                        gpointer         user_data)
{
radstop=widget;
}


void
on_radio_program_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
radprog=widget;

}

void
on_vseparator6_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt1=widget;
}


void
on_hseparator6_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt2=widget;
}


void
on_vseparator5_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt3=widget;
}


void
on_hseparator5_realize                 (GtkWidget       *widget,
                                        gpointer         user_data)
{
vt4=widget;
}


void
on_label26_realize                     (GtkWidget       *widget,
                                        gpointer         user_data)
{
rlab=widget;
}

void
on_freq_spin_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{
float fl=0;
char buf[1000];
unsigned long freq;
static int b=0;
char *ebuff;

if(radio_dev==-2)
{
if(b==1)return;
b=1;
gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file to alter the frequency.\nYour radio device has been configured as\n%s.\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow.\nThis message will only be displayed once",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
b=1;
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
return;

}


fl=gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin);
sprintf(buf,"%-2.1f",fl);

gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);

gtk_adjustment_set_value((GtkAdjustment *)sadj,atof(buf)*10);

gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}


void
on_freq_spin_realize                   (GtkWidget       *widget,
                                        gpointer         user_data)
{
freq_spin=widget;
}


void
on_station_lable_realize               (GtkWidget       *widget,
                                        gpointer         user_data)
{
flabel=widget;
}

void main_f( GtkAdjustment *get, gpointer         user_data )
{
float b=0;
char buf[1000];
unsigned long freq;
static int ba=0;
char *ebuff;


if(radio_dev==-2)
{
if(ba==1)return;
ba=1;
gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Errors accesing the Radio Device\nSonic-Rainbow needs to be able to read and write\nto the Radio device file to alter the frequency.\nYour radio device has been configured as\n%s.\nThis is most likely a file permissions based\nproblem that can be resolved by changing the\npermissions on %s\nor changing the runtime permissions of\nSonic-Rainbow.\nThis message will only be displayed once",default_radio,default_radio);
   do_error_message(ebuff);
   free(ebuff);
ba=1;
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
return;

}


gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
b=(float)get->value/10;
sprintf(buf,"%-2.1f",b);
gtk_tooltips_set_tip((GtkTooltips*)tooltips,sta,buf,NULL);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,atof(buf));
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);
if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}
}



void radio_buttons()
{
;
}





void
on_fixed3_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_save_radio_spin_changed             (GtkEditable     *editable,
                                        gpointer         user_data)
{
float fl=0;
char buf[1000];
unsigned long freq;

fl=gtk_spin_button_get_value_as_float((GtkSpinButton*)save_spin);
sprintf(buf,"%-2.1f",fl);

gtk_signal_handler_block_by_func((GtkObject *)sadj,main_f,NULL);
gtk_adjustment_set_value((GtkAdjustment *)sadj,atof(buf)*10);
gtk_signal_handler_unblock_by_func((GtkObject *)sadj,main_f,NULL);



gtk_signal_handler_block_by_func((GtkObject *)freq_spin,on_freq_spin_changed,NULL);
gtk_tooltips_set_tip((GtkTooltips*)tooltips,sta,buf,NULL);
gtk_spin_button_set_value ((GtkSpinButton*)freq_spin,atof(buf));
gtk_signal_handler_unblock_by_func((GtkObject*)freq_spin,on_freq_spin_changed,NULL);


if(radio_dev!=-1)
{
freq= ceil(atof(buf) * fact);

ioctl(radio_dev, VIDIOCSFREQ, &freq);
va.audio = 0;
va.volume = 0;/*tunevol;*/
va.flags = 0;
va.mode = VIDEO_SOUND_STEREO;
ioctl(radio_dev, VIDIOCSAUDIO, &va);
}

}


void
on_save_radio_spin_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
save_spin=widget;
gtk_spin_button_set_value ((GtkSpinButton*)widget,gtk_spin_button_get_value_as_float((GtkSpinButton*)freq_spin));
}


void
on_radio_save_exit_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_destroy(radsave_window);
gtk_main_quit();
}


void
on_radio_save_save_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
char b[1000];


if(rowsel>-1)
{
strcpy(b,gtk_entry_get_text((GtkEntry *)save_entry));
if(b[0]==0)
{
sprintf(b,"%d",rowsel+1);
}

gtk_clist_set_text((GtkCList *)save_list,rowsel,0,b);
strcpy(blabels[rowsel],b);

sprintf(b,"%-2.1f",gtk_spin_button_get_value_as_float((GtkSpinButton*)save_spin));
gtk_clist_set_text((GtkCList *)save_list,rowsel,1,b);
frequencys[rowsel]=atof(b);
do_save_config();
reset_radio_button(rowsel+1);
}

}




void
on_radio_save_window_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
save_list=widget;
}



void
on_radio_save_list_select_row          (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry *)save_entry,blabels[row]);
rowsel=row;

}


void
on_radio_save_list_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{
int n;
char *dat[3];
char r[1000];
rowsel=-1;
save_list=widget;

for(n=0;n<10;n++)
{
dat[0]=blabels[n];
sprintf(r,"%-2.1f",frequencys[n]);
dat[1]=r;
dat[2]=NULL;
gtk_clist_append((GtkCList *)save_list,dat);
}

}


void
on_radio_save_list_unselect_row        (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry *)save_entry,"");
rowsel=-1;
}








GtkWidget*
create_rec_window (void)
{
  GtkWidget *rec_window;
  GtkWidget *fixed5;

  GtkObject *record_hours_adj;
  GtkObject *record_minutes_adj;
  GtkWidget *record_directory_entry;
  GtkWidget *record_file_entry;
  GtkWidget *record_directory_browse;
  GtkWidget *record_file_browse;
  GtkWidget *record_exit;
  GtkWidget *label35;
  GtkWidget *label36;
  GtkWidget *rf_label;
  GSList *radio_record_group = NULL;
  GtkWidget *label37,*c_label,*q_label;
  GtkObject *f_spin_adj;
  int f,num,level,re;
  const char *labels[] = SOUND_DEVICE_LABELS ;
  char *rec_src=NULL;


int recsrc;
GList *rf_combo_items = NULL;


f=open(default_mixer,O_RDWR);
ioctl(f, MIXER_READ(SOUND_MIXER_READ_DEVMASK), &level);
ioctl(f, MIXER_READ(SOUND_MIXER_READ_RECMASK), &re);
ioctl(f, MIXER_READ(SOUND_MIXER_READ_RECSRC), &recsrc);
close(f);


  rec_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (rec_window), "rec_window", rec_window);
  gtk_window_set_title (GTK_WINDOW (rec_window), "Sonic-Rainbow Radio Record");

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (rec_window), fixed5);
  gtk_widget_set_usize (fixed5, 339, 285);

  start_record = gtk_button_new_with_label ("Start");
  gtk_widget_ref (start_record);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "start_record", start_record,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (start_record);
  gtk_fixed_put (GTK_FIXED (fixed5), start_record, 96, 255);
  gtk_widget_set_uposition (start_record, 96, 255);
  gtk_widget_set_usize (start_record, 47, 22);

  stop_record = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (stop_record);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "stop_record", stop_record,
                            (GtkDestroyNotify) gtk_widget_unref);
/*  gtk_widget_show (stop_record);*/
  gtk_fixed_put (GTK_FIXED (fixed5), stop_record, 96, 255);
  gtk_widget_set_uposition (stop_record, 96, 255);
  gtk_widget_set_usize (stop_record, 47, 22);

  record_hours_adj = gtk_adjustment_new (0, 0, 100, 1, 10, 10);
  record_hours = gtk_spin_button_new (GTK_ADJUSTMENT (record_hours_adj), 1, 0);
  gtk_widget_ref (record_hours);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_hours", record_hours,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_hours);
  gtk_widget_set_sensitive (record_hours, FALSE);

  gtk_fixed_put (GTK_FIXED (fixed5), record_hours, 124, 156);
  gtk_widget_set_uposition (record_hours, 124, 156);
  gtk_widget_set_usize (record_hours, 49, 22);

  record_minutes_adj = gtk_adjustment_new (0, 0, 100, 1, 10, 10);
  record_minutes = gtk_spin_button_new (GTK_ADJUSTMENT (record_minutes_adj), 1, 0);
  gtk_widget_ref (record_minutes);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_minutes", record_minutes,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_minutes);
  gtk_widget_set_sensitive (record_minutes, FALSE);
  gtk_fixed_put (GTK_FIXED (fixed5), record_minutes, 172, 156);
  gtk_widget_set_uposition (record_minutes, 172, 156);
  gtk_widget_set_usize (record_minutes, 49, 22);

  record_directory_entry = gtk_entry_new ();
  gtk_widget_ref (record_directory_entry);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_directory_entry", record_directory_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_directory_entry);
  gtk_fixed_put (GTK_FIXED (fixed5), record_directory_entry, 16, 48);
  gtk_widget_set_uposition (record_directory_entry, 16, 48);
  gtk_widget_set_usize (record_directory_entry, 256, 24);

  record_file_entry = gtk_entry_new ();
  gtk_widget_ref (record_file_entry);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_file_entry", record_file_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_file_entry);
  gtk_fixed_put (GTK_FIXED (fixed5), record_file_entry, 16, 96);
  gtk_widget_set_uposition (record_file_entry, 16, 96);
  gtk_widget_set_usize (record_file_entry, 168, 24);

  record_directory_browse = gtk_button_new_with_label ("Browse");
  gtk_widget_ref (record_directory_browse);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_directory_browse", record_directory_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_directory_browse);
  gtk_fixed_put (GTK_FIXED (fixed5), record_directory_browse, 272, 48);
  gtk_widget_set_uposition (record_directory_browse, 272, 48);
  gtk_widget_set_usize (record_directory_browse, 47, 22);

  record_file_browse = gtk_button_new_with_label ("Browse");
  gtk_widget_ref (record_file_browse);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_file_browse", record_file_browse,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_file_browse);
  gtk_fixed_put (GTK_FIXED (fixed5), record_file_browse, 184, 96);
  gtk_widget_set_uposition (record_file_browse, 184, 96);
  gtk_widget_set_usize (record_file_browse, 47, 22);

  record_exit = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (record_exit);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_exit", record_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_exit);
  gtk_fixed_put (GTK_FIXED (fixed5), record_exit, 168, 255);
  gtk_widget_set_uposition (record_exit, 168, 255);
  gtk_widget_set_usize (record_exit, 47, 22);

  label35 = gtk_label_new ("Record Directory");
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label35);
  gtk_fixed_put (GTK_FIXED (fixed5), label35, 8, 32);
  gtk_widget_set_uposition (label35, 8, 32);
  gtk_widget_set_usize (label35, 112, 16);

  label36 = gtk_label_new ("Record Filename");
  gtk_widget_ref (label36);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "label36", label36,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label36);
  gtk_fixed_put (GTK_FIXED (fixed5), label36, 8, 80);
  gtk_widget_set_uposition (label36, 8, 80);
  gtk_widget_set_usize (label36, 112, 16);

  record_ogg_button = gtk_radio_button_new_with_label (radio_record_group, "Ogg Format");
  radio_record_group = gtk_radio_button_group (GTK_RADIO_BUTTON (record_ogg_button));
  gtk_widget_ref (record_ogg_button);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_ogg_button", record_ogg_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_ogg_button);
  gtk_fixed_put (GTK_FIXED (fixed5), record_ogg_button, 16, 128);

  gtk_widget_set_uposition (record_ogg_button, 16, 128);
  gtk_widget_set_usize (record_ogg_button, 96, 24);

  record_wav_button = gtk_radio_button_new_with_label (radio_record_group, "Wav Format");
  radio_record_group = gtk_radio_button_group (GTK_RADIO_BUTTON (record_wav_button));
  gtk_widget_ref (record_wav_button);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "record_wav_button", record_wav_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (record_wav_button);
  gtk_fixed_put (GTK_FIXED (fixed5), record_wav_button, 16, 156);
  gtk_widget_set_uposition (record_wav_button, 16, 156);
  gtk_widget_set_usize (record_wav_button, 96, 24);
 
  timed_record_button = gtk_check_button_new_with_label ("Timed Recording Length");
  gtk_widget_ref (timed_record_button);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "timed_record_button", timed_record_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (timed_record_button);
  gtk_fixed_put (GTK_FIXED (fixed5), timed_record_button, 120, 128);
  gtk_widget_set_uposition (timed_record_button, 120, 128);
  gtk_widget_set_usize (timed_record_button, 168, 24);

  label37 = gtk_label_new ("Hours and Min");
  gtk_widget_ref (label37);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "label37", label37,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label37);
  gtk_fixed_put (GTK_FIXED (fixed5), label37, 214, 154);
  gtk_widget_set_uposition (label37, 214, 154);
  gtk_widget_set_usize (label37, 104, 24);


  rf_label = gtk_label_new ("Record Frequency");
  gtk_widget_ref (rf_label);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "rf_label", rf_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (rf_label);
  gtk_fixed_put (GTK_FIXED (fixed5), rf_label, 16, 195);
  gtk_widget_set_uposition (rf_label, 16, 195);
  gtk_widget_set_usize (rf_label, 104, 24);


rf_combo_items=NULL;

  radio_speed_combo = gtk_combo_new ();
  gtk_widget_ref (radio_speed_combo);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "radio_speed_combo", radio_speed_combo,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (fixed5), radio_speed_combo, 16, 215);
  gtk_widget_set_uposition (radio_speed_combo, 16, 215);
  gtk_widget_set_usize (radio_speed_combo, 90, 22);
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "4000");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "8000");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "11025");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "22050");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "44100");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "48000");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "88200");
  rf_combo_items = g_list_append (rf_combo_items, (gpointer) "96000");
  gtk_combo_set_popdown_strings (GTK_COMBO (radio_speed_combo), rf_combo_items);
  g_list_free (rf_combo_items);

  rf_combo_entry = GTK_COMBO (radio_speed_combo)->entry;
  gtk_widget_ref (rf_combo_entry);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "rfcombo_entry", rf_combo_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_entry_set_text (GTK_ENTRY (rf_combo_entry), "4000");

  gtk_widget_show(radio_speed_combo);

  c_label = gtk_label_new ("Record Channel");
  gtk_widget_ref (c_label);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "c_label", c_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (c_label);
  gtk_fixed_put (GTK_FIXED (fixed5), c_label, 125, 195);
  gtk_widget_set_uposition (c_label, 125, 195);
  gtk_widget_set_usize (c_label, 104, 24);



  chan_combo = gtk_combo_new ();
  gtk_widget_ref (chan_combo);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "chan_combo", chan_combo,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (fixed5), chan_combo, 131, 215);
  gtk_widget_set_uposition (chan_combo, 131, 215);
  gtk_widget_set_usize (chan_combo, 90, 22);
devtot=0;

rf_combo_items=NULL;

for(num=0;num<25;num++)
{

if(level &(1 << num))
{
strcpy(devs[devtot].label,labels[num]);
devs[devtot].chan=num;
if(re &(1 << num) )
{
devs[devtot].rec=1;
rf_combo_items = g_list_append (rf_combo_items, (gpointer)labels[num]);
}
else
devs[devtot].rec=0;
devtot++;
}


}


for(num=0;num<devtot;num++)
{
if(recsrc &(1 << devs[num].chan) )
{
rec_src=devs[num].label;
}

}


  gtk_combo_set_popdown_strings (GTK_COMBO (chan_combo), rf_combo_items);
  g_list_free (rf_combo_items);

  c_combo_entry = GTK_COMBO (chan_combo)->entry;
  gtk_widget_ref (c_combo_entry);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "c_combo_entry", c_combo_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_entry_set_text (GTK_ENTRY (c_combo_entry),rec_src);

  gtk_widget_show(chan_combo);


  f_spin_adj = gtk_adjustment_new (5,0,10,1, 10, 10);
  fspin = gtk_spin_button_new (GTK_ADJUSTMENT (f_spin_adj), 1, 0);
  gtk_widget_ref (fspin);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "fspin", fspin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (fixed5), fspin, 250,215);
  gtk_widget_set_uposition (fspin, 250, 215);
  gtk_widget_set_usize (fspin, 56, 24);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (fspin), TRUE);
 /* gtk_widget_set_sensitive (fspin, FALSE);*/
  gtk_widget_show(fspin);

  q_label = gtk_label_new ("Record Quality");
  gtk_widget_ref (q_label);
  gtk_object_set_data_full (GTK_OBJECT (rec_window), "q_label", q_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (q_label);
  gtk_fixed_put (GTK_FIXED (fixed5), q_label, 240, 195);
  gtk_widget_set_uposition (q_label, 240, 195);
  gtk_widget_set_usize (q_label, 104, 24);
  gtk_widget_show(q_label);



  gtk_signal_connect (GTK_OBJECT (radio_speed_combo), "realize",
                      GTK_SIGNAL_FUNC (on_radio_speed_combo_realize),
                      NULL);


  gtk_signal_connect (GTK_OBJECT (start_record), "clicked",
                      GTK_SIGNAL_FUNC (on_start_record_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (stop_record), "clicked",
                      GTK_SIGNAL_FUNC (on_stop_record_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_hours), "realize",
                      GTK_SIGNAL_FUNC (on_record_hours_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_minutes), "realize",
                      GTK_SIGNAL_FUNC (on_record_minutes_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_directory_entry), "realize",
                      GTK_SIGNAL_FUNC (on_record_directory_entry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_file_entry), "realize",
                      GTK_SIGNAL_FUNC (on_record_file_entry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_directory_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_record_directory_browse_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_file_browse), "clicked",
                      GTK_SIGNAL_FUNC (on_record_file_browse_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_exit), "clicked",
                      GTK_SIGNAL_FUNC (on_record_exit_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_ogg_button), "realize",
                      GTK_SIGNAL_FUNC (on_record_ogg_button_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (record_wav_button), "realize",
                      GTK_SIGNAL_FUNC (on_record_wav_button_realize),
                      NULL);
/*
  gtk_signal_connect (GTK_OBJECT (record_mp3_button), "realize",
                      GTK_SIGNAL_FUNC (on_record_mp3_button_realize),
                      NULL);
*/
    gtk_signal_connect (GTK_OBJECT (timed_record_button), "realize",
                      GTK_SIGNAL_FUNC (on_timed_record_button_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (timed_record_button), "toggled",
                      GTK_SIGNAL_FUNC (on_timed_record_button_toggled),
                      NULL);
  return rec_window;
}


void
on_start_record_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_hide(start_record);
gtk_widget_show(stop_record);
if(!record_radio())
{
gtk_widget_hide(stop_record);
gtk_widget_show(start_record);
f_stop_rec=1;
}

}


void
on_stop_record_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_widget_hide(stop_record);
gtk_widget_show(start_record);
f_stop_rec=1;
}



void
on_record_hours_realize                (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_record_minutes_realize              (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_record_directory_entry_realize      (GtkWidget       *widget,
                                        gpointer         user_data)
{
rde=widget;
gtk_entry_set_text((GtkEntry*)rde,default_radio_directory);
}


void
on_record_file_entry_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{
fde=widget;
}


void
on_record_directory_browse_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;

f=create_single_dir_window ("/");
gtk_widget_show(f);
gtk_main();
if(ddata!=NULL)
{
gtk_entry_set_text((GtkEntry *)rde,ddata);
free(ddata);
ddata=NULL;
}
gtk_widget_destroy(f);

}


void
on_record_file_browse_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *f;

f=single_file_window (gtk_entry_get_text((GtkEntry*)rde));
 gtk_widget_show(f);
gtk_main();
if(fdata!=NULL)
{
gtk_entry_set_text((GtkEntry*)fde,strrchr(fdata,'/')+1);
free(fdata);
fdata=NULL;
}
gtk_widget_destroy(f);
}


void
on_rec_radio_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *rc;
rc=create_rec_window ();
gtk_widget_show(rc);
gtk_main();
gtk_widget_destroy(rc);
}



void
on_record_exit_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
gtk_main_quit();
}


void
on_record_ogg_button_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_record_wav_button_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{

}


void
on_record_mp3_button_realize           (GtkWidget       *widget,
                                        gpointer         user_data)
{

}



void
on_timed_record_button_realize         (GtkWidget       *widget,
                                        gpointer         user_data)
{

}

void
on_timed_record_button_toggled         (GtkWidget       *widget,
                                        gpointer         user_data)
{

if(gtk_toggle_button_get_active ((GtkToggleButton*)widget))
{
  gtk_widget_set_sensitive (record_hours, TRUE);
gtk_widget_set_sensitive (record_minutes, TRUE);
}
else
{
  gtk_widget_set_sensitive (record_minutes, FALSE);
gtk_widget_set_sensitive (record_hours, FALSE);
}


}

int record_radio()
{
int han=0;
int fmt= AFMT_S8;
char rb[1000];
FILE *fptr=NULL;
int radio_stat=2;
int c=0;
int speed;
char fname[10000];
int num;
char *t;
int b;
int f;
long ti;
int eof=0;
char *ebuff;
char pcmout[4096];
ao_sample_format format1;
int default_driver1;
ao_device *device1=NULL;

strcpy(fname,gtk_entry_get_text((GtkEntry*)rde));
strcat(fname,gtk_entry_get_text((GtkEntry*)fde));

han=open(fname,O_CREAT|O_TRUNC);
if(han<1)
{
  ebuff=(char *)malloc(5000);
sprintf(ebuff,"Sonic-Rainbow cannot open file %s to record to",fname);
   do_error_message(ebuff);
   free(ebuff);
   return 0;
}

on_play_radio_clicked(NULL,NULL);

f_stop_rec=0;

gtk_main_iteration_do(FALSE);

if(gtk_toggle_button_get_active ((GtkToggleButton*)timed_record_button))
{
ti=0;
ti=gtk_spin_button_get_value_as_int ((GtkSpinButton*)record_hours);
ti=ti*60;
ti=ti+(gtk_spin_button_get_value_as_int ((GtkSpinButton*)record_minutes)*60);
ti=ti*1000;
tradio=gtk_timeout_add(ti,(GtkFunction)radio_timer,NULL);
}
else
tradio=0;

t=gtk_entry_get_text((GtkEntry*)c_combo_entry);
for(num=0;num<devtot;num++)
{
if(strcmp(devs[num].label,t)==0)
{
 b=1;
 b=b<<devs[num].chan;

  f=open(default_mixer,O_RDWR);
  ioctl(f,MIXER_WRITE(SOUND_MIXER_READ_RECSRC),&b);
  close(f);
break;
}
}


speed=atoi(gtk_entry_get_text((GtkEntry*)rf_combo_entry));

close(han);
unlink(fname);

han=open("/dev/dsp",O_RDWR);

speed=atoi(gtk_entry_get_text((GtkEntry*)rf_combo_entry));

ioctl(han,SNDCTL_DSP_SETFMT,&fmt);
ioctl(han,SNDCTL_DSP_CHANNELS,&radio_stat); /* set channels */
ioctl(han,SNDCTL_DSP_SPEED,&speed);


if(gtk_toggle_button_get_active ((GtkToggleButton*)record_ogg_button))
{
sprintf(rb,"oggenc -R %s -B 8 -C %d -q %d -r - -o %s.ogg",gtk_entry_get_text((GtkEntry*)rf_combo_entry),2,gtk_spin_button_get_value_as_int ((GtkSpinButton*)fspin),fname);
fflush(NULL);
fptr=popen(rb,"w");

while(1)
{
c=read(han,pcmout,2);
if(c<1)break;
fwrite(pcmout,sizeof(char),2,fptr);
if(f_stop_rec)break;
gtk_main_iteration_do(FALSE);
}

f_stop_rec=0;
pclose(fptr);
signal(SIGALRM,SIG_IGN);
signal(SIGINT,SIG_IGN);
close(han);
kill(0,SIGINT);
}

else
if(gtk_toggle_button_get_active ((GtkToggleButton*)record_wav_button))
{

format1.bits =8;
format1.channels =2;
format1.rate = speed;

format1.byte_format = AO_FMT_LITTLE;

	ao_initialize();
	default_driver1 = ao_driver_id("wav");
	device1 = ao_open_file(default_driver1,fname,1,&format1, NULL);

	eof=0;


while(1)
{
gtk_main_iteration_do(FALSE);
c=read(han,pcmout,2);
if(c<1)break;
ao_play(device1,pcmout,2);
if(f_stop_rec)break;
gtk_main_iteration_do(FALSE);
}

close(han);

ao_close(device1);
ao_shutdown();
device1=NULL;
}

if(tradio)
{
gtk_timeout_remove(tradio);
gtk_widget_hide(stop_record);
gtk_widget_show(start_record);
}
return 1;

}





void
on_radio_speed_combo_realize          (GtkWidget       *widget,
                                        gpointer         user_data)
{
;
}



void radio_timer()
{
f_stop_rec=1;
}


