/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2004 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "cd.h"
#include <fcntl.h>
#include <linux/soundcard.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/videodev.h>
#include <string.h>
#include <dirent.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>
#include <mad.h>
#include <id3tag.h>
#include <audiofile.h>
#include <ao/ao.h>
#include <sys/mman.h>
#include <id3.h>
#include <glib.h>
#include "charset.h"
#include "vcedit.h"
#include <FLAC/all.h>
#include <FLAC/stream_decoder.h>

#define ID3V2_MAX_STRING_LEN 4096
#define MULTIFIELD_SEPARATOR " - "
#define BUFFER_FRAME_COUNT 65536

extern GtkWidget *te,*he;

int Id3tag_Get_Id3v2_Version (char *);
gboolean Ogg_Tag_Read_File_Tag (gchar *filename);
gboolean Ogg_Tag_Write_File_Tag ();
gboolean Ogg_Tag_Write_File (FILE *file_in, gchar *filename_in, vcedit_state *state);
int isogg(char *);
int ismp3(char *);
int isflac(char *fn);
gboolean Flac_Tag_Read_File_Tag (gchar *filename);
int retag_flac_tag(char *fname);
FLAC__bool set_vc_field(const char *filename, FLAC__StreamMetadata *block, char *field, FLAC__bool *needs_write, FLAC__bool raw);

void
on_tag_exit_clicked                     (GtkButton       *button,
                                        gpointer         user_data);

void
on_tag_help_clicked                     (GtkButton       *button,
                                        gpointer         user_data);
void fill_tag(void);

extern char help[];

char *cdir=NULL;
char *tag_file=NULL;
int tag_dirnum=0;
int frow=-1;
ID3Tag  *tag=NULL;
ID3Frame *id3_frame;
ID3Field *id3_field;

extern GtkWidget *hw;

FLAC__bool remove_vc_all(FLAC__StreamMetadata *block, FLAC__bool *needs_write);
int tag_dirfill_list(char *di);
GtkWidget *tag_exit,*tag_fixed,*tag_window,*tag_scrolledwindow1=NULL;
GtkWidget *tag_dirlist,*tag_cdir,*tag_help=NULL;
GtkWidget *tag_filelist=NULL;
GtkWidget *tag_scrolledwindow2=NULL;
GtkWidget *tag_artist_entry, *tag_album_entry,*tag_track_entry,*tag_genre_entry,*tag_comment_entry=NULL;
GtkWidget *tag_year_entry=NULL;
GtkWidget *tag_genre_combo,*tag_combo_entry,*tag_update=NULL;
GtkWidget *scrolledwindow3,*text1;

GList *genre_items = NULL;

void on_tag_update_clicked (GtkButton       *button,gpointer         user_data);
void on_tag_dirlist_realize (GtkWidget       *widget,gpointer         user_data);
GtkWidget* create_tag_window (char *);
void on_tag_dirlist_select_row (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void on_tag_cdir_realize (GtkWidget       *widget,
                                        gpointer         user_data);
void on_tag_filelist_realize (GtkWidget       *widget,
                                        gpointer         user_data);

void
on_tag_filelist_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void
on_tag_filelist_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);
void update();



GtkWidget* create_tag_window (char *sd)
{

  GtkWidget *atlabel3;
  GtkWidget *atlabel1;
  GtkWidget *atlabel2;
  GtkWidget *album_label,*track_label,*comment_label,*genre_label,*year_label,*artist_label;
  int num;

  DIR *dir1_handle=NULL;
  char *root_dir="/";


dir1_handle=opendir(sd);
if(dir1_handle==NULL)
{
cdir=root_dir;
}
else
{
closedir(dir1_handle);
cdir=sd;
}
  cdir=sd;


  tag_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (tag_window), "tag_window", tag_window);
  gtk_window_set_title (GTK_WINDOW (tag_window), "Sonic-Rainbow File Tag");

  tag_fixed = gtk_fixed_new ();
  gtk_widget_ref (tag_fixed);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_fixed", tag_fixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_fixed);
  gtk_container_add (GTK_CONTAINER (tag_window), tag_fixed);
  gtk_widget_set_usize (tag_fixed, 349, 515);


  tag_cdir = gtk_entry_new ();
  gtk_widget_ref (tag_cdir);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_cdir", tag_cdir,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_cdir);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_cdir, 16, 25);
  gtk_widget_set_uposition (tag_cdir, 16, 25);
  gtk_widget_set_usize (tag_cdir, 318, 24);
  gtk_entry_set_editable ((GtkEntry*)tag_cdir,0);

  atlabel3 = gtk_label_new ("Current Directory");
  gtk_widget_ref (atlabel3);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "atlabel3", atlabel3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel3);
  gtk_fixed_put (GTK_FIXED (tag_fixed), atlabel3, 15, 4);
  gtk_widget_set_uposition (atlabel3, 15, 4);
  gtk_widget_set_usize (atlabel3, 100, 24);




  album_label = gtk_label_new ("Album Title");
  gtk_widget_ref (album_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "album_label", album_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (album_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), album_label, 16, 280);
  gtk_widget_set_uposition (album_label, 16, 280);
  gtk_widget_set_usize (album_label, 60, 24);

  tag_album_entry = gtk_entry_new ();
  gtk_widget_ref (tag_album_entry);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_album_entry", tag_album_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_album_entry);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_album_entry, 85, 280);
  gtk_widget_set_uposition (tag_album_entry, 85, 280);
  gtk_widget_set_usize (tag_album_entry, 248, 24);



  artist_label = gtk_label_new ("Track Artist");
  gtk_widget_ref (artist_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "artist_label", artist_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (artist_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), artist_label, 16, 310);
  gtk_widget_set_uposition (artist_label, 16, 310);
  gtk_widget_set_usize (artist_label, 65, 24);

  tag_artist_entry = gtk_entry_new ();
  gtk_widget_ref (tag_artist_entry);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_artist_entry", tag_artist_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_artist_entry);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_artist_entry, 85, 310);
  gtk_widget_set_uposition (tag_artist_entry, 85, 310);
  gtk_widget_set_usize (tag_artist_entry, 248, 24);


  track_label = gtk_label_new ("Track Title");
  gtk_widget_ref (track_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "track_label", track_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (track_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), track_label, 16, 340);
  gtk_widget_set_uposition (track_label, 16, 340);
  gtk_widget_set_usize (track_label, 60, 24);

  tag_track_entry = gtk_entry_new ();
  gtk_widget_ref (tag_track_entry);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_track_entry", tag_track_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_track_entry);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_track_entry, 85, 340);
  gtk_widget_set_uposition (tag_track_entry, 85, 340);
  gtk_widget_set_usize (tag_track_entry, 248, 24);


  comment_label = gtk_label_new ("Comment");
  gtk_widget_ref (comment_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "comment_label", comment_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (comment_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), comment_label, 16, 435);
  gtk_widget_set_uposition (comment_label, 16, 435);
  gtk_widget_set_usize (comment_label, 55, 24);


  year_label = gtk_label_new ("Year");
  gtk_widget_ref (year_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "year_label", year_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (year_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), year_label, 16, 370);
  gtk_widget_set_uposition (year_label, 16, 370);
  gtk_widget_set_usize (year_label,30, 24);

  tag_year_entry = gtk_entry_new ();
  gtk_widget_ref (tag_year_entry);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_year_entry", tag_year_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_year_entry);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_year_entry, 85, 370);
  gtk_widget_set_uposition (tag_year_entry, 85, 370);
  gtk_widget_set_usize (tag_year_entry, 90, 24);


  genre_label = gtk_label_new ("Genre");
  gtk_widget_ref (genre_label);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "genre_label", genre_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (genre_label);
  gtk_fixed_put (GTK_FIXED (tag_fixed), genre_label, 16, 400);
  gtk_widget_set_uposition (genre_label, 16, 400);
  gtk_widget_set_usize (genre_label, 40, 24);



  tag_genre_combo = gtk_combo_new ();
  gtk_widget_ref (tag_genre_combo);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_genre_combo", tag_genre_combo,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_genre_combo);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_genre_combo, 85, 400);
  gtk_widget_set_uposition (tag_genre_combo, 85, 400);
  gtk_widget_set_usize (tag_genre_combo, 144, 22);

  tag_combo_entry = GTK_COMBO (tag_genre_combo)->entry;
  gtk_widget_ref (tag_combo_entry);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_combo_entry", tag_combo_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_combo_entry);

for(num=0;num<ID3_NR_OF_V1_GENRES;num++)
{
  genre_items = g_list_append (genre_items,(gchar *)ID3_v1_genre_description[num]);
}
  gtk_combo_set_popdown_strings (GTK_COMBO (tag_genre_combo), genre_items);


  tag_scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (tag_scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_scrolledwindow2", tag_scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_scrolledwindow2);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_scrolledwindow2, 174, 56);
  gtk_widget_set_uposition (tag_scrolledwindow2, 174, 56);
  gtk_widget_set_usize (tag_scrolledwindow2, 160, 208);

  tag_filelist = gtk_clist_new (1);
  gtk_widget_ref (tag_filelist);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_filelist", tag_filelist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_filelist);
  gtk_container_add (GTK_CONTAINER (tag_scrolledwindow2), tag_filelist);
  gtk_clist_set_column_width (GTK_CLIST (tag_filelist), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (tag_filelist), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (tag_filelist));

  atlabel2 = gtk_label_new ("Files");
  gtk_widget_ref (atlabel2);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "atlabel2", atlabel2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel2);
  gtk_clist_set_column_widget (GTK_CLIST (tag_filelist), 0, atlabel2);
  gtk_label_set_justify (GTK_LABEL (atlabel2), GTK_JUSTIFY_LEFT);

  tag_exit = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (tag_exit);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_exit", tag_exit,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_exit);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_exit, 60, 475);
  gtk_widget_set_uposition (tag_exit, 60, 475);
  gtk_widget_set_usize (tag_exit, 51, 26);


  tag_update = gtk_button_new_with_label ("Save");
  gtk_widget_ref (tag_update);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_update", tag_update,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_update);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_update, 150, 475);
  gtk_widget_set_uposition (tag_update, 150, 475);
  gtk_widget_set_usize (tag_update, 51, 26);

  tag_help = gtk_button_new_with_label ("Help");
  gtk_widget_ref (tag_help);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_help", tag_help,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_help);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_help, 250, 475);
  gtk_widget_set_uposition (tag_help, 250, 475);
  gtk_widget_set_usize (tag_help, 51, 26);

  tag_scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (tag_scrolledwindow1);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_scrolledwindow1", tag_scrolledwindow1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_scrolledwindow1);
  gtk_fixed_put (GTK_FIXED (tag_fixed), tag_scrolledwindow1, 16, 56);
  gtk_widget_set_uposition (tag_scrolledwindow1, 16, 56);
  gtk_widget_set_usize (tag_scrolledwindow1, 160, 208);

  tag_dirlist = gtk_clist_new (1);
  gtk_widget_ref (tag_dirlist);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "tag_dirlist", tag_dirlist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (tag_dirlist);
  gtk_container_add (GTK_CONTAINER (tag_scrolledwindow1), tag_dirlist);
  gtk_clist_set_column_width (GTK_CLIST (tag_dirlist), 0, 80);
  gtk_clist_set_selection_mode (GTK_CLIST (tag_dirlist), GTK_SELECTION_SINGLE);
  gtk_clist_column_titles_show (GTK_CLIST (tag_dirlist));

  atlabel1 = gtk_label_new ("Directorys");
  gtk_widget_ref (atlabel1);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "atlabel1", atlabel1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (atlabel1);
  gtk_clist_set_column_widget (GTK_CLIST (tag_dirlist), 0, atlabel1);
  gtk_label_set_justify (GTK_LABEL (atlabel1), GTK_JUSTIFY_LEFT);


  scrolledwindow3 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow3);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "scrolledwindow3", scrolledwindow3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow3);
  gtk_fixed_put (GTK_FIXED (tag_fixed), scrolledwindow3, 85, 430);
  gtk_widget_set_uposition (scrolledwindow3, 85, 430);
  gtk_widget_set_usize (scrolledwindow3, 248, 36);
  gtk_scrolled_window_set_policy((GtkScrolledWindow*)scrolledwindow3,GTK_POLICY_NEVER,GTK_POLICY_ALWAYS);

  text1 = gtk_text_new (NULL, NULL);
  gtk_widget_ref (text1);
  gtk_object_set_data_full (GTK_OBJECT (tag_window), "text1", text1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (text1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow3), text1);
  gtk_text_set_editable (GTK_TEXT (text1), TRUE);


 gtk_signal_connect (GTK_OBJECT (tag_update), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_update_clicked),
                      NULL);
gtk_signal_handler_block_by_func((GtkObject*)tag_update,on_tag_update_clicked,NULL);

 gtk_signal_connect (GTK_OBJECT (tag_exit), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_exit_clicked),
                      NULL);

 gtk_signal_connect (GTK_OBJECT (tag_help), "clicked",
                      GTK_SIGNAL_FUNC (on_tag_help_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (tag_dirlist), "realize",
                      GTK_SIGNAL_FUNC (on_tag_dirlist_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_dirlist), "select_row",
                      GTK_SIGNAL_FUNC (on_tag_dirlist_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_cdir), "realize",
                      GTK_SIGNAL_FUNC (on_tag_cdir_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_filelist), "realize",
                      GTK_SIGNAL_FUNC (on_tag_filelist_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_filelist), "select_row",
                      GTK_SIGNAL_FUNC (on_tag_filelist_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (tag_filelist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_tag_filelist_unselect_row),
                      NULL);

  return tag_window;
}




void
on_tag_cdir_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
gtk_entry_set_text((GtkEntry*)widget,cdir);
}





void
on_tag_dirlist_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle;
char *t[2];
struct dirent *dent;


tag_dirnum=0;

dir1_handle=opendir(cdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)return;
strcpy(cdir,"/");
}
while(1)
{

dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type==DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
tag_dirnum++;
}

}

gtk_clist_set_auto_sort ((GtkCList*)widget,1);
closedir(dir1_handle);
}








void
on_tag_filelist_realize                      (GtkWidget       *widget,
                                        gpointer         user_data)
{
DIR *dir1_handle;
char *t[2];
struct dirent *dent;

dir1_handle=opendir(cdir);
if(dir1_handle==NULL)
{
dir1_handle=opendir("/");
if(dir1_handle==NULL)
return;
}
while(1)
{
dent=readdir(dir1_handle);
if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)widget,t);
}
}


closedir(dir1_handle);
gtk_clist_set_auto_sort ((GtkCList*)widget,1);
}





void
on_tag_dirlist_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *t,*p;
char *cwd,*nwd;
int b,csel;

tag_dirnum=-1;

if(event->button.type==GDK_2BUTTON_PRESS)
{
cwd=(char *)malloc(10001);
nwd=(char *)malloc(10001);
getcwd(cwd,10000);
gtk_clist_get_text((GtkCList *)clist,row,column,&p);
t=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)tag_cdir))+ strlen(p)+2);
strcpy(t,gtk_entry_get_text((GtkEntry*)tag_cdir));
strcat(t,p);
strcat(t,"/");
chdir(t);
getcwd(nwd,10000);
if(strlen(nwd)>2 && nwd[strlen(nwd)-1]!='/')
strcat(nwd,"/");
b=tag_dirfill_list(t);
if(b)gtk_entry_set_text((GtkEntry*)tag_cdir,nwd);
chdir(cwd);
free(cwd);
free(nwd);
free(t);
}
else
csel=row;


}







int tag_dirfill_list(char *di)
{
DIR *dir1_handle=NULL;
char *t[2];
struct dirent *dent=NULL;


dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)tag_dirlist);
tag_dirnum=0;

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type==DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)tag_dirlist,t);
tag_dirnum++;
}
}
closedir(dir1_handle);
gtk_clist_set_auto_sort ((GtkCList*)tag_dirlist,1);
dir1_handle=NULL;
dent=NULL;


dir1_handle=opendir(di);
if(dir1_handle==NULL)return 0;

gtk_clist_clear((GtkCList*)tag_filelist);

while(1)
{

dent=readdir(dir1_handle);

if(dent==NULL)break;
if(dent->d_type!=DT_DIR)
{
t[0]=dent->d_name;
t[1]=NULL;
gtk_clist_append((GtkCList*)tag_filelist,t);
}
}


closedir(dir1_handle);
gtk_clist_set_auto_sort ((GtkCList*)tag_filelist,1);
return 1;
}






void
on_tag_filelist_unselect_row                 (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
frow=-1;
if(tag!=NULL)
{
ID3Tag_Delete(tag);
tag=NULL;
}
gtk_signal_handler_block_by_func((GtkObject*)tag_update,on_tag_update_clicked,NULL);
gtk_entry_set_text((GtkEntry*)tag_track_entry,"");
gtk_entry_set_text((GtkEntry*)tag_artist_entry,"");
gtk_entry_set_text((GtkEntry*)tag_album_entry,"");
gtk_entry_set_text((GtkEntry*)tag_comment_entry,"");
gtk_entry_set_text((GtkEntry*)tag_combo_entry,"");
gtk_entry_set_text((GtkEntry*)tag_year_entry,"");
gtk_text_set_point((GtkText*)text1,0);
gtk_text_forward_delete((GtkText*)text1,gtk_text_get_length((GtkText*)text1));

}



void
on_tag_filelist_select_row                   (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
char *p;

if(tag_file)free(tag_file);

gtk_clist_get_text((GtkCList *)clist,row,column,&p);
tag_file=(char *)malloc(strlen(gtk_entry_get_text((GtkEntry*)tag_cdir))+ strlen(p)+2);
strcpy(tag_file,gtk_entry_get_text((GtkEntry*)tag_cdir));
strcat(tag_file,p);

if(isflac(tag_file))
{
Flac_Tag_Read_File_Tag (tag_file);
gtk_signal_handler_unblock_by_func((GtkObject*)tag_update,on_tag_update_clicked,NULL);
frow=row;
}
else
if(ismp3(tag_file))
{
fill_tag();
gtk_signal_handler_unblock_by_func((GtkObject*)tag_update,on_tag_update_clicked,NULL);
frow=row;
}
else
if(isogg(tag_file))
{
Ogg_Tag_Read_File_Tag (tag_file);
gtk_signal_handler_unblock_by_func((GtkObject*)tag_update,on_tag_update_clicked,NULL);
frow=row;
}
else
frow=-1;
}



void
on_tag_exit_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if(tag_file){free(tag_file);tag_file=NULL;}
if(tag!=NULL)
{
ID3Tag_Delete(tag);
tag=NULL;
}

gtk_widget_destroy(te);
te=NULL;
}

void
on_tag_update_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if(isflac(tag_file))
{
retag_flac_tag(tag_file);
}
else
if(ismp3(tag_file))
{
update();
gtk_clist_unselect_row((GtkCList*)tag_filelist,frow,0);
if(tag_file){free(tag_file);tag_file=NULL;}
if(tag!=NULL)
{
ID3Tag_Delete(tag);
tag=NULL;
}
}
else
if(isogg(tag_file))
{
Ogg_Tag_Write_File_Tag ();
gtk_clist_unselect_row((GtkCList*)tag_filelist,frow,0);
if(tag_file){free(tag_file);tag_file=NULL;}
}

}

void fill_tag()
{
size_t offset;
int num_chars;
char string[ID3V2_MAX_STRING_LEN],*string1;
int num;
GtkList *l;
char *token;

if(tag!=NULL)
{
ID3Tag_Delete(tag);
tag=NULL;
}

tag= ID3Tag_New();
offset = ID3Tag_Link(tag,tag_file);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_TITLE);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);

if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_entry_set_text((GtkEntry*)tag_track_entry,string1);
}
else
gtk_entry_set_text((GtkEntry*)tag_track_entry,"");

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_LEADARTIST);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);

if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_entry_set_text((GtkEntry*)tag_artist_entry,string1);
}
else
gtk_entry_set_text((GtkEntry*)tag_artist_entry,"");

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_ALBUM);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);

if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_entry_set_text((GtkEntry*)tag_album_entry,string1);
}
else
gtk_entry_set_text((GtkEntry*)tag_album_entry,"");

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_COMMENT);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);

if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_text_insert ((GtkText*)text1,NULL,NULL,NULL,string1,-1);
}
else
gtk_text_insert ((GtkText*)text1,NULL,NULL,NULL,"",-1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_YEAR);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);

if(num_chars)
{
string1 = convert_from_iso88591(string);
gtk_entry_set_text((GtkEntry*)tag_year_entry,string1);
}
else
gtk_entry_set_text((GtkEntry*)tag_year_entry,"");

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_CONTENTTYPE);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
num_chars=ID3Field_GetASCII(id3_field,string,ID3V2_MAX_STRING_LEN);
if(num_chars)
{
if ( (string[0]=='(') && (strchr(string,')')) )
{
string1 = convert_from_iso88591(string+1);
token=strtok(string1,")");
gtk_entry_set_text((GtkEntry*)tag_combo_entry,ID3_v1_genre_description[atoi(token)]);
}
else
{
string1 = convert_from_iso88591(string);
for(num=0;num<ID3_NR_OF_V1_GENRES;num++)
if(strcasecmp(string1,ID3_v1_genre_description[num])==0)
break;
l=(GtkList*)GTK_COMBO (tag_genre_combo)->list;
gtk_list_select_item (l,num);
}
}
else
gtk_entry_set_text((GtkEntry*)tag_combo_entry,"");

}


void update()
{
char *string1;

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_ALBUM);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_ALBUM);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_entry_get_text((GtkEntry*)tag_album_entry));
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_LEADARTIST);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_LEADARTIST);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_entry_get_text((GtkEntry*)tag_artist_entry));
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_TITLE);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_TITLE);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_entry_get_text((GtkEntry*)tag_track_entry));
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_YEAR);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_YEAR);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_entry_get_text((GtkEntry*)tag_year_entry));
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_CONTENTTYPE);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_CONTENTTYPE);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_entry_get_text((GtkEntry*)tag_combo_entry));
ID3Field_SetASCII(id3_field,string1);

id3_frame = ID3Tag_FindFrameWithID(tag,ID3FID_COMMENT);
ID3Tag_RemoveFrame(tag,id3_frame);
id3_frame = ID3Frame_NewID(ID3FID_COMMENT);
ID3Tag_AttachFrame(tag,id3_frame);
id3_field = ID3Frame_GetField(id3_frame,ID3FN_TEXT);
string1 = convert_to_iso88591(gtk_editable_get_chars ((GtkEditable*)text1,0,-1));
ID3Field_SetASCII(id3_field,string1);

ID3Tag_NumFrames(tag);
ID3Tag_UpdateByTagType(tag,ID3TT_ID3V2);
}







/* This function is based on work of :
* ogg_tag.c - 2001/11/08
*
*  EasyTAG - Tag editor for MP3 and Ogg Vorbis files
*  Copyright (C) 2001-2003  Jerome Couderc <j.couderc@ifrance.com>
*
*/
gboolean Ogg_Tag_Read_File_Tag (gchar *filename)
{
    FILE           *file;
    vcedit_state   *state;
    vorbis_comment *vc;
    gchar          *string = NULL;
    gchar          *string1 = NULL;
    guint           field_num;
    guchar tmp_id3[4];
    gulong id3v2size;


    if ( (file=fopen(filename,"rb")) == NULL )
                return FALSE;

    // Skip the id3v2 tag


    // Check if there is an ID3v2 tag...
    fseek(file, 0L, SEEK_SET);
    if (fread(tmp_id3, 1, 4, file) == 4)
    {
        // Calculate ID3v2 length
        if (tmp_id3[0] == 'I' && tmp_id3[1] == 'D' && tmp_id3[2] == '3' && tmp_id3[3] < 0xFF)
        {
            // id3v2 tag skipeer $49 44 33 yy yy xx zz zz zz zz [zz size]
            fseek(file, 2, SEEK_CUR); // Size is 6-9 position
            if (fread(tmp_id3, 1, 4, file) == 4)
            {
                id3v2size = 10 + ( (long)(tmp_id3[3])        | ((long)(tmp_id3[2]) << 7)
                                   | ((long)(tmp_id3[1]) << 14) | ((long)(tmp_id3[0]) << 21) );
                fseek(file, id3v2size, SEEK_SET);
            }else
            {
                fseek(file, 0L, SEEK_SET);
            }
        }else
        {
            fseek(file, 0L, SEEK_SET);
        }
    }else
    {
        fseek(file, 0L, SEEK_SET);
    }

    state = vcedit_new_state();    // Allocate memory for 'state'
    if ( vcedit_open(state,file) < 0 )
    {
        fclose(file);
        return FALSE;
    }

    /* Get data from tag */
    vc = vcedit_comments(state);


    /*********
     * Title *
     *********/
    field_num = 0;
    while ( (string = vorbis_comment_query(vc,"TITLE",field_num++)) != NULL )
    {
        if ( strlen(string)>0 )
        {
            string = convert_from_utf8(string);
            gtk_entry_set_text((GtkEntry*)tag_track_entry,string);
            g_free(string);
        }
    }

    /**********
     * Artist *
     **********/
    field_num = 0;
    while ( (string = vorbis_comment_query(vc,"ARTIST",field_num++)) != NULL )
    {
        if ( strlen(string)>0 )
        {
            string = convert_from_utf8(string);
            gtk_entry_set_text((GtkEntry*)tag_artist_entry,string);
            g_free(string);
        }
    }

    /*********
     * Album *
     *********/
    field_num = 0;
    while ( (string = vorbis_comment_query(vc,"ALBUM",field_num++)) != NULL )
    {
        if ( strlen(string)>0 )
        {
            string = convert_from_utf8(string);
            gtk_entry_set_text((GtkEntry*)tag_album_entry,string);
            g_free(string);
        }
    }

    /********
     * Year *
     ********/
    if ( (string = vorbis_comment_query(vc,"DATE",0)) != NULL && strlen(string)>0 )
    {
        string = convert_from_utf8(string);
        gtk_entry_set_text((GtkEntry*)tag_year_entry,string);
        //Strip_String(string);
        // FileTag->year = g_strdup(string);
        g_free(string);
    }


    /*********
     * Genre *
     *********/
    field_num = 0;
    while ( (string = vorbis_comment_query(vc,"GENRE",field_num++)) != NULL )
    {
        if ( strlen(string)>0 )
        {
            string = convert_from_utf8(string);
            gtk_entry_set_text((GtkEntry*)tag_combo_entry,string);
            g_free(string);
        }
    }

    /***********
     * Comment *
     ***********/
    field_num = 0;
    string1 = NULL; // Cause it may be not updated into the 'while' condition
    while ( ((string  = vorbis_comment_query(vc,"COMMENT",field_num)) != NULL )   // Winamp format
         || ((string1 = vorbis_comment_query(vc,"",       field_num)) != NULL ) ) // Xmms format
    {
        if ( string && strlen(string)>0 ) // Contains comment to Winamp format and we prefer this format (field name defined)
        {
            string = convert_from_utf8(string);
            //Strip_String(string);
/*
            if (FileTag->comment==NULL)
                FileTag->comment = g_strdup(string);
            else
                FileTag->comment = g_strconcat(FileTag->comment,MULTIFIELD_SEPARATOR,string,NULL);
*/
gtk_text_insert ((GtkText*)text1,NULL,NULL,NULL,string,-1);
            g_free(string);
            if (string1 && strlen(string1)>0) g_free(string1);
        }else if ( string1 && strlen(string1)>0 ) // Contains comment to Xmms format only
        {
            string1 = convert_from_utf8(string1);
           // Strip_String(string1);
/*
            if (FileTag->comment==NULL)
                FileTag->comment = g_strdup(string2);
            else
                FileTag->comment = g_strconcat(FileTag->comment,MULTIFIELD_SEPARATOR,string2,NULL);
*/
gtk_text_insert ((GtkText*)text1,NULL,NULL,NULL,string,-1);
            g_free(string1);
        }
        string1 = NULL;
        field_num++;
}


    vcedit_clear(state);
    fclose(file);

    return TRUE;
}







/* This function is based on work of :
* ogg_tag.c - 2001/11/08
*
*  EasyTAG - Tag editor for MP3 and Ogg Vorbis files
*  Copyright (C) 2001-2003  Jerome Couderc <j.couderc@ifrance.com>
*
*/
gboolean Ogg_Tag_Write_File_Tag ()
{
    FILE           *file_in;
    vcedit_state   *state;
    vorbis_comment *vc;
    gchar          *string, *string1;
   guchar tmp_id3[4];
    gulong id3v2size;

    if ( (file_in=fopen(tag_file,"rb"))==NULL )
    {
              return FALSE;
    }


    // Skip the id3v2 tag


    // Check if there is an ID3v2 tag...
    fseek(file_in, 0L, SEEK_SET);
    if (fread(tmp_id3, 1, 4, file_in) == 4)
    {
        // Calculate ID3v2 length
        if (tmp_id3[0] == 'I' && tmp_id3[1] == 'D' && tmp_id3[2] == '3' && tmp_id3[3] < 0xFF)
        {
            // id3v2 tag skipeer $49 44 33 yy yy xx zz zz zz zz [zz size]
            fseek(file_in, 2, SEEK_CUR); // Size is 6-9 position
            if (fread(tmp_id3, 1, 4, file_in) == 4)
            {
                id3v2size = 10 + ( (long)(tmp_id3[3])        | ((long)(tmp_id3[2]) << 7)
                                   | ((long)(tmp_id3[1]) << 14) | ((long)(tmp_id3[0]) << 21) );
                fseek(file_in, id3v2size, SEEK_SET);
            }else
            {
                fseek(file_in, 0L, SEEK_SET);
            }
        }else
        {
            fseek(file_in, 0L, SEEK_SET);
        }
    }else
    {
        fseek(file_in, 0L, SEEK_SET);
    }


    state = vcedit_new_state();    // Allocate memory for 'state'
    if ( vcedit_open(state,file_in) < 0 )
    {
        fclose(file_in);
        return FALSE;
    }

    /* Get data from tag */

    vc = vcedit_comments(state);
    vorbis_comment_clear(vc);
    vorbis_comment_init(vc);

    /*********
     * Title *
     *********/

        string  = g_strconcat("TITLE=",gtk_entry_get_text((GtkEntry*)tag_track_entry),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /**********
     * Artist *
     **********/

        string  = g_strconcat("ARTIST=",gtk_entry_get_text((GtkEntry*)tag_artist_entry),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /*********
     * Album *
     *********/
        string  = g_strconcat("ALBUM=",gtk_entry_get_text((GtkEntry*)tag_album_entry),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /********
     * Year *
     ********/

        string  = g_strconcat("DATE=",gtk_entry_get_text((GtkEntry*)tag_year_entry),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);


    /*********
     * Genre *
     *********/

        string  = g_strconcat("GENRE=",gtk_entry_get_text((GtkEntry*)tag_combo_entry),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);

    /***********
     * Comment *
     ***********/
    // We write the comment using the "both" format


        string = g_strconcat("COMMENT=",gtk_editable_get_chars ((GtkEditable*)text1,0,-1),NULL);
        string1 = convert_to_utf8(string);
        vorbis_comment_add(vc,string1);
        g_free(string);
        g_free(string1);



    /* Write tag */
    if ( Ogg_Tag_Write_File(file_in,tag_file,state) == FALSE )
    {
        return FALSE;
    }

    vcedit_clear(state);

    return TRUE;
}




/* This function is based on work of :
 *  XMMS - Cross-platform multimedia player
 *  Copyright (C) 1998-2001  Peter Alm, Mikael Alm, Olle Hallnas, Thomas Nilsson and 4Front Technologies
 *  Copyright (C) 1999-2001  Håvard Kvålen
 *  Copyright (C) 2001, Jorn Baayen <jorn@nl.linux.org>
 */
gboolean Ogg_Tag_Write_File (FILE *file_in, gchar *filename_in, vcedit_state *state)
{
    gchar *filename_tmp;
    gint   file_mkstemp;
    FILE  *file_out;
    gboolean return_code = TRUE;


    filename_tmp = g_strdup_printf("%s.XXXXXX",filename_in);

    if ((file_mkstemp = mkstemp(filename_tmp)) < 0)
    {
        g_free(filename_tmp);
        fclose(file_in);
        return FALSE;
    }

    if ( (file_out=fdopen(file_mkstemp,"wb")) == NULL )
    {
        close(file_mkstemp);
        remove(filename_tmp);
        g_free(filename_tmp);
        fclose(file_in);
        return FALSE;
    }

    if(vcedit_write(state,file_out) < 0)
        return_code = FALSE;

    fclose(file_in);

    if (fclose(file_out) != 0)
        return_code = FALSE;

    if ( (return_code==FALSE) || (rename(filename_tmp,filename_in)<0) )
    {
        remove(filename_tmp);
        return_code = FALSE;
    }

    g_free(filename_tmp);

    return return_code;
}




gboolean Flac_Tag_Read_File_Tag (char *fn)
{
FLAC__bool found_vc_block = false;
FLAC__StreamMetadata *block = 0;
FLAC__Metadata_Iterator *iterator = FLAC__metadata_iterator_new();
FLAC__Metadata_Chain *chain = FLAC__metadata_chain_new();
int i;
gchar *string;

if(0 == chain)
{
return 0;
}

if(!FLAC__metadata_chain_read(chain, fn))
 {
FLAC__metadata_chain_delete(chain);
return false;
}

if(0 == iterator)
{
FLAC__metadata_chain_delete(chain);
return 0;
}

FLAC__metadata_iterator_init(iterator, chain);
do {
block = FLAC__metadata_iterator_get_block(iterator);
if(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT)
found_vc_block = true;
} while(!found_vc_block && FLAC__metadata_iterator_next(iterator));

if(!found_vc_block)
{
FLAC__metadata_iterator_delete(iterator);
FLAC__metadata_chain_delete(chain);
return 0;
}


i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"TITLE");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"TITLE="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>6)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+6);
            gtk_entry_set_text((GtkEntry*)tag_track_entry,string);
            g_free(string);
}
}
}


i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"ARTIST");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"ARTIST="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>8)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+7);
            gtk_entry_set_text((GtkEntry*)tag_artist_entry,string);
            g_free(string);
}
}
}


i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"ALBUM");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"ALBUM="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>7)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+6);
            gtk_entry_set_text((GtkEntry*)tag_album_entry,string);
            g_free(string);
}
}
}

i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"DATE");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"DATE="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>6)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+5);
            gtk_entry_set_text((GtkEntry*)tag_year_entry,string);
            g_free(string);
}
}
}

i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"GENRE");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"GENRE="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>7)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+6);
            gtk_entry_set_text((GtkEntry*)tag_combo_entry,string);
            g_free(string);
}
else
{
string = convert_from_utf8("Unknown");
gtk_entry_set_text((GtkEntry*)tag_combo_entry,string);
            g_free(string);
}
}
}
else
{
string = convert_from_utf8("Unknown");
gtk_entry_set_text((GtkEntry*)tag_combo_entry,string);
            g_free(string);
}

i=FLAC__metadata_object_vorbiscomment_find_entry_from(block,0,"COMMENT");
if(i!=-1)
{
if((strcmp((block->data.vorbis_comment.comments+i)->entry,"COMMENT="))!=0)
{
if((block->data.vorbis_comment.comments+i)->length>9)
{
            string = convert_from_utf8((block->data.vorbis_comment.comments+i)->entry+8);
            gtk_text_insert ((GtkText*)text1,NULL,NULL,NULL,string,-1);
            g_free(string);
}
}
}

FLAC__metadata_iterator_delete(iterator);
FLAC__metadata_chain_delete(chain);

return 1;
}











int retag_flac_tag(char *fname)
{
        gchar          *string,*string1=NULL;
	FLAC__bool ok = true, found_vc_block = false;
	FLAC__StreamMetadata *block = 0;
	FLAC__Metadata_Iterator *iterator = FLAC__metadata_iterator_new();
	FLAC__Metadata_Chain *chain = FLAC__metadata_chain_new();
int nw=1;
	if(0 == chain)
		return 0;

	if(!FLAC__metadata_chain_read(chain, fname)) {

		return false;
	}


	if(0 == iterator)
		return 0;

	FLAC__metadata_iterator_init(iterator, chain);

	do {
		block = FLAC__metadata_iterator_get_block(iterator);
		if(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT)
{
        FLAC__metadata_iterator_delete_block(iterator, 0);
	FLAC__metadata_iterator_delete(iterator);
	ok = FLAC__metadata_chain_write(chain, 0,1);
	FLAC__metadata_chain_delete(chain);

			found_vc_block = true;

	iterator = FLAC__metadata_iterator_new();
	chain = FLAC__metadata_chain_new();
	FLAC__metadata_chain_read(chain, fname);
	FLAC__metadata_iterator_init(iterator, chain);
        break;
}
	} while(!found_vc_block && FLAC__metadata_iterator_next(iterator));





	//if(!found_vc_block) {
		/* create a new block if necessary */

			block = FLAC__metadata_object_new(FLAC__METADATA_TYPE_VORBIS_COMMENT);
			if(0 == block)
				return 0;
			while(FLAC__metadata_iterator_next(iterator))
				;
			if(!FLAC__metadata_iterator_insert_block_after(iterator, block)) {
				/*fprintf(stderr, "%s: ERROR: adding new VORBIS_COMMENT block to metadata, status =\"%s\"\n", filename,*/ //FLAC__Metadata_ChainStatusString[FLAC__metadata_chain_status(chain)];
				return false;
			}
			/* iterator is left pointing to new block */
			FLAC__ASSERT(FLAC__metadata_iterator_get_block(iterator) == block);


//	}

	FLAC__ASSERT(0 != block);
	FLAC__ASSERT(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT);


       string  = g_strconcat("TITLE=",gtk_entry_get_text((GtkEntry*)tag_track_entry));
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);

     /**********
     * Artist *
     **********/

      string  = g_strconcat("ARTIST=",gtk_entry_get_text((GtkEntry*)tag_artist_entry));
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);
    /*********
     * Album *
     *********/
      string  = g_strconcat("ALBUM=",gtk_entry_get_text((GtkEntry*)tag_album_entry));
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);

    /********
     * Year *
     ********/
      string  = g_strconcat("DATE=",gtk_entry_get_text((GtkEntry*)tag_year_entry));
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);
    /*********
     * Genre *
     *********/

      string  = g_strconcat("GENRE=",gtk_entry_get_text((GtkEntry*)tag_combo_entry));
       string1 = convert_to_utf8(string);
       set_vc_field(fname, block,string1 , &nw,1);
       g_free(string);
       g_free(string1);


        string = g_strconcat("COMMENT=",gtk_editable_get_chars ((GtkEditable*)text1,0,-1),NULL);
        string1 = convert_to_utf8(string);
        set_vc_field(fname, block,string1 , &nw,1);
        g_free(string);
        g_free(string1);

	FLAC__metadata_iterator_delete(iterator);
	ok = FLAC__metadata_chain_write(chain, 0,1);
	FLAC__metadata_chain_delete(chain);


return 1;

}



FLAC__bool remove_vc_all(FLAC__StreamMetadata *block, FLAC__bool *needs_write)
{
	FLAC__ASSERT(0 != block);
	FLAC__ASSERT(block->type == FLAC__METADATA_TYPE_VORBIS_COMMENT);
	FLAC__ASSERT(0 != needs_write);

	if(0 != block->data.vorbis_comment.comments) {
		FLAC__ASSERT(block->data.vorbis_comment.num_comments > 0);
		if(!FLAC__metadata_object_vorbiscomment_resize_comments(block, 0)) {
			return false;
		}
		*needs_write = true;
	}
	else {
		FLAC__ASSERT(block->data.vorbis_comment.num_comments == 0);
	}

	return true;
}


void
on_tag_help_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
if(hw)return;
strcpy(help,"Sonic-Rainbow Version 0.7.2.2\nCopyright Gary Baker\n");

strcat(help,"\nUse the Directorys list box to select the directory your\nfiles are in, then click on the files in the Files List box\none at a time. When a file is selected its Tag\ndetails will be displayed in the Album Title, Artist,\nTrack Title,Year, Genre and Comment emtry fields and\ndrop down box. Edit or modify the fields as you wish\nand then click on Save to save the changes before\nselecting another file. The dialog supports, Ogg, FLAC\nand MP3 tags.");

 hw=create_help_window();
 gtk_widget_show(hw);

}

