/*
Sonic Rainbow written by Gary Baker South Australia.
Copyright (C) 2003 Gary Baker

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern char *loaded_play_list;

void on_vfcombo_entry_changed                (GtkEditable     *editable,
                                        gpointer         user_data);

/************   CD Player ***************/
GtkWidget *hseparator2,*vseparator2=NULL;
GtkWidget *vseparator1=NULL;
GtkWidget *hseparator1=NULL;
GtkWidget *label4=NULL;
GtkWidget *main_window_listbutton=NULL;
GtkWidget *main_window_cd_entry=NULL;
GtkWidget *main_window_cdscrolled=NULL;
GtkWidget *main_window_cdlist=NULL;
GtkWidget *label20=NULL;
GtkWidget *main_window_playcd=NULL;
GtkWidget *main_window_stop_cd=NULL;
GtkWidget *main_window_cdprev=NULL;
GtkWidget *main_window_cd_pause=NULL;
GtkWidget *main_window_cd_resume=NULL;
GtkWidget *main_window_cd_next=NULL;
GtkWidget *main_window_cd_eject=NULL;
GtkWidget *main_window_cd_autoplay=NULL;
/************   CD Player ***************/


/************   Ogg Player ***************/
GtkWidget *pslide=NULL;
GtkObject *padj=NULL;
GtkWidget *label11=NULL;
GtkWidget *hseparator3=NULL;
GtkWidget *vseparator3=NULL;
GtkWidget *vseparator4=NULL;
GtkWidget *hseparator4=NULL;
GtkWidget *main_window_playogg=NULL;
GtkWidget *main_window_stopogg=NULL;
GtkWidget *main_window_prevogg=NULL;
GtkWidget *main_window_nextogg=NULL;
GtkWidget *main_window_pauseogg=NULL;
GtkWidget *main_window_resogg=NULL;
GtkWidget *main_window_browaeogg=NULL;
GtkWidget *main_window_sal=NULL;
GtkWidget *main_window_shuffle=NULL;
GtkWidget *main_window_blank=NULL;
GtkWidget *main_window_ogg_entry=NULL;
GtkWidget *main_window_listogg=NULL;
GtkWidget *main_window_delplaylist=NULL;
GtkWidget *main_window_loadplaylist=NULL;
GtkWidget *main_window_oggscrolled=NULL;
GtkWidget *main_window_oggclist=NULL;
GtkWidget *label12=NULL;
GtkWidget *label13=NULL;
GtkWidget *vbuttonbox1=NULL;
GtkWidget *vbutton2=NULL;
GtkWidget *vbutton3=NULL;
GtkWidget *vbutton4=NULL;
GtkWidget *vbutton5=NULL;
GtkWidget *vbutton6=NULL;
void p_change( GtkAdjustment *get, gpointer         user_data );
/************   Ogg Player ***************/

/************   DVD Player ***************/
GtkWidget *vp_play_file=NULL;
GtkWidget *vp_play_dvd=NULL;
GtkWidget *vp_pause=NULL;
GtkWidget *vp_stop=NULL;
GtkWidget *vp_play_vcd=NULL;
GtkWidget *vp_res=NULL;
GtkWidget *vp_rewind=NULL;
GtkWidget *vp_foward=NULL;
GtkWidget *hseparator5=NULL;
GtkWidget *vseparator6=NULL;
GtkWidget *vseparator5=NULL;
GtkWidget *hseparator6=NULL;
GtkWidget *label34=NULL;
GtkWidget *vp_combo=NULL;
GtkWidget *vf_combo=NULL;
GList *vp_combo_items = NULL;
GList *vf_combo_items = NULL;
GtkWidget *combo_entry1=NULL;
GtkWidget *vfcombo_entry=NULL;
GtkWidget *label35=NULL;
GtkWidget *conslide,*bslide=NULL;
GtkObject *cadj,*badj=NULL;
GtkWidget *contrast=NULL;
GtkWidget *brightness=NULL;
GtkWidget *aspect=NULL;
GtkWidget *edvd=NULL;
/************   DVD Player ***************/

/************   Radio Player ***************/
GtkWidget *bt1,*bt2,*bt3,*bt4,*bt5,*bt6,*bt7,*bt8,*bt9,*bt10,*radprog,*radplay,*radstop=NULL;
GtkWidget *vt1,*vt2,*vt3,*vt4,*rlab,*flabel,*freq_spin,*rec_radio,*ffw,*rew=NULL;
GtkWidget *radsave_window,*save_list,*save_spin,*save_entry=NULL;
GtkObject *freq_spin_adj;
extern char  blabels[11][7];
extern float frequencys[11];
extern GtkObject *sadj,*badj;
extern GtkWidget *sta;
extern GtkTooltips *tooltips;
/************   Radio Player ***************/



extern GtkWidget *main_fixed,*mwin;

void show_cdplayer();
void hide_cdplayer();
void show_oggplayer();
void hide_videoplayer();
void cont_change( GtkAdjustment *get, gpointer         user_data );
void bright_change( GtkAdjustment *get, gpointer         user_data );
void hide_radioplayer();
void show_radioplayer();
void reset_radio_button(int but);
void main_f( GtkAdjustment *get, gpointer         user_data );
void on_edvd_clicked         (GtkButton       *button, gpointer         user_data);
void on_ffw_clicked(GtkButton       *button, gpointer         user_data);
void on_rew_clicked(GtkButton       *button, gpointer         user_data);
void p_release(GtkWidget *widget,GdkEventButton  *event,gpointer user_data);
void p_press(GtkWidget *widget,GdkEventButton  *event,gpointer user_data);
void on_nb_clicked(GtkButton       *button, gpointer         user_data);

void xstuff()
{
  char nb[1000];

/*
  ffwrewtips = gtk_tooltips_new ();
*/
/*********************   CD PLAYER ********************/
  hseparator2 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator2", hseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator2, 16, 16);
  gtk_widget_set_uposition (hseparator2, 16, 16);
  gtk_widget_set_usize (hseparator2, 424, 16);


  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator2, 432, 24);
  gtk_widget_set_uposition (vseparator2, 432, 24);
  gtk_widget_set_usize (vseparator2, 16, 73);

  vseparator1 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator1", vseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator1, 8, 24);
  gtk_widget_set_uposition (vseparator1, 8, 24);
  gtk_widget_set_usize (vseparator1, 16, 73);

    hseparator1 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator1", hseparator1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator1, 16, 88);
  gtk_widget_set_uposition (hseparator1, 16, 88);
  gtk_widget_set_usize (hseparator1, 424, 16);

  label4 = gtk_label_new ("Cd Player");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), label4, 0, 8);
  gtk_widget_set_uposition (label4, 0, 8);
  gtk_widget_set_usize (label4, 84, 16);

    main_window_listbutton = gtk_button_new_with_label ("List");
  gtk_widget_ref (main_window_listbutton);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_listbutton", main_window_listbutton,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_listbutton, 384, 32);
  gtk_widget_set_uposition (main_window_listbutton, 384, 32);
  gtk_widget_set_usize (main_window_listbutton, 35, 22);
  gtk_tooltips_set_tip (tooltips, main_window_listbutton, "List Tracks On CD", NULL);

  main_window_cd_entry = gtk_entry_new ();
  gtk_widget_ref (main_window_cd_entry);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_entry", main_window_cd_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_entry, 24, 32);
  gtk_widget_set_uposition (main_window_cd_entry, 24, 32);
  gtk_widget_set_usize (main_window_cd_entry, 360, 24);
  gtk_entry_set_editable (GTK_ENTRY (main_window_cd_entry), FALSE);



  main_window_cdscrolled = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (main_window_cdscrolled);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cdscrolled", main_window_cdscrolled,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cdscrolled, 24, 56);
  gtk_widget_set_uposition (main_window_cdscrolled, 24, 56);
  gtk_widget_set_usize (main_window_cdscrolled, 384, 192);

  main_window_cdlist = gtk_clist_new (1);
  gtk_widget_ref (main_window_cdlist);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cdlist", main_window_cdlist,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (main_window_cdscrolled), main_window_cdlist);
  gtk_clist_set_column_width (GTK_CLIST (main_window_cdlist), 0, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (main_window_cdlist));

  label20 = gtk_label_new ("label20");
  gtk_widget_ref (label20);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label20", label20,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_clist_set_column_widget (GTK_CLIST (main_window_cdlist), 0, label20);


  main_window_playcd = gtk_button_new_with_label ("Play");
  gtk_widget_ref (main_window_playcd);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_playcd", main_window_playcd,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_playcd, 24, 64);
  gtk_widget_set_uposition (main_window_playcd, 24, 64);
  gtk_widget_set_usize (main_window_playcd, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_playcd, "Play CD", NULL);

  main_window_stop_cd = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (main_window_stop_cd);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_stop_cd", main_window_stop_cd,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_stop_cd, 72, 64);
  gtk_widget_set_uposition (main_window_stop_cd, 72, 64);
  gtk_widget_set_usize (main_window_stop_cd, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_stop_cd, "Stop CD Playing", NULL);

  main_window_cdprev = gtk_button_new_with_label ("Prev");
  gtk_widget_ref (main_window_cdprev);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cdprev", main_window_cdprev,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cdprev, 120, 64);
  gtk_widget_set_uposition (main_window_cdprev, 120, 64);
  gtk_widget_set_usize (main_window_cdprev, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_cdprev, "Previous Track", NULL);

  main_window_cd_pause = gtk_button_new_with_label ("Pause");
  gtk_widget_ref (main_window_cd_pause);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_pause", main_window_cd_pause,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_pause, 216, 64);
  gtk_widget_set_uposition (main_window_cd_pause, 216, 64);
  gtk_widget_set_usize (main_window_cd_pause, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_cd_pause, "Pause CD", NULL);

  main_window_cd_resume = gtk_button_new_with_label ("Res");
  gtk_widget_ref (main_window_cd_resume);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_resume", main_window_cd_resume,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_resume, 264, 64);
  gtk_widget_set_uposition (main_window_cd_resume, 264, 64);
  gtk_widget_set_usize (main_window_cd_resume, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_cd_resume, "Resume Playing CD", NULL);

  main_window_cd_next = gtk_button_new_with_label ("Next");
  gtk_widget_ref (main_window_cd_next);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_next", main_window_cd_next,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_next, 168, 64);
  gtk_widget_set_uposition (main_window_cd_next, 168, 64);
  gtk_widget_set_usize (main_window_cd_next, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_cd_next, "Next Track", NULL);

  main_window_cd_eject = gtk_button_new_with_label ("Eject");
  gtk_widget_ref (main_window_cd_eject);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_eject", main_window_cd_eject,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_eject, 312, 64);
  gtk_widget_set_uposition (main_window_cd_eject, 312, 64);
  gtk_widget_set_usize (main_window_cd_eject, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_cd_eject, "Eject CD", NULL);

  main_window_cd_autoplay = gtk_check_button_new_with_label ("AutoPlay");
  gtk_widget_ref (main_window_cd_autoplay);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_cd_autoplay", main_window_cd_autoplay,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_cd_autoplay, 360, 64);
  gtk_widget_set_uposition (main_window_cd_autoplay, 360, 64);
  gtk_widget_set_usize (main_window_cd_autoplay, 72, 24);
  gtk_tooltips_set_tip (tooltips, main_window_cd_autoplay, "Enable / Disable CD AutoPlay", NULL);

 gtk_signal_connect (GTK_OBJECT (main_window_cd_entry), "map",
                      GTK_SIGNAL_FUNC (on_main_window_cd_entry_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_cd_autoplay), "map",
                      GTK_SIGNAL_FUNC (on_main_window_cd_autoplay_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cd_autoplay), "toggled",
                      GTK_SIGNAL_FUNC (on_main_window_cd_autoplay_toggled),
                      NULL);


  gtk_signal_connect (GTK_OBJECT (main_window_cd_eject), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_cd_eject_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cd_next), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_cd_next_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cd_resume), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_cd_resume_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cd_pause), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_cd_pause_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdprev), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_cdprev_clicked),
                      NULL);
    gtk_signal_connect (GTK_OBJECT (main_window_stop_cd), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_stop_cd_clicked),
                      NULL);
    gtk_signal_connect (GTK_OBJECT (main_window_playcd), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_playcd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdscrolled), "map",
                      GTK_SIGNAL_FUNC (on_main_window_cdscrolled_map),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdlist), "unselect_row",
                      GTK_SIGNAL_FUNC (on_main_window_cdlist_unselect_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdlist), "select_row",
                      GTK_SIGNAL_FUNC (on_main_window_cdlist_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdlist), "map",
                      GTK_SIGNAL_FUNC (on_main_window_cdlist_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_cdlist), "map",
                      GTK_SIGNAL_FUNC (on_main_window_cdlist_map),
                      NULL);
   gtk_signal_connect (GTK_OBJECT (main_window_listbutton), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_listbutton_clicked),
                      NULL);

/****************************   CD PLAER ********************************/


/****************************   Ogg PLAER ********************************/
  padj=gtk_adjustment_new (0, 0, 100, 1, 0, 0);
  pslide= gtk_hscale_new (GTK_ADJUSTMENT (padj));
  gtk_widget_ref (pslide);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "pscale1", pslide,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), pslide, 216,120);
  gtk_widget_set_uposition (pslide,216,120);
  gtk_widget_set_usize (pslide,200,24);
  gtk_scale_set_draw_value (GTK_SCALE (pslide), FALSE);

  label11 = gtk_label_new ("Ogg, FLAC, WAV & MP3 Player");
  gtk_widget_ref (label11);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label11", label11,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), label11, 5, 8);
  gtk_widget_set_uposition (label11, 5, 8);
  gtk_widget_set_usize (label11, 205, 16);
  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator3, 16, 16);
  gtk_widget_set_uposition (hseparator3, 16, 16);
  gtk_widget_set_usize (hseparator3, 424, 16);

  vseparator3 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator3", vseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator3, 8, 24);
  gtk_widget_set_uposition (vseparator3, 8, 24);
  gtk_widget_set_usize (vseparator3, 16, 121);

  vseparator4 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator4", vseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator4, 432, 24);
  gtk_widget_set_uposition (vseparator4, 432, 24);
  gtk_widget_set_usize (vseparator4, 16, 121);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator4, 16, 120);
  gtk_widget_set_uposition (hseparator4, 16, 137);
  gtk_widget_set_usize (hseparator4, 424, 16);

  main_window_playogg = gtk_button_new_with_label ("Play");
  gtk_widget_ref (main_window_playogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_playogg", main_window_playogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_playogg, 24, 61);
  gtk_widget_set_uposition (main_window_playogg, 24, 61);
  gtk_widget_set_usize (main_window_playogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_playogg, "Play Tracks in List", NULL);

  main_window_stopogg = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (main_window_stopogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_stopogg", main_window_stopogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_stopogg, 72, 61);
  gtk_widget_set_uposition (main_window_stopogg, 72, 61);
  gtk_widget_set_usize (main_window_stopogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_stopogg, "Stop Playing", NULL);

  main_window_prevogg = gtk_button_new_with_label ("Prev");
  gtk_widget_ref (main_window_prevogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_prevogg", main_window_prevogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_prevogg, 120, 61);
  gtk_widget_set_uposition (main_window_prevogg, 120, 61);
  gtk_widget_set_usize (main_window_prevogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_prevogg, "Previous Track", NULL);

  main_window_nextogg = gtk_button_new_with_label ("Next");
  gtk_widget_ref (main_window_nextogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_nextogg", main_window_nextogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_nextogg, 168, 61);
  gtk_widget_set_uposition (main_window_nextogg, 168, 61);
  gtk_widget_set_usize (main_window_nextogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_nextogg, "Next Track", NULL);

  main_window_pauseogg = gtk_button_new_with_label ("Pause");
  gtk_widget_ref (main_window_pauseogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_pauseogg", main_window_pauseogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_pauseogg, 216, 61);
  gtk_widget_set_uposition (main_window_pauseogg, 216, 61);
  gtk_widget_set_usize (main_window_pauseogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_pauseogg, "Pause Playing Tracks", NULL);

  main_window_resogg = gtk_button_new_with_label ("Res");
  gtk_widget_ref (main_window_resogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_resogg", main_window_resogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_resogg, 264, 61);
  gtk_widget_set_uposition (main_window_resogg, 264, 61);
  gtk_widget_set_usize (main_window_resogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_resogg, "Resume Playing Tracks", NULL);

  rew = gtk_button_new_with_label ("ReW");
  gtk_widget_ref (rew);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "rew", rew,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), rew, 312, 61);
  gtk_widget_set_uposition (rew, 312, 61);
  gtk_widget_set_usize (rew, 40, 22);
gtk_tooltips_set_tip (tooltips, rew, "Rewind Playing Track", NULL);
/*
  gtk_tooltips_set_tip (ffwrewtips, rew, "Rewind Playing Track\nMP3 Unsupported", NULL);
*/
  ffw = gtk_button_new_with_label ("FfW");
  gtk_widget_ref (ffw);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "ffw", ffw,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), ffw, 360, 61);
  gtk_widget_set_uposition (ffw, 360, 61);
  gtk_widget_set_usize (ffw, 40, 22);
gtk_tooltips_set_tip (tooltips, ffw, "Fast FowardPlaying Track", NULL);
/*
  gtk_tooltips_set_tip (ffwrewtips, ffw, "Fast Foward Playing Track\nMP3 Unsupported", NULL);
*/

  main_window_browaeogg = gtk_button_new_with_label ("Load File/Dir");
  gtk_widget_ref (main_window_browaeogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_browaeogg", main_window_browaeogg,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_browaeogg, 24, 90);
  gtk_widget_set_uposition (main_window_browaeogg, 24, 90);
  gtk_widget_set_usize (main_window_browaeogg, 89, 22);
  gtk_tooltips_set_tip (tooltips, main_window_browaeogg, "Load Files Or Directory Of Files For Playing", NULL);


  main_window_ogg_entry = gtk_entry_new ();
  gtk_widget_ref (main_window_ogg_entry);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_ogg_entry", main_window_ogg_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_ogg_entry, 24, 32);
  gtk_widget_set_uposition (main_window_ogg_entry, 24, 32);
  gtk_widget_set_usize (main_window_ogg_entry, 360, 24);

  main_window_listogg = gtk_button_new_with_label ("List");
  gtk_widget_ref (main_window_listogg);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_listogg", main_window_listogg,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_listogg, 384, 32);
  gtk_widget_set_uposition (main_window_listogg, 384, 32);
  gtk_widget_set_usize (main_window_listogg, 40, 22);
  gtk_tooltips_set_tip (tooltips, main_window_listogg, "List Tracks Currently Loaded", NULL);


  main_window_delplaylist = gtk_button_new_with_label ("Del Playlist");
  gtk_widget_ref (main_window_delplaylist);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_delplaylist", main_window_delplaylist,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_delplaylist, 312, 90);
  gtk_widget_set_uposition (main_window_delplaylist, 312, 90);
  gtk_widget_set_usize (main_window_delplaylist, 89, 22);
  gtk_tooltips_set_tip (tooltips, main_window_delplaylist, "Delete A Playlist File", NULL);


  main_window_loadplaylist = gtk_button_new_with_label ("Load Playlist");
  gtk_widget_ref (main_window_loadplaylist);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_loadplaylist", main_window_loadplaylist,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_loadplaylist, 120, 90);
  gtk_widget_set_uposition (main_window_loadplaylist, 120, 90);
  gtk_widget_set_usize (main_window_loadplaylist, 89, 22);
  gtk_tooltips_set_tip (tooltips, main_window_loadplaylist, "Load a Playlist File for Playing", NULL);



  main_window_sal = gtk_button_new_with_label ("Save Playlist");
  gtk_widget_ref (main_window_sal);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_sal", main_window_sal,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_tooltips_set_tip (tooltips,main_window_sal, "Save Current Tracks as Playlist", NULL);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_sal, 216, 90);
  gtk_widget_set_uposition (main_window_sal, 216, 90);
  gtk_widget_set_usize (main_window_sal, 89, 22);

  main_window_shuffle = gtk_button_new_with_label ("Shuffle");
  gtk_widget_ref (main_window_shuffle);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "shuffle", main_window_shuffle,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_shuffle, 120, 119);
  /*gtk_fixed_put (GTK_FIXED (main_fixed), main_window_shuffle, 24, 119);*/
  gtk_widget_set_uposition (main_window_shuffle, 120, 119);
  gtk_widget_set_usize (main_window_shuffle, 89, 22);
  gtk_tooltips_set_tip (tooltips,main_window_shuffle, "Shuffle Playlist Tracks", NULL);



  main_window_blank = gtk_button_new_with_label ("Clear List");
  gtk_widget_ref (main_window_blank);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "Blank", main_window_blank,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_tooltips_set_tip (tooltips,main_window_blank, "Creates Empty Playlist", NULL);
  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_blank, 24, 119);
 /* gtk_fixed_put (GTK_FIXED (main_fixed), main_window_blank, 312, 90);*/
  gtk_widget_set_uposition (main_window_blank, 24, 119);
  gtk_widget_set_usize (main_window_blank, 89, 22);


  main_window_oggscrolled = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (main_window_oggscrolled);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "scrolledwindow2", main_window_oggscrolled,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), main_window_oggscrolled, 24, 53);
  gtk_widget_set_uposition (main_window_oggscrolled, 24, 53);
  gtk_widget_set_usize (main_window_oggscrolled, 384, 192);

  main_window_oggclist = gtk_clist_new (2);
  gtk_widget_ref (main_window_oggclist);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "main_window_oggclist", main_window_oggclist,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_container_add (GTK_CONTAINER (main_window_oggscrolled), main_window_oggclist);
  gtk_clist_set_column_width (GTK_CLIST (main_window_oggclist), 0, 228);
  gtk_clist_set_column_width (GTK_CLIST (main_window_oggclist), 1, 80);
  gtk_clist_column_titles_show (GTK_CLIST (main_window_oggclist));

  label12 = gtk_label_new ("Title");
  gtk_widget_ref (label12);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label12", label12,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_clist_set_column_widget (GTK_CLIST (main_window_oggclist), 0, label12);

  label13 = gtk_label_new ("Artist");
  gtk_widget_ref (label13);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label13", label13,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_clist_set_column_widget (GTK_CLIST (main_window_oggclist), 1, label13);

gtk_clist_set_button_actions(GTK_CLIST (main_window_oggclist),2,GTK_BUTTON_SELECTS);




  vbuttonbox1 = gtk_vbutton_box_new ();
  gtk_widget_ref (vbuttonbox1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbuttonbox1", vbuttonbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vbuttonbox1, 407, 70);
  gtk_widget_set_uposition (vbuttonbox1, 407, 70);
  gtk_widget_set_usize (vbuttonbox1, 42, 170);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (vbuttonbox1), GTK_BUTTONBOX_SPREAD);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (vbuttonbox1), 42, 0);
  gtk_button_box_set_child_ipadding (GTK_BUTTON_BOX (vbuttonbox1), 0, 0);

  vbutton2 = gtk_button_new_with_label ("Add");
  gtk_widget_ref (vbutton2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbutton2", vbutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), vbutton2);
  gtk_widget_set_usize (vbutton2, 42, 32);
  GTK_WIDGET_SET_FLAGS (vbutton2, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips,vbutton2, "Add Files", NULL);



  vbutton3 = gtk_button_new_with_label ("Del");
  gtk_widget_ref (vbutton3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbutton3", vbutton3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), vbutton3);
  gtk_widget_set_usize (vbutton3, 42, 32);
  GTK_WIDGET_SET_FLAGS (vbutton3, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips,vbutton3, "Select Titles with Right Click ", NULL);

  vbutton4 = gtk_button_new_with_label ("Up");
  gtk_widget_ref (vbutton4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbutton4", vbutton4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), vbutton4);
  gtk_widget_set_usize (vbutton4, 42, 32);
  GTK_WIDGET_SET_FLAGS (vbutton4, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips,vbutton4, "Select Titles with Right Click ", NULL);

  vbutton5 = gtk_button_new_with_label ("Dwn");
  gtk_widget_ref (vbutton5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbutton5", vbutton5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), vbutton5);
  gtk_widget_set_usize (vbutton5, 42, 32);
  GTK_WIDGET_SET_FLAGS (vbutton5, GTK_CAN_DEFAULT);
  gtk_tooltips_set_tip (tooltips,vbutton5, "Select Titles with Right Click ", NULL);

vbutton6 = gtk_button_new_with_label ("Help");
  gtk_widget_ref (vbutton6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vbutton6", vbutton6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_container_add (GTK_CONTAINER (vbuttonbox1), vbutton6);
  gtk_widget_set_usize (vbutton6, 42, 32);
  GTK_WIDGET_SET_FLAGS (vbutton6, GTK_CAN_DEFAULT);

gtk_signal_connect (GTK_OBJECT (vbutton6), "clicked",
                      GTK_SIGNAL_FUNC (on_button6_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (vbutton2), "clicked",
                      GTK_SIGNAL_FUNC (on_button2_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (vbutton3), "clicked",
                      GTK_SIGNAL_FUNC (on_button3_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (vbutton4), "clicked",
                      GTK_SIGNAL_FUNC (on_button4_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (vbutton5), "clicked",
                      GTK_SIGNAL_FUNC (on_button5_clicked),
                      NULL);




  gtk_signal_connect (GTK_OBJECT (main_window_playogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_playogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_playogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_playogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_stopogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_stopogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_stopogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_stopogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_prevogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_prevogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_prevogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_prevogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_nextogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_nextogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_nextogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_nextogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_pauseogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_pauseogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_pauseogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_pauseogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_resogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_resogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_resogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_resogg_realize),
                      NULL);

 gtk_signal_connect (GTK_OBJECT (ffw), "pressed",
                      GTK_SIGNAL_FUNC (on_ffw_clicked),
                      NULL);
 gtk_signal_connect (GTK_OBJECT (ffw), "released",
                      GTK_SIGNAL_FUNC (on_ffw_clicked),
                      NULL);

 gtk_signal_connect (GTK_OBJECT (rew), "pressed",
                      GTK_SIGNAL_FUNC (on_rew_clicked),
                      NULL);
 gtk_signal_connect (GTK_OBJECT (rew), "released",
                      GTK_SIGNAL_FUNC (on_rew_clicked),
                      NULL);



  gtk_signal_connect (GTK_OBJECT (main_window_browaeogg), "clicked",
                      GTK_SIGNAL_FUNC (on_button2_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_browaeogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_browaeogg_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_ogg_entry), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_ogg_entry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_listogg), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_listogg_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_listogg), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_listogg_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_delplaylist), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_delplaylist_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_delplaylist), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_delplaylist_realize),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_loadplaylist), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_loadplaylist_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_sal), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_sal_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_shuffle), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_shuffle_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_blank), "clicked",
                      GTK_SIGNAL_FUNC (on_main_window_blank_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (main_window_oggscrolled), "map",
                      GTK_SIGNAL_FUNC (on_scrolledwindow2_map),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_oggscrolled), "realize",
                      GTK_SIGNAL_FUNC (on_scrolledwindow2_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_oggclist), "select_row",
                      GTK_SIGNAL_FUNC (on_main_window_oggclist_select_row),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_oggclist), "realize",
                      GTK_SIGNAL_FUNC (on_main_window_oggclist_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (main_window_oggclist), "map",
                      GTK_SIGNAL_FUNC (on_main_window_oggclist_map),
                      NULL);
gtk_signal_connect (GTK_OBJECT (padj), "value_changed",
                        GTK_SIGNAL_FUNC (p_change), NULL);
//gtk_signal_connect (GTK_OBJECT (padj), "changed",
  //                      GTK_SIGNAL_FUNC (p_change), NULL);

 gtk_signal_connect (GTK_OBJECT (pslide), "button_release_event",
                      GTK_SIGNAL_FUNC (p_release),
                      NULL);
gtk_signal_connect (GTK_OBJECT (pslide), "button_press_event",
                      GTK_SIGNAL_FUNC (p_press),
                      NULL);

gtk_tooltips_set_delay ((GtkTooltips*)tooltips,0);
/****************************   Ogg PLAER ********************************/


/****************************   DVD PLAER ********************************/
  vp_play_file = gtk_button_new_with_label ("Play File");
  gtk_widget_ref (vp_play_file);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_play_file", vp_play_file,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_play_file, 24, 32);
  gtk_widget_set_uposition (vp_play_file, 24, 32);
  gtk_widget_set_usize (vp_play_file, 65, 22);

  vp_play_dvd = gtk_button_new_with_label ("Play DVD");
  gtk_widget_ref (vp_play_dvd);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_play_dvd", vp_play_dvd,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_play_dvd, 104, 32);
  gtk_widget_set_uposition (vp_play_dvd, 104, 32);
  gtk_widget_set_usize (vp_play_dvd, 65, 22);

  vp_pause = gtk_button_new_with_label ("Pause");
  gtk_widget_ref (vp_pause);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_pause", vp_pause,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_pause, 320, 32);
  gtk_widget_set_uposition (vp_pause, 320, 32);
  gtk_widget_set_usize (vp_pause, 40, 22);

  vp_stop = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (vp_stop);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_stop", vp_stop,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_stop, 264, 32);
  gtk_widget_set_uposition (vp_stop, 264, 32);
  gtk_widget_set_usize (vp_stop, 40, 22);

  vp_play_vcd = gtk_button_new_with_label ("Play VCD");
  gtk_widget_ref (vp_play_vcd);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_play_vcd", vp_play_vcd,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_play_vcd, 184, 32);
  gtk_widget_set_uposition (vp_play_vcd, 184, 32);
  gtk_widget_set_usize (vp_play_vcd, 65, 22);

  vp_res = gtk_button_new_with_label ("Res");
  gtk_widget_ref (vp_res);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_res", vp_res,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_res, 376, 32);
  gtk_widget_set_uposition (vp_res, 376, 32);
  gtk_widget_set_usize (vp_res, 40, 22);

  vp_rewind = gtk_button_new_with_label ("Slow");
  gtk_widget_ref (vp_rewind);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_rewind", vp_rewind,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_rewind, 24, 64);
  gtk_widget_set_uposition (vp_rewind, 24, 64);
  gtk_widget_set_usize (vp_rewind, 47, 22);

  vp_foward = gtk_button_new_with_label ("Fast");
  gtk_widget_ref (vp_foward);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_foward", vp_foward,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vp_foward, 88, 64);
  gtk_widget_set_uposition (vp_foward, 88, 64);
  gtk_widget_set_usize (vp_foward, 40, 22);

 edvd = gtk_button_new_with_label ("Eject");
  gtk_widget_ref (edvd);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "edvd",edvd,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), edvd, 152, 64);
  gtk_widget_set_uposition (edvd, 152, 64);
  gtk_widget_set_usize (edvd, 40, 22);


    hseparator5 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator5", hseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator5, 16, 16);
  gtk_widget_set_uposition (hseparator5, 16, 16);
  gtk_widget_set_usize (hseparator5, 424, 16);

  vseparator6 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator6", vseparator6,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator6, 432, 24);
  gtk_widget_set_uposition (vseparator6, 432, 24);
  gtk_widget_set_usize (vseparator6, 16, 104);

  vseparator5 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator5", vseparator5,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vseparator5, 8, 24);
  gtk_widget_set_uposition (vseparator5, 8, 24);
  gtk_widget_set_usize (vseparator5, 16, 104);

  hseparator6 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator6", hseparator6,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), hseparator6, 16, 120);
  gtk_widget_set_uposition (hseparator6, 16, 120);
  gtk_widget_set_usize (hseparator6, 424, 16);

  label34 = gtk_label_new ("Video Player");
  gtk_widget_ref (label34);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label34", label34,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), label34, 0, 8);
  gtk_widget_set_uposition (label34, 0, 8);
  gtk_widget_set_usize (label34, 104, 16);

  vp_combo = gtk_combo_new ();
  gtk_widget_ref (vp_combo);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vp_combo", vp_combo,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vp_combo, 349, 105);
  gtk_widget_set_uposition (vp_combo, 349, 105);
  gtk_widget_set_usize (vp_combo, 90, 22);
  vp_combo_items = g_list_append (vp_combo_items, (gpointer) "320 x 240");
  vp_combo_items = g_list_append (vp_combo_items, (gpointer) "640 x 480");
  vp_combo_items = g_list_append (vp_combo_items, (gpointer) "1024 x 768");
  vp_combo_items = g_list_append (vp_combo_items, (gpointer) "Full Screen");
  gtk_combo_set_popdown_strings (GTK_COMBO (vp_combo), vp_combo_items);
  g_list_free (vp_combo_items);

  combo_entry1 = GTK_COMBO (vp_combo)->entry;
  gtk_widget_ref (combo_entry1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "combo_entry1", combo_entry1,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_entry_set_text (GTK_ENTRY (combo_entry1), "320 x 240");

  label35 = gtk_label_new ("Video Window");
  gtk_widget_ref (label35);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label35", label35,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), label35, 346, 90);
  gtk_widget_set_uposition (label35, 346, 90);
  gtk_widget_set_usize (label35, 84,16);




  vf_combo = gtk_combo_new ();
  gtk_widget_ref (vf_combo);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vf_combo", vf_combo,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vf_combo, 250, 105);
  gtk_widget_set_uposition (vf_combo, 250, 105);
  gtk_widget_set_usize (vf_combo, 90, 22);
  vf_combo_items = g_list_append (vf_combo_items, (gpointer) "1:1");
  vf_combo_items = g_list_append (vf_combo_items, (gpointer) "4:3");
  vf_combo_items = g_list_append (vf_combo_items, (gpointer) "16:9");
  vf_combo_items = g_list_append (vf_combo_items, (gpointer) "2.11:1");
  gtk_combo_set_popdown_strings (GTK_COMBO (vf_combo), vf_combo_items);
  g_list_free (vf_combo_items);

  vfcombo_entry = GTK_COMBO (vf_combo)->entry;
  gtk_widget_ref (vfcombo_entry);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vfcombo_entry", vfcombo_entry,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_entry_set_text (GTK_ENTRY (vfcombo_entry), "16:9");



  cadj=gtk_adjustment_new (33, 0, 66, 1, 0, 0);
  conslide= gtk_hscale_new (GTK_ADJUSTMENT (cadj));
  gtk_widget_ref (conslide);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", conslide,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), conslide, 24,105);
  gtk_widget_set_uposition (conslide,24,105);
  gtk_widget_set_usize (conslide,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (conslide), FALSE);

  contrast = gtk_label_new ("Contrast");
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "contrast",contrast,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), contrast,6, 90);
  gtk_widget_set_uposition (contrast,6, 90);
  gtk_widget_set_usize (contrast, 84, 16);

  aspect = gtk_label_new ("Video Aspect");
  gtk_widget_ref (aspect);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "aspect",aspect,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), aspect,245, 90);
  gtk_widget_set_uposition (aspect,245, 90);
  gtk_widget_set_usize (aspect, 84, 16);


  gtk_signal_connect (GTK_OBJECT (cadj), "value_changed",
                        GTK_SIGNAL_FUNC (cont_change), NULL);




  badj=gtk_adjustment_new (33, 0, 66, 1, 0, 0);
  bslide= gtk_hscale_new (GTK_ADJUSTMENT (badj));
  gtk_widget_ref (bslide);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", bslide,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bslide, 142,105);
  gtk_widget_set_uposition (bslide,142,105);
  gtk_widget_set_usize (bslide,100,24);
  gtk_scale_set_draw_value (GTK_SCALE (bslide), FALSE);


  brightness = gtk_label_new ("Brightness");
  gtk_widget_ref (brightness);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "Brightness",brightness,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), brightness,132, 90);
  gtk_widget_set_uposition (brightness,132, 90);
  gtk_widget_set_usize (brightness, 84, 16);


  gtk_signal_connect (GTK_OBJECT (badj), "value_changed",
                        GTK_SIGNAL_FUNC (bright_change), NULL);


  gtk_signal_connect (GTK_OBJECT (edvd), "clicked",
                      GTK_SIGNAL_FUNC (on_edvd_clicked),
                      NULL);


  gtk_signal_connect (GTK_OBJECT (vp_play_file), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_play_file_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_play_dvd), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_play_dvd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_pause), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_pause_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_stop), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_stop_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_play_vcd), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_play_vcd_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_res), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_res_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_rewind), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_rewind_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_foward), "clicked",
                      GTK_SIGNAL_FUNC (on_vp_foward_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vp_combo), "realize",
                      GTK_SIGNAL_FUNC (on_vp_combo_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (combo_entry1), "changed",
                      GTK_SIGNAL_FUNC (on_combo_entry1_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (combo_entry1), "realize",
                      GTK_SIGNAL_FUNC (on_combo_entry1_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (vfcombo_entry), "changed",
                      GTK_SIGNAL_FUNC (on_vfcombo_entry_changed),
                      NULL);

/****************************   DVD PLAER ********************************/

/****************************   Radio PLAER ********************************/
  bt1 = gtk_button_new_with_label (blabels[0]);
  gtk_widget_ref (bt1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_1", bt1,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed),bt1, 120,32);
  gtk_widget_set_uposition (bt1, 120, 32);
  gtk_widget_set_usize (bt1, 54, 22);


  bt2 = gtk_button_new_with_label (blabels[1]);
  gtk_widget_ref (bt2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_2", bt2,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt2, 184, 32);
  gtk_widget_set_uposition (bt2, 184, 32);
  gtk_widget_set_usize (bt2, 54, 22);


  bt3 = gtk_button_new_with_label (blabels[2]);
  gtk_widget_ref (bt3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_3", bt3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt3, 248, 32);
  gtk_widget_set_uposition (bt3, 248, 32);
  gtk_widget_set_usize (bt3, 54, 22);


  bt4 = gtk_button_new_with_label (blabels[3]);
  gtk_widget_ref (bt4);

  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_4", bt4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt4, 312, 32);
  gtk_widget_set_uposition (bt4, 312, 32);
  gtk_widget_set_usize (bt4, 54, 22);


  bt5 = gtk_button_new_with_label (blabels[4]);
  gtk_widget_ref (bt5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_5", bt5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt5, 376, 32);
  gtk_widget_set_uposition (bt5, 376, 32);
  gtk_widget_set_usize (bt5, 54, 22);

  bt6 = gtk_button_new_with_label (blabels[5]);
  gtk_widget_ref (bt6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_6", bt6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt6, 120,64);
  gtk_widget_set_uposition (bt6, 120, 64);
  gtk_widget_set_usize (bt6, 54, 22);

  bt7 = gtk_button_new_with_label (blabels[6]);
  gtk_widget_ref (bt7);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_7", bt7,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt7, 184,64);
  gtk_widget_set_uposition (bt7, 184, 64);
  gtk_widget_set_usize (bt7, 54, 22);


  bt8 = gtk_button_new_with_label (blabels[7]);
  gtk_widget_ref (bt8);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_8", bt8,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt8, 248, 64);
  gtk_widget_set_uposition (bt8, 248,64);
  gtk_widget_set_usize (bt8, 54, 22);


  bt9 = gtk_button_new_with_label (blabels[8]);
  gtk_widget_ref (bt9);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "statio_9", bt9,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt9, 312,64);
  gtk_widget_set_uposition (bt9, 312,64);
  gtk_widget_set_usize (bt9, 54, 22);


  bt10 = gtk_button_new_with_label (blabels[9]);
  gtk_widget_ref (bt10);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_10", bt10,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), bt10, 376,64);
  gtk_widget_set_uposition (bt10, 376,64);
  gtk_widget_set_usize (bt10, 54, 22);


    gtk_signal_connect (GTK_OBJECT (bt1), "clicked",
                      GTK_SIGNAL_FUNC (on_station_1_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt2), "clicked",
                      GTK_SIGNAL_FUNC (on_station_2_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt3), "clicked",
                      GTK_SIGNAL_FUNC (on_station_3_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt4), "clicked",
                      GTK_SIGNAL_FUNC (on_station_4_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt5), "clicked",
                      GTK_SIGNAL_FUNC (on_station_5_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt6), "clicked",
                      GTK_SIGNAL_FUNC (on_station_6_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt7), "clicked",
                      GTK_SIGNAL_FUNC (on_station_7_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt8), "clicked",
                      GTK_SIGNAL_FUNC (on_station_8_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt9), "clicked",
                      GTK_SIGNAL_FUNC (on_statio_9_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (bt10), "clicked",
                      GTK_SIGNAL_FUNC (on_station_10_clicked),
                      NULL);

  radplay = gtk_button_new_with_label ("Play");
  gtk_widget_ref (radplay);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "play_radio", radplay,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radplay, 24, 32);
  gtk_widget_set_uposition (radplay, 24, 32);
  gtk_widget_set_usize (radplay, 54, 22);

  radstop = gtk_button_new_with_label ("Stop");
  gtk_widget_ref (radstop);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "stop_radio", radstop,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radstop, 24, 64);
  gtk_widget_set_uposition (radstop, 24, 64);
  gtk_widget_set_usize (radstop, 54, 22);

  rec_radio = gtk_button_new_with_label ("R\nE\nC");
  gtk_widget_ref (rec_radio);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "rec_radio", rec_radio,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), rec_radio, 82, 32);
  gtk_widget_set_uposition (rec_radio, 82, 32);
  gtk_widget_set_usize (rec_radio, 34, 54);


  radprog = gtk_button_new_with_label ("Save");
  gtk_widget_ref (radprog);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "radio_program", radprog,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), radprog, 312, 96);
  gtk_widget_set_uposition (radprog, 312, 96);
  gtk_widget_set_usize (radprog, 54, 22);


  vt1 = gtk_vseparator_new ();
  gtk_widget_ref (vt1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator6", vt1,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vt1,432,24);
  gtk_widget_set_uposition (vt1, 432,24);
  gtk_widget_set_usize (vt1,16,103);

  vt2 = gtk_hseparator_new ();
  gtk_widget_ref (vt2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator6", vt2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vt2, 16,16);
  gtk_widget_set_uposition (vt2, 16,16);
  gtk_widget_set_usize (vt2, 424, 16);


  vt3 = gtk_vseparator_new ();
  gtk_widget_ref (vt3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vseparator5", vt3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), vt3, 8,24);
  gtk_widget_set_uposition (vt3, 8,24);
  gtk_widget_set_usize (vt3, 16,103);


  vt4 = gtk_hseparator_new ();
  gtk_widget_ref (vt4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "hseparator5", vt4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), vt4, 16,120);
  gtk_widget_set_uposition (vt4, 16,120);
  gtk_widget_set_usize (vt4, 424, 16);


  rlab = gtk_label_new ("FM Radio Player");
  gtk_widget_ref (rlab);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "label26", rlab,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), rlab, 8,8);
  gtk_widget_set_uposition (rlab, 8,8);
  gtk_widget_set_usize (rlab, 112, 16);
  freq_spin_adj = gtk_adjustment_new (frequencys[10],87.9,107.9, 0.1, 10, 10);
  freq_spin = gtk_spin_button_new (GTK_ADJUSTMENT (freq_spin_adj), 1, 1);
  gtk_widget_ref (freq_spin);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "freq_spin", freq_spin,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), freq_spin, 376,96);
  gtk_widget_set_uposition (freq_spin, 376, 96);
  gtk_widget_set_usize (freq_spin, 56, 24);
  gtk_spin_button_set_numeric (GTK_SPIN_BUTTON (freq_spin), TRUE);
  flabel = gtk_label_new ("Station");
  gtk_widget_ref (flabel);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_lable", flabel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed), flabel, 16, 96);
  gtk_widget_set_uposition (flabel, 16, 96);
  gtk_widget_set_usize (flabel, 48, 24);


 gtk_signal_connect (GTK_OBJECT (radplay), "clicked",
                      GTK_SIGNAL_FUNC (on_play_radio_clicked),
                      NULL);

gtk_signal_connect (GTK_OBJECT (rec_radio), "clicked",
                      GTK_SIGNAL_FUNC (on_rec_radio_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (radstop), "clicked",
                      GTK_SIGNAL_FUNC (on_stop_radio_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (radprog), "clicked",
                      GTK_SIGNAL_FUNC (on_radio_program_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (freq_spin), "changed",
                      GTK_SIGNAL_FUNC (on_freq_spin_changed),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (freq_spin),"realize",
                      GTK_SIGNAL_FUNC (on_freq_spin_realize),
                      NULL);

  sadj=gtk_adjustment_new (frequencys[10]*10,879, 1079, 1, 0, 0);
  sta= gtk_hscale_new (GTK_ADJUSTMENT (sadj));
  gtk_widget_ref (sta);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "vscale1", sta,
                            (GtkDestroyNotify) gtk_widget_unref);
 /* gtk_widget_show (sta);*/
  gtk_fixed_put (GTK_FIXED (main_fixed), sta, 63,96);
  gtk_widget_set_uposition (sta,63,96);
  gtk_widget_set_usize (sta,250,22);
  gtk_scale_set_draw_value (GTK_SCALE (sta), FALSE);


  gtk_signal_connect (GTK_OBJECT (sadj), "value_changed",
                        GTK_SIGNAL_FUNC (main_f), NULL);

sprintf(nb,"%-2.1f",frequencys[10]);
gtk_tooltips_set_tip((GtkTooltips*)tooltips,sta,nb,NULL);
gtk_tooltips_set_delay ((GtkTooltips*)tooltips,0);
/****************************   Radio PLAER ********************************/
}



void show_videoplayer()
{
gtk_widget_show (vp_play_file);
gtk_widget_show (vp_play_dvd);
gtk_widget_show (vp_pause);
gtk_widget_show (vp_stop);
gtk_widget_show (vp_play_vcd);
gtk_widget_show (vp_res);
gtk_widget_show (vp_rewind);
gtk_widget_show (vp_foward);
gtk_widget_show (hseparator5);
gtk_widget_show (vseparator6);
gtk_widget_show (vseparator5);
gtk_widget_show (hseparator6);
gtk_widget_show (label34);
gtk_widget_show (vp_combo);
gtk_widget_show (combo_entry1);
gtk_widget_show (label35);
gtk_widget_show (conslide);
gtk_widget_show(contrast);
gtk_widget_show(brightness);
gtk_widget_show (bslide);
gtk_widget_show(vf_combo);
gtk_widget_show(aspect);
gtk_widget_show(edvd);
}

void hide_videoplayer()
{
gtk_widget_hide (vp_play_file);
gtk_widget_hide (vp_play_dvd);
gtk_widget_hide (vp_pause);
gtk_widget_hide (vp_stop);
gtk_widget_hide (vp_play_vcd);
gtk_widget_hide (vp_res);
gtk_widget_hide (vp_rewind);
gtk_widget_hide (vp_foward);
gtk_widget_hide (hseparator5);
gtk_widget_hide (vseparator6);
gtk_widget_hide (vseparator5);
gtk_widget_hide (hseparator6);
gtk_widget_hide (label34);
gtk_widget_hide (vp_combo);
gtk_widget_hide (combo_entry1);
gtk_widget_hide (label35);
gtk_widget_hide (conslide);
gtk_widget_hide(contrast);
gtk_widget_hide(brightness);
gtk_widget_hide (bslide);
gtk_widget_hide(vf_combo);
gtk_widget_hide(aspect);
gtk_widget_hide(edvd);
}

void show_oggplayer()
{
gtk_widget_show (label11);
gtk_widget_show (hseparator3);
gtk_widget_show (vseparator3);
gtk_widget_show (vseparator4);
gtk_widget_show (hseparator4);
gtk_widget_show (main_window_playogg);
gtk_widget_show (main_window_stopogg);
gtk_widget_show (main_window_prevogg);
gtk_widget_show (main_window_nextogg);
gtk_widget_show (main_window_pauseogg);
gtk_widget_show (main_window_resogg);
gtk_widget_show (main_window_browaeogg);
gtk_widget_show (main_window_sal);
gtk_widget_show (main_window_shuffle);
gtk_widget_show (main_window_blank);
gtk_widget_show (main_window_ogg_entry);
gtk_widget_show (main_window_listogg);
/*gtk_widget_show (main_window_newplaylist);*/
gtk_widget_show (main_window_delplaylist);
/*gtk_widget_show (main_window_modplaylist);*/
gtk_widget_show (main_window_loadplaylist);
gtk_widget_show(rew);
gtk_widget_show(ffw);
gtk_widget_show(pslide);
}


void hide_oggplayer()
{
gtk_widget_hide (label11);
gtk_widget_hide (hseparator3);
gtk_widget_hide (vseparator3);
gtk_widget_hide (vseparator4);
gtk_widget_hide (hseparator4);
gtk_widget_hide (main_window_playogg);
gtk_widget_hide (main_window_stopogg);
gtk_widget_hide (main_window_prevogg);
gtk_widget_hide (main_window_nextogg);
gtk_widget_hide (main_window_pauseogg);
gtk_widget_hide (main_window_resogg);
gtk_widget_hide (main_window_browaeogg);
gtk_widget_hide (main_window_sal);
gtk_widget_hide (main_window_shuffle);
gtk_widget_hide (main_window_blank);
gtk_widget_hide (main_window_ogg_entry);
gtk_widget_hide (main_window_listogg);
/*gtk_widget_hide (main_window_newplaylist);*/
gtk_widget_hide (main_window_delplaylist);
/*gtk_widget_hide (main_window_modplaylist);*/
gtk_widget_hide (main_window_loadplaylist);
gtk_widget_hide(rew);
gtk_widget_hide(ffw);
gtk_widget_hide(pslide);
}




void show_cdplayer()
{
gtk_widget_show(hseparator2);
gtk_widget_show(vseparator2);
gtk_widget_show(hseparator1);
gtk_widget_show(vseparator1);
gtk_widget_show(label4);
gtk_widget_show (main_window_listbutton);
gtk_widget_show (main_window_cd_entry);
gtk_widget_show (label20);
gtk_widget_show (main_window_playcd);
gtk_widget_show (main_window_stop_cd);
gtk_widget_show (main_window_cdprev);
gtk_widget_show (main_window_cd_pause);
gtk_widget_show (main_window_cd_resume);
gtk_widget_show (main_window_cd_next);
gtk_widget_show (main_window_cd_eject);
gtk_widget_show (main_window_cd_autoplay);
gtk_widget_show (label4);
}

void hide_cdplayer()
{
gtk_widget_hide(hseparator2);
gtk_widget_hide(vseparator2);
gtk_widget_hide(hseparator1);
gtk_widget_hide(vseparator1);
gtk_widget_hide(label4);
gtk_widget_hide (main_window_listbutton);
gtk_widget_hide (main_window_cd_entry);
gtk_widget_hide (main_window_cdscrolled);
gtk_widget_hide (main_window_cdlist);
gtk_widget_hide (label20);
gtk_widget_hide (main_window_playcd);
gtk_widget_hide (main_window_stop_cd);
gtk_widget_hide (main_window_cdprev);
gtk_widget_hide (main_window_cd_pause);
gtk_widget_hide (main_window_cd_resume);
gtk_widget_hide (main_window_cd_next);
gtk_widget_hide (main_window_cd_eject);
gtk_widget_hide (main_window_cd_autoplay);
gtk_widget_hide (label4);
}

void hide_radioplayer()
{
gtk_widget_hide(bt1);
gtk_widget_hide(bt2);
gtk_widget_hide(bt3);
gtk_widget_hide(bt4);
gtk_widget_hide(bt5);
gtk_widget_hide(bt6);
gtk_widget_hide(bt7);
gtk_widget_hide(bt8);
gtk_widget_hide(bt9);
gtk_widget_hide(bt10);
gtk_widget_hide(radprog);
gtk_widget_hide(radplay);
gtk_widget_hide(radstop);
gtk_widget_hide(vt1);
gtk_widget_hide(vt2);
gtk_widget_hide(vt3);
gtk_widget_hide(vt4);
gtk_widget_hide(rlab);
gtk_widget_hide(flabel);
gtk_widget_hide(freq_spin);
gtk_widget_hide(sta);
gtk_widget_hide(rec_radio);
}


void show_radioplayer()
{

gtk_widget_show(bt1);
gtk_widget_show(bt2);
gtk_widget_show(bt3);
gtk_widget_show(bt4);
gtk_widget_show(bt5);
gtk_widget_show(bt6);
gtk_widget_show(bt7);
gtk_widget_show(bt8);
gtk_widget_show(bt9);
gtk_widget_show(bt10);
gtk_widget_show(radprog);
gtk_widget_show(radplay);
gtk_widget_show(radstop);
gtk_widget_show(vt1);
gtk_widget_show(vt2);
gtk_widget_show(vt3);
gtk_widget_show(vt4);
gtk_widget_show(rlab);
gtk_widget_show(flabel);
gtk_widget_show(freq_spin);
gtk_widget_show (sta);
gtk_widget_show(rec_radio);
}


void
on_radio_save_entry_realize            (GtkWidget       *widget,
                                        gpointer         user_data)
{
save_entry=widget;
}

void reset_radio_button(int but)
{

if(but==1)
{
 gtk_widget_destroy(bt1);
  bt1 = gtk_button_new_with_label (blabels[0]);
  gtk_widget_ref (bt1);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_1", bt1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (main_fixed),bt1, 120, 32);
  gtk_widget_set_uposition (bt1, 120, 32);
  gtk_widget_set_usize (bt1, 54, 22);
  gtk_widget_show(bt1);
    gtk_signal_connect (GTK_OBJECT (bt1), "clicked",
                      GTK_SIGNAL_FUNC (on_station_1_clicked),
                      NULL);
}
else
if(but==2)
{
  gtk_widget_destroy(bt2);
  bt2 = gtk_button_new_with_label (blabels[1]);
  gtk_widget_ref (bt2);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_2", bt2,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt2, 184, 32);
  gtk_widget_set_uposition (bt2, 184, 32);
  gtk_widget_set_usize (bt2, 54, 22);
  gtk_widget_show(bt2);
 gtk_signal_connect (GTK_OBJECT (bt2), "clicked",
                      GTK_SIGNAL_FUNC (on_station_2_clicked),
                      NULL);
}
else
if(but==3)
{
  gtk_widget_destroy(bt3);
  bt3 = gtk_button_new_with_label (blabels[2]);
  gtk_widget_ref (bt3);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_3", bt3,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt3, 248, 32);
  gtk_widget_set_uposition (bt3, 248, 32);
  gtk_widget_set_usize (bt3, 54, 22);
    gtk_widget_show(bt3);
  gtk_signal_connect (GTK_OBJECT (bt3), "clicked",
                      GTK_SIGNAL_FUNC (on_station_3_clicked),
                      NULL);

}
else
if(but==4)
{
  gtk_widget_destroy(bt4);
  bt4 = gtk_button_new_with_label (blabels[3]);
  gtk_widget_ref (bt4);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_4", bt4,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt4, 312, 32);
  gtk_widget_set_uposition (bt4, 312, 32);
  gtk_widget_set_usize (bt4, 54, 22);
    gtk_widget_show(bt4);
 gtk_signal_connect (GTK_OBJECT (bt4), "clicked",
                      GTK_SIGNAL_FUNC (on_station_4_clicked),
                      NULL);
}
else
if(but==5)
{
  gtk_widget_destroy(bt5);

  bt5 = gtk_button_new_with_label (blabels[4]);
  gtk_widget_ref (bt5);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_5", bt5,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt5, 376, 32);
  gtk_widget_set_uposition (bt5, 376, 32);
  gtk_widget_set_usize (bt5, 54, 22);
    gtk_widget_show(bt5);
 gtk_signal_connect (GTK_OBJECT (bt5), "clicked",
                      GTK_SIGNAL_FUNC (on_station_5_clicked),
                      NULL);
}
else
if(but==6)
{
  gtk_widget_destroy(bt6);

  bt6 = gtk_button_new_with_label (blabels[5]);
  gtk_widget_ref (bt6);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_6", bt6,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt6, 120, 64);
  gtk_widget_set_uposition (bt6, 120, 64);
  gtk_widget_set_usize (bt6, 54, 22);
    gtk_widget_show(bt6);
  gtk_signal_connect (GTK_OBJECT (bt6), "clicked",
                      GTK_SIGNAL_FUNC (on_station_6_clicked),
                      NULL);
}
else
if(but==7)
{
  gtk_widget_destroy(bt7);

  bt7 = gtk_button_new_with_label (blabels[6]);
  gtk_widget_ref (bt7);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_7", bt7,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt7, 184, 64);
  gtk_widget_set_uposition (bt7, 184, 64);
  gtk_widget_set_usize (bt7, 54, 22);
    gtk_widget_show(bt7);
 gtk_signal_connect (GTK_OBJECT (bt7), "clicked",
                      GTK_SIGNAL_FUNC (on_station_7_clicked),
                      NULL);
}
else
if(but==8)
{
  gtk_widget_destroy(bt8);
  bt8 = gtk_button_new_with_label (blabels[7]);
  gtk_widget_ref (bt8);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_8", bt8,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt8, 248, 64);
  gtk_widget_set_uposition (bt8, 248, 64);
  gtk_widget_set_usize (bt8, 54, 22);
    gtk_widget_show(bt8);
 gtk_signal_connect (GTK_OBJECT (bt8), "clicked",
                      GTK_SIGNAL_FUNC (on_station_8_clicked),
                      NULL);
}
else
if(but==9)
{
  gtk_widget_destroy(bt9);

  bt9 = gtk_button_new_with_label (blabels[8]);
  gtk_widget_ref (bt9);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "statio_9", bt9,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt9, 312, 64);
  gtk_widget_set_uposition (bt9, 312, 64);
  gtk_widget_set_usize (bt9, 54, 22);
     gtk_widget_show(bt9);
  gtk_signal_connect (GTK_OBJECT (bt9), "clicked",
                      GTK_SIGNAL_FUNC (on_statio_9_clicked),
                      NULL);
}
else
if(but==10)
{
  gtk_widget_destroy(bt10);


  bt10 = gtk_button_new_with_label (blabels[9]);
  gtk_widget_ref (bt10);
  gtk_object_set_data_full (GTK_OBJECT (mwin), "station_10", bt10,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_fixed_put (GTK_FIXED (main_fixed), bt10, 376, 64);
  gtk_widget_set_uposition (bt10, 376, 64);
  gtk_widget_set_usize (bt10, 54, 22);

     gtk_widget_show(bt9);
  gtk_signal_connect (GTK_OBJECT (bt10), "clicked",
                      GTK_SIGNAL_FUNC (on_station_10_clicked),
                      NULL);
}

}






GtkWidget*
create_create_playlist_window (void)
{
  GtkWidget *create_playlist_window;
  GtkWidget *create_playlist_window_fixed;
  GtkWidget *create_playlist_direntry;
  GtkWidget *create_playlist_fileentry;
  GtkWidget *create_playlist_browse_button,*nb;
  GtkWidget *label15;
  GtkWidget *create_playlist_exit_button;
  GtkWidget *create_playlist_save_button;
  GtkWidget *create_playlist_cancel_button;
  GtkWidget *label16;


  create_playlist_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (create_playlist_window), "create_playlist_window", create_playlist_window);
  gtk_window_set_title (GTK_WINDOW (create_playlist_window), "SonicRainbow Save Playlist");

  create_playlist_window_fixed = gtk_fixed_new ();
  gtk_widget_ref (create_playlist_window_fixed);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_window_fixed", create_playlist_window_fixed,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_window_fixed);
  gtk_container_add (GTK_CONTAINER (create_playlist_window), create_playlist_window_fixed);
  gtk_widget_set_usize (create_playlist_window_fixed, 387, 160);

  create_playlist_direntry = gtk_entry_new ();
  gtk_widget_ref (create_playlist_direntry);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_direntry", create_playlist_direntry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_direntry);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_direntry, 16, 40);
  gtk_widget_set_uposition (create_playlist_direntry, 16, 40);
  gtk_widget_set_usize (create_playlist_direntry, 288, 24);

  create_playlist_fileentry = gtk_entry_new ();
  gtk_widget_ref (create_playlist_fileentry);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_fileentry", create_playlist_fileentry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_fileentry);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_fileentry, 16, 86);
  gtk_widget_set_uposition (create_playlist_fileentry, 16, 86);
  gtk_widget_set_usize (create_playlist_fileentry, 158, 22);
  gtk_tooltips_set_tip (tooltips, create_playlist_fileentry, "Filename to Save Playlist to", NULL);

  create_playlist_browse_button = gtk_button_new_with_label ("Browse");
  gtk_widget_ref (create_playlist_browse_button);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_browse_button", create_playlist_browse_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_browse_button);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_browse_button, 304, 40);
  gtk_widget_set_uposition (create_playlist_browse_button, 304, 40);
  gtk_widget_set_usize (create_playlist_browse_button, 49, 22);
  gtk_tooltips_set_tip (tooltips, create_playlist_browse_button, "Select Target Directory to Save Playlist in", NULL);

  nb = gtk_button_new_with_label ("Browse");
  gtk_widget_ref (nb);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "nb",nb,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (nb);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed),nb, 174, 86);
  gtk_widget_set_uposition (nb, 174, 86);
  gtk_widget_set_usize (nb, 49, 22);
  gtk_tooltips_set_tip (tooltips,nb, "Select Target Save Playlist File", NULL);


  label15 = gtk_label_new ("Playlist Directory");
  gtk_widget_ref (label15);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "label15", label15,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label15);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), label15, 16, 26);
  gtk_widget_set_uposition (label15, 16, 26);
  gtk_widget_set_usize (label15, 104, 16);

  create_playlist_exit_button = gtk_button_new_with_label ("Exit");
  gtk_widget_ref (create_playlist_exit_button);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_exit_button", create_playlist_exit_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_exit_button);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_exit_button, 24, 120);
  gtk_widget_set_uposition (create_playlist_exit_button, 24, 120);
  gtk_widget_set_usize (create_playlist_exit_button, 47, 22);
  gtk_tooltips_set_tip (tooltips, create_playlist_exit_button, "Exit Create Playlist Dialog", NULL);

  create_playlist_save_button = gtk_button_new_with_label ("Save");
  gtk_widget_ref (create_playlist_save_button);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_save_button", create_playlist_save_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (create_playlist_save_button);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_save_button, 136, 120);
  gtk_widget_set_uposition (create_playlist_save_button, 136, 120);
  gtk_widget_set_usize (create_playlist_save_button, 47, 22);
  gtk_tooltips_set_tip (tooltips, create_playlist_save_button, "Save Playlist", NULL);

  create_playlist_cancel_button = gtk_button_new_with_label ("Cancel");
  gtk_widget_ref (create_playlist_cancel_button);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "create_playlist_cancel_button", create_playlist_cancel_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), create_playlist_cancel_button, 280, 120);
  gtk_widget_set_uposition (create_playlist_cancel_button, 280, 120);
  gtk_widget_set_usize (create_playlist_cancel_button, 47, 22);
  gtk_widget_set_sensitive (create_playlist_cancel_button, FALSE);

  label16 = gtk_label_new ("Playlist Filename");
  gtk_widget_ref (label16);
  gtk_object_set_data_full (GTK_OBJECT (create_playlist_window), "label16", label16,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label16);
  gtk_fixed_put (GTK_FIXED (create_playlist_window_fixed), label16, 16, 70);
  gtk_widget_set_uposition (label16, 16, 70);
  gtk_widget_set_usize (label16, 103, 16);

  gtk_signal_connect (GTK_OBJECT (create_playlist_window_fixed), "realize",
                      GTK_SIGNAL_FUNC (on_create_playlist_window_fixed_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (create_playlist_direntry), "realize",
                      GTK_SIGNAL_FUNC (on_create_playlist_direntry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (create_playlist_fileentry), "realize",
                      GTK_SIGNAL_FUNC (on_create_playlist_fileentry_realize),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (create_playlist_browse_button), "clicked",
                      GTK_SIGNAL_FUNC (on_create_playlist_browse_button_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (nb), "clicked",
                      GTK_SIGNAL_FUNC (on_nb_clicked),
                      NULL);

  gtk_signal_connect (GTK_OBJECT (create_playlist_exit_button), "clicked",
                      GTK_SIGNAL_FUNC (on_create_playlist_exit_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (create_playlist_save_button), "clicked",
                      GTK_SIGNAL_FUNC (on_create_playlist_save_button_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (create_playlist_cancel_button), "clicked",
                      GTK_SIGNAL_FUNC (on_create_playlist_cancel_button_clicked),
                      NULL);

  gtk_object_set_data (GTK_OBJECT (create_playlist_window), "tooltips", tooltips);

  return create_playlist_window;
}


GtkWidget*
create_cddb_window (void)
{
  GtkWidget *cddb_window;
  GtkWidget *fixed5;
  GtkWidget *cddb_label;

  cddb_window = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (cddb_window), "cddb_window", cddb_window);
  gtk_window_set_title (GTK_WINDOW (cddb_window), "Sonic-Rainbow");
  gtk_window_set_position (GTK_WINDOW (cddb_window), GTK_WIN_POS_CENTER);
  gtk_window_set_modal (GTK_WINDOW (cddb_window), TRUE);

  fixed5 = gtk_fixed_new ();
  gtk_widget_ref (fixed5);
  gtk_object_set_data_full (GTK_OBJECT (cddb_window), "fixed5", fixed5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed5);
  gtk_container_add (GTK_CONTAINER (cddb_window), fixed5);

  cddb_label = gtk_label_new ("Obtaining CDDB Information");
  gtk_widget_ref (cddb_label);
  gtk_object_set_data_full (GTK_OBJECT (cddb_window), "cddb_label", cddb_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (cddb_label);
  gtk_fixed_put (GTK_FIXED (fixed5), cddb_label, 0, 0);
  gtk_widget_set_uposition (cddb_label, 0, 0);
  gtk_widget_set_usize (cddb_label, 232, 48);

  return cddb_window;
}









